=begin
------------------------------------------------------------------------
Copyright 2007, TIG (c)
Permission to use, copy, modify, and distribute this software for any 
purpose, and currently without fee, is hereby granted, provided that  
this text and the above copyright (c) notice appear in all copies.
This software is provided "as is" and without any express or implied 
warranties, including, without limitation, the implied warranties of 
merchantability and fitness for a particular purpose.
------------------------------------------------------------------------
Name        : Roof.rb
Author      : TIG
Description : A set of Roof Making Tools.
Menu Item   : Plugins > Roof... > Sub-Menus...
Usage       : See RoofHelp.mht file originally distributed with this.
Version     : 1.0	20070824	First issue.
------------------------------------------------------------------------
Several parts are inspired in part by Didier Burr's work and also 
RickW's...  ### The 3 next methods are based on RickW's ideas 
[slightly adjusted], with TIG's adjustments = ###
=end
eval %q{IyMjLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tCnJlcXVpcmUgJ3NrZXRjaHVw
LnJiJwojIyMtLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0KY2xhc3MgR2VvbTo6
VmVjdG9yM2QKIGRlZiB0b19mbGF0X2FuZ2xlIyMjCgl2ZWN0b3I9R2VvbTo6
VmVjdG9yM2QubmV3KHNlbGYueCxzZWxmLnksMCkKCWlmIHZlY3Rvci55IDwg
MAoJCXJldHVybiAyKjE4MC5kZWdyZWVzLXZlY3Rvci5hbmdsZV9iZXR3ZWVu
KEdlb206OlZlY3RvcjNkLm5ldygxLDAsMCkpIAoJZWxzaWYgdmVjdG9yLnkg
PiAwCgkJcmV0dXJuIHZlY3Rvci5hbmdsZV9iZXR3ZWVuKEdlb206OlZlY3Rv
cjNkLm5ldygxLDAsMCkpCgllbHNpZiB2ZWN0b3IueSA9PSAwCgkJaWYgdmVj
dG9yLnNhbWVkaXJlY3Rpb24/KEdlb206OlZlY3RvcjNkLm5ldygxLDAsMCkp
CgkJCXJldHVybiAwCgkJZWxzZQoJCQlyZXR1cm4gMTgwLmRlZ3JlZXMKCQll
bmQjaWYKCWVuZCNpZgogZW5kI2RlZgplbmQjY2xhc3MKIyMjLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tCmNsYXNzIEdlb206OlBvaW50M2QKCWRlZiBpc19v
bl9mYWNlPyhmYWNlLGJvdW5kcykjIyMKCQlyZXR1cm4gbmlsIGlmIGZhY2Uu
dHlwZW5hbWUhPSJGYWNlIiMjIwoJCW9yaWdpbj1mYWNlLnZlcnRpY2VzWzBd
LnBvc2l0aW9uCgkJeCx5LHo9ZmFjZS5ub3JtYWwuYXhlcwoJCSh0PUdlb206
OlRyYW5zZm9ybWF0aW9uLmF4ZXMob3JpZ2luLHgseSx6KSkuaW52ZXJ0IQoJ
CXB0PXNlbGYuY2xvbmUudHJhbnNmb3JtKHQpCiAgICBwb2ludHM9ZmFjZS5v
dXRlcl9sb29wLnZlcnRpY2VzLmNvbGxlY3R7fHZ8KHYucG9zaXRpb24udHJh
bnNmb3JtKHQpKS50b19hfSMjIwoJCXJldHVybiB0cnVlIGlmIEdlb20ucG9p
bnRfaW5fcG9seWdvbl8yRChwdCxwb2ludHMsYm91bmRzKSAmJiBwdC56PT0w
CgkJcmV0dXJuIGZhbHNlCgllbmQjZGVmCmVuZCNjbGFzcwojIyMtLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0KY2xhc3MgU2tldGNodXA6OkZhY2UKIGRlZiBv
ZmZzZXRfZWF2ZXMoZGlzdCkjIyMKCQlpZiAobm90ICgoZGlzdC5jbGFzcz09
Rml4bnVtIHx8IGRpc3QuY2xhc3M9PUZsb2F0IHx8IGRpc3QuY2xhc3M9PUxl
bmd0aCkgJiYgZGlzdCE9MCkpCgkJCXJldHVybiBuaWwKCQllbmQKICAgIHZl
cnRzPXNlbGYub3V0ZXJfbG9vcC52ZXJ0aWNlcwoJCXB0cz1bXQoJCTAudXB0
byh2ZXJ0cy5sZW5ndGgtMSkgZG8gfGF8CgkJCXZlY3RvcjE9KHZlcnRzW2Fd
LnBvc2l0aW9uLXZlcnRzW2EtKHZlcnRzLmxlbmd0aC0xKV0ucG9zaXRpb24p
Lm5vcm1hbGl6ZQoJCQl2ZWN0b3IyPSh2ZXJ0c1thXS5wb3NpdGlvbi12ZXJ0
c1thLTFdLnBvc2l0aW9uKS5ub3JtYWxpemUKCQkJdmVjdG9yMz0odmVjdG9y
MSt2ZWN0b3IyKS5ub3JtYWxpemUKCQkJaWYgdmVjdG9yMy52YWxpZD8KICAg
ICAgICBhbmc9dmVjdG9yMS5hbmdsZV9iZXR3ZWVuKHZlY3RvcjIpLzIKCQkJ
CWFuZz05MC5kZWdyZWVzIGlmIHZlY3RvcjEucGFyYWxsZWw/KHZlY3RvcjIp
ICMjI3BpaS8yIGlmIHZlY3RvcjEucGFyYWxsZWw/KHZlY3RvcjIpCgkJCQl2
ZWN0b3IzLmxlbmd0aD1kaXN0L01hdGg6OnNpbihhbmcpCgkJCQl0PUdlb206
OlRyYW5zZm9ybWF0aW9uLm5ldyh2ZWN0b3IzKQoJCQkJaWYgcHRzLmxlbmd0
aCA+IDAKCQkJCQlpZiBub3QgKHZlY3RvcjIucGFyYWxsZWw/KHB0cy5sYXN0
LnZlY3Rvcl90byh2ZXJ0c1thXS5wb3NpdGlvbi50cmFuc2Zvcm0odCkpKSkK
CQkJCQkJdD1HZW9tOjpUcmFuc2Zvcm1hdGlvbi5uZXcodmVjdG9yMy5yZXZl
cnNlKQoJCQkJCWVuZAoJCQkJZW5kCiAgICAgICAgcHQ9dmVydHNbYV0ucG9z
aXRpb24udHJhbnNmb3JtKHQpIyMjCgkJCQlpZiBwdC5pc19vbl9mYWNlPyhz
ZWxmLHRydWUpICMjIwogICAgICAgICAgdD1HZW9tOjpUcmFuc2Zvcm1hdGlv
bi5uZXcodmVjdG9yMy5yZXZlcnNlKWlmIGRpc3Q+MCMjIwogICAgICAgICAg
dD1HZW9tOjpUcmFuc2Zvcm1hdGlvbi5uZXcodmVjdG9yMylpZiBkaXN0PDAj
IyMKICAgICAgICAgIHB0PXZlcnRzW2FdLnBvc2l0aW9uLnRyYW5zZm9ybSh0
KSMjIwogICAgICAgIGVuZCNpZgogICAgICAgIHB0cy5wdXNoKHB0KSMjIwoJ
CQllbmQKCQllbmQKCQlyZXR1cm4gc2VsZi5wYXJlbnQuZW50aXRpZXMuYWRk
X2ZhY2UocHRzKSMjIz1mYWNlCiBlbmQjZGVmCmVuZCNjbGFzcwojIyMtLS0g
ZW5kIG9mIFJpY2tXIGluc3BpcmVkIHN0dWZmICMjIy0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0KIyMjCiMjIwpjbGFzcyBSb29mIyMjIyMj
IyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMj
IyMjIyMjIyMjIyMKIGRlZiBSb29mOjpvcmRlcmVkX2VkZ2VfcG9pbnRzKGZh
Y2UpCiAgIyMjIGEgYml0IFJpY2tXIGluc3BpcmVkID8KICByZXR1cm4gbmls
IGlmICEgZmFjZQogIGZhY2Uub3V0ZXJfbG9vcC5lZGdlcy5lYWNoe3xlZGdl
fAogICAgZmFjZS5wYXJlbnQuZW50aXRpZXMuYWRkX2xpbmUoZWRnZS5lbmQu
cG9zaXRpb24sZWRnZS5zdGFydC5wb3NpdGlvbikgaWYgZWRnZS5yZXZlcnNl
ZF9pbj8oZmFjZSkKICB9CiAgZWRnZXM9ZmFjZS5vdXRlcl9sb29wLmVkZ2Vz
CiAgZWRnZT1lZGdlc1swXTsgdmVydD1lZGdlLnN0YXJ0OyBwb2ludD12ZXJ0
LnBvc2l0aW9uLnRvX2EKICB2ZXJ0cz1mYWNlLm91dGVyX2xvb3AudmVydGlj
ZXMKICBwb2ludHM9W107IHZlcnRzLmVhY2h7fHZ8cG9pbnRzLnB1c2godi5w
b3NpdGlvbi50b19hKX0KICBwb2ludHMuY29tcGFjdCEKICBzcG9pbnRzPVtd
O3BvaW50PXBvaW50c1swXTtzZWRnZXM9ZWRnZXMKICBwb2ludHMuZWFjaHt8
cHwKICAgIGZvdW5kX2VkZ2U9ZmFsc2UKICAgIGlmIHA9PXBvaW50CiAgICAg
IHNlZGdlcy5lYWNoe3xlfAogICAgICAgIHB0cz1lLnN0YXJ0LnBvc2l0aW9u
LnRvX2E7cHRlPWUuZW5kLnBvc2l0aW9uLnRvX2EKICAgICAgICBpZiBwPT1w
dHMgYW5kIG5vdCBmb3VuZF9lZGdlCiAgICAgICAgICBmb3VuZF9lZGdlPXRy
dWU7c3BvaW50cy5wdXNoKHB0ZSk7cG9pbnQ9cHRlCiAgICAgICAgICBzZWRn
ZXM9c2VkZ2VzLVtlXQogICAgICAgIGVsc2lmIHA9PXB0ZSBhbmQgbm90IGZv
dW5kX2VkZ2UKICAgICAgICAgIGZvdW5kX2VkZ2U9dHJ1ZTtzcG9pbnRzLnB1
c2gocHRzKTtwb2ludD1wdHMKICAgICAgICAgIHNlZGdlcz1zZWRnZXMtW2Vd
CiAgICAgICAgZW5kI2lmCiAgICAgIH0KICAgIGVuZCNpZgogIH0KICAjIyMg
ZW5zdXJlIGMvY2xvY2t3aXNlCiAgcHQwPXNwb2ludHNbMF07IHB0MT1zcG9p
bnRzWzFdCiAgcHQwPUdlb206OlBvaW50M2QubmV3KHB0MFswXSxwdDBbMV0s
cHQwWzJdKSAKICBwdDE9R2VvbTo6UG9pbnQzZC5uZXcocHQxWzBdLHB0MVsx
XSxwdDFbMl0pIAogIHZlY3Rvcj1wdDAudmVjdG9yX3RvKHB0MSk7IHB0Mj1w
dDAub2Zmc2V0KHZlY3RvciwwLjEubW0pCiAgcm90YXRlPUdlb206OlRyYW5z
Zm9ybWF0aW9uLnJvdGF0aW9uKHB0MCxbMCwwLDFdLDAuMDEuZGVncmVlcykK
ICBwdDI9cHQyLnRyYW5zZm9ybSEocm90YXRlKQogIHNwb2ludHMucmV2ZXJz
ZSEgaWYgbm90IHB0Mi5pc19vbl9mYWNlPyhmYWNlLHRydWUpCiAgcmV0dXJu
IHNwb2ludHMKIGVuZCNkZWYKIyMjLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
CgoKZGVmIFJvb2Y6OmhpcCgpCiAgIyMjIHZlcnNpb24gZXJyb3IgIyMjLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LQogIGlmIFNrZXRjaHVwLnZlcnNpb24uc3BsaXQoIi4iKVswXS50b19pPDUK
ICAgICBVSS5tZXNzYWdlYm94KCJTb3JyeSBidXQgJ0hpcHBlZCBSb29mJyBv
bmx5IHdvcmtzIHdpdGggVmVyc2lvbiA1IGFuZCBvdmVyLi4uIikKICAgICBy
ZXR1cm4gbmlsCiAgZW5kI2lmCiAgIyMjIGNoZWNrIGZhY2UgLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LQogIEBtb2RlbD1Ta2V0Y2h1cC5hY3RpdmVfbW9kZWwKICBzcz1AbW9kZWwu
c2VsZWN0aW9uCiAgZmFjZXM9W10KICBzcy5lYWNoe3xlfGZhY2VzLnB1c2go
ZSlpZiBlLnR5cGVuYW1lPT0iRmFjZSJ9CiAgaWYgc3MuZW1wdHk/IHx8IGZh
Y2VzLmVtcHR5PwogICAgVUkubWVzc2FnZWJveCgiSGlwcGVkIFJvb2Y6XG5c
bllvdSBtdXN0IHNlbGVjdCBvbmUgaG9yaXpvbnRhbCBGQUNFICEiKQogICAg
cmV0dXJuIG5pbAogIGVuZCNpZgogIGlmIGZhY2VzWzFdCiAgICBVSS5tZXNz
YWdlYm94KCJIaXBwZWQgUm9vZjpcblxuWW91IG11c3Qgc2VsZWN0IE9ORSBo
b3Jpem9udGFsIGZhY2UgISIpCiAgICByZXR1cm4gbmlsCiAgZW5kI2lmCiAg
b2ZhY2U9ZmFjZXNbMF0jIyMgc3RhcnRpbmcgZmFjZQogIGlmIG9mYWNlLm5v
cm1hbC5ub3JtYWxpemUhLnouYWJzICE9MS4wCiAgICBVSS5tZXNzYWdlYm94
KCJIaXBwZWQgUm9vZjpcblxuWW91IG11c3Qgc2VsZWN0IG9uZSBIT1JJWk9O
VEFMIGZhY2UgISIpCiAgICByZXR1cm4gbmlsCiAgZW5kI2lmCmRlZiBkaWFs
b2dfaGlwICgpCiMjIyBoaXAgZGlhbG9nICMjIy0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0KQHBp
dGNoPSIxOjIiIGlmICEgQHBpdGNoICYmIEBtb2RlbC5vcHRpb25zWyJVbml0
c09wdGlvbnMiXVsiTGVuZ3RoVW5pdCJdPDIKQHBpdGNoPSIzMCIgaWYgISBA
cGl0Y2ggJiYgQG1vZGVsLm9wdGlvbnNbIlVuaXRzT3B0aW9ucyJdWyJMZW5n
dGhVbml0Il0+MQpAZmFzY2lhPTguaW5jaCBpZiAhIEBmYXNjaWEgJiYgQG1v
ZGVsLm9wdGlvbnNbIlVuaXRzT3B0aW9ucyJdWyJMZW5ndGhVbml0Il08MgpA
ZmFzY2lhPTIwMC5tbSBpZiAhIEBmYXNjaWEgJiYgQG1vZGVsLm9wdGlvbnNb
IlVuaXRzT3B0aW9ucyJdWyJMZW5ndGhVbml0Il0+MQpAZWF2ZXM9MTYuaW5j
aCBpZiAhIEBlYXZlcyAmJiBAbW9kZWwub3B0aW9uc1siVW5pdHNPcHRpb25z
Il1bIkxlbmd0aFVuaXQiXTwyCkBlYXZlcz00MDAubW0gaWYgISBAZWF2ZXMg
JiYgQG1vZGVsLm9wdGlvbnNbIlVuaXRzT3B0aW9ucyJdWyJMZW5ndGhVbml0
Il0+MQpAb3RoZXI9Ik5vIiBpZiAhIEBvdGhlcgp1bml0cz0iaW5jaGVzIiBp
ZiBAbW9kZWwub3B0aW9uc1siVW5pdHNPcHRpb25zIl1bIkxlbmd0aFVuaXQi
XT09MAp1bml0cz0iZmVldCIgaWYgQG1vZGVsLm9wdGlvbnNbIlVuaXRzT3B0
aW9ucyJdWyJMZW5ndGhVbml0Il09PTEKdW5pdHM9Im1tIiBpZiBAbW9kZWwu
b3B0aW9uc1siVW5pdHNPcHRpb25zIl1bIkxlbmd0aFVuaXQiXT09Mgp1bml0
cz0iY20iIGlmIEBtb2RlbC5vcHRpb25zWyJVbml0c09wdGlvbnMiXVsiTGVu
Z3RoVW5pdCJdPT0zCnVuaXRzPSJtIiBpZiBAbW9kZWwub3B0aW9uc1siVW5p
dHNPcHRpb25zIl1bIkxlbmd0aFVuaXQiXT09NAplbnVtcz1bIiIsIiIsIiIs
Illlc3xObyJdCnByb21wdHM9WyJTbG9wZSAoRGVncmVlcyBPUiBBOkIpOiAg
IiwiT3ZlcmFsbCBFYXZlcyBGYXNjaWEgSGVpZ2h0ICgje3VuaXRzfSk6ICAi
LCJPdmVyYWxsIEVhdmVzIFNvZmZpdCBPdmVyaGFuZyAoI3t1bml0c30pOiAg
IiwiU2V0IExheWVyICsgTWF0ZXJpYWxzID8gOiJdCnZhbHVlcz1bQHBpdGNo
LEBmYXNjaWEsQGVhdmVzLEBvdGhlcl0KQHJlc3VsdHM9KGlucHV0Ym94IHBy
b21wdHMsdmFsdWVzLGVudW1zLCJIaXBwZWQgUm9vZiBTZXR0aW5ncyIpCnJl
dHVybiBuaWwgaWYgISBAcmVzdWx0cwpibGFuaz1mYWxzZSMjIwpAcmVzdWx0
cy5lYWNoe3xlfGJsYW5rPXRydWUgaWYgZS50b19zPT0iIn0KaWYgYmxhbmsK
ICBVSS5tZXNzYWdlYm94KCJIaXBwZWQgUm9vZjpcblxuWW91IGNhbm5vdCBo
YXZlIGJsYW5rIGVudHJpZXMuXG5SZXRyeS4uLiIpCiAgZGlhbG9nX2hpcApl
bmQjaWYjIyMKKEBwaXRjaF9zLEBmYXNjaWFfLEBlYXZlc18sQG90aGVyXyk9
QHJlc3VsdHMKQHBpdGNoPUBwaXRjaF9zO0BmYXNjaWE9QGZhc2NpYV87QGVh
dmVzPUBlYXZlc187QG90aGVyPUBvdGhlcl8KIyMjIGdldCBhbmdsZSBvZiBy
b29mIGluIHJhZGlhbnMKcmF0aW89QHBpdGNoX3Muc3BsaXQoIjoiKS50b19m
CmlmIHJhdGlvWzFdCiAgdGFuPXJhdGlvWzBdL3JhdGlvWzFdCiAgQHBpdGNo
X2Q9KE1hdGg6OmF0YW4odGFuKSkucmFkaWFucwplbHNlCiAgQHBpdGNoX2Q9
cmF0aW9bMF0KZW5kI2lmCkBwaXRjaF9yPUBwaXRjaF9kLmRlZ3JlZXMgICMj
IyB0byByYWRpYW5zICMjIy0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLQppZiBA
cGl0Y2hfZDwxCiAgVUkubWVzc2FnZWJveCgiSGlwcGVkIFJvb2Y6XG5cblBp
dGNoIGNhbid0IGJlIGxlc3MgdGhhbiAxIGRlZ3JlZS4iKQogIEBwaXRjaD0i
MSI7QHBpdGNoX3M9IjEiO0BwaXRjaF9kPTE7QHBpdGNoX3I9MS5kZWdyZWVz
CiAgZGlhbG9nX2hpcAplbmQjaWYKaWYgQHBpdGNoX2Q+ODkKICBVSS5tZXNz
YWdlYm94KCJIaXBwZWQgUm9vZjpcblxuUGl0Y2ggY2FuJ3QgYmUgbW9yZSB0
aGFuIDg5IGRlZ3JlZXMuIikKICBAcGl0Y2g9Ijg5IjtAcGl0Y2hfcz0iODki
O0BwaXRjaF9kPTg5O0BwaXRjaF9yPTg5LmRlZ3JlZXMKICBkaWFsb2dfaGlw
CmVuZCNpZgppZiBAZWF2ZXNfIDwwCiAgVUkubWVzc2FnZWJveCgiSGlwcGVk
IFJvb2Y6XG5cbkVhdmVzIGNhbid0IGJlIExFU1MgVEhBTiBaRVJPLlxuUmVz
ZXR0aW5nIGl0IHRvIFpFUk8uLi5cblxuRm9yIGEgJ3BhcmFwZXQtZWF2ZXMn
IGZpcnN0IHVzZSAnT2Zmc2V0JyBvbiB0aGUgZmFjZSB0byBpbnNldCBpdHMg
ZWRnZXMgLi4uIikKICBAZWF2ZXM9MC50b19sO0BlYXZlc189MC50b19sCiAg
ZGlhbG9nX2hpcAplbmQjaWYKIyMjCmVuZCNkZWYKIyMjIHJ1biBoaXAgZGlh
bG9nCiAgZGlhbG9nX2hpcCgpCiAgcmV0dXJuIG5pbCBpZiAhIEByZXN1bHRz
CiMjIwpkZWYgZGlhbG9nX21hdHMgKCkKIyMjIG1hdGVyaWFscyBkaWFsb2cg
IyMjLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tCiAgbW9kZWw9U2tldGNodXAuYWN0aXZlX21vZGVsCiAgIyMjIGxh
eWVycy4uLgogIG1sYXllcnM9bW9kZWwubGF5ZXJzCiAgYWxheWVyPW1vZGVs
LmFjdGl2ZV9sYXllcgogIG1vZGVsLmFjdGl2ZV9sYXllcj1uaWwKICBkZWZs
YXllcj1tb2RlbC5hY3RpdmVfbGF5ZXIubmFtZQogIG1vZGVsLmFjdGl2ZV9s
YXllcj1hbGF5ZXIKICBybGF5ZXI9Ii1ST09GIiMjIyBlZGl0IHRoaXMgdG8g
c3VpdCB5b3VyIGRlc2lyZWQgZGVmYXVsdCByb29mIGxheWVyLgogIGxheWVy
cz1bXQogIG1sYXllcnMuZWFjaHt8bGF5ZXJ8bGF5ZXJzLnB1c2gobGF5ZXIu
bmFtZSlpZiBsYXllci5uYW1lIT1kZWZsYXllcn0KICBsYXllcnM9W3JsYXll
cixkZWZsYXllcl0rbGF5ZXJzLnNvcnQhCiAgbGF5ZXJzPWxheWVycy51bmlx
LmpvaW4oJ3wnKQogICMjIyBtYXRlcmlhbHMuLi4KICBtYXRfcm9vZj0iUm9v
ZiBTdXJmYWNlIgogIG1hdF9mYXNjaWE9IlJvb2YgRmFzY2lhIgogIG1hdF9z
b2ZmaXQ9IlJvb2YgU29mZml0IgogIG1hdGVyaWFscz1tb2RlbC5tYXRlcmlh
bHMKICBtYXRzPVtdCiAgbWF0ZXJpYWxzLmVhY2h7fG1hdHxtYXRzLnB1c2go
bWF0Lm5hbWUpfQogIG1hdHMuc29ydCEKICBsaXN0X21hdF9yb29mPSgoWyI8
RGVmYXVsdD4iXStbbWF0X3Jvb2ZdK21hdHMpLnVuaXEpLmpvaW4oInwiKQog
IGxpc3RfbWF0X2Zhc2NpYT0oKFsiPERlZmF1bHQ+Il0rW21hdF9mYXNjaWFd
K21hdHMpLnVuaXEpLmpvaW4oInwiKQogIGxpc3RfbWF0X3NvZmZpdD0oKFsi
PERlZmF1bHQ+Il0rW21hdF9zb2ZmaXRdK21hdHMpLnVuaXEpLmpvaW4oInwi
KQogICMjIyBzZXQgdXAgdmFyaWFibGVzLi4uCiAgQGxheWVyPXJsYXllciBp
ZiAhIEBsYXllcgogIEBtYXRfcm9vZj1tYXRfcm9vZiBpZiAhIEBtYXRfcm9v
ZgogIEBtYXRfZmFzY2lhPW1hdF9mYXNjaWEgaWYgISBAbWF0X2Zhc2NpYQog
IEBtYXRfc29mZml0PW1hdF9zb2ZmaXQgaWYgISBAbWF0X3NvZmZpdAogIGVu
dW1zPVtsYXllcnMsbGlzdF9tYXRfcm9vZixsaXN0X21hdF9mYXNjaWEsbGlz
dF9tYXRfc29mZml0XQogIHByb21wdHM9WyJSb29mIExheWVyOiAgIiwiUm9v
ZiBTdXJmYWNlOiAgIiwiUm9vZiBGYXNjaWE6ICAiLCJSb29mIFNvZmZpdDog
Il0KICB2YWx1ZXM9W0BsYXllcixAbWF0X3Jvb2YsQG1hdF9mYXNjaWEsQG1h
dF9zb2ZmaXRdCiAgQG90aGVyX3Jlc3VsdHM9KGlucHV0Ym94IHByb21wdHMs
dmFsdWVzLGVudW1zLCJSb29mIExheWVyIGFuZCBNYXRlcmlhbHMiKQogIEBs
YXllcixAbWF0X3Jvb2YsQG1hdF9mYXNjaWEsQG1hdF9zb2ZmaXQ9QG90aGVy
X3Jlc3VsdHMgaWYgQG90aGVyX3Jlc3VsdHMKICBAb3RoZXI9Ik5vIiBpZiAh
IEBvdGhlcl9yZXN1bHRzCiAgIyMjCmVuZCNkZWYKIyMjIHJ1biBtYXRlcmlh
bCBkaWFsb2cKICBkaWFsb2dfbWF0cygpIGlmIEBvdGhlcj09IlllcyIKIyMj
IAojIyMgZG8gaGlwcGVkIHJvb2YgIyMjLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0KQG1vZGVsLnN0YXJ0X29w
ZXJhdGlvbigiSGlwcGVkIFJvb2YiKQplbnRpdGllcz1AbW9kZWwuYWN0aXZl
X2VudGl0aWVzCm9lZGdlcz1vZmFjZS5vdXRlcl9sb29wLmVkZ2VzCm92ZXJ0
cz1vZmFjZS5vdXRlcl9sb29wLnZlcnRpY2VzCmNvdW50PW92ZXJ0cy5sZW5n
dGgjIyMgdXNlZCBmb3IgJSBldGMgbGF0ZXIuLi4Kb3BvaW50cz1bXTtvdmVy
dHMuZWFjaHt8ZXxvcG9pbnRzLnB1c2goZS5wb3NpdGlvbi50b19hKX0KIyMj
IHNldCB1cCByb29mIGdyb3VwIGV0YyAjIyMtLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tCnJvb2ZfZ3JvdXA9ZW50aXRpZXMu
YWRkX2dyb3VwCnJvb2ZfZW50aXRpZXM9cm9vZl9ncm91cC5lbnRpdGllcwpp
ZmFjZT1yb29mX2VudGl0aWVzLmFkZF9mYWNlKG9wb2ludHMpCmlmIEBlYXZl
cz09MAogIGZhY2U9aWZhY2UKZWxzZQogIGZhY2U9aWZhY2Uub2Zmc2V0X2Vh
dmVzKEBlYXZlcykKICBmYWNlPWlmYWNlIGlmIG5vdCBmYWNlCmVuZCNpZgoj
IyMgdHJhcCBmb3IgZm9sbG93bWUgYnVnc3BsYXQgaWYgZmFjZSBoYXMgY29y
bmVyIGF0IG9yaWdpbiAjIyMtLS0tLS0tLS0Kb3JpZ2luPWZhbHNlCmlmIHJv
b2ZfZ3JvdXAuYm91bmRzLm1pbi56PT0wCiAgb3JpZ2luPXRydWUKICBvcnB0
PXJvb2ZfZ3JvdXAuYm91bmRzLm1pbgogIHB0MD1HZW9tOjpQb2ludDNkLm5l
dygwLDAsMSsoQGZhc2NpYV8qQGZhc2NpYV8pKQogIHRyMD1HZW9tOjpUcmFu
c2Zvcm1hdGlvbi5uZXcocHQwKQogIHJvb2ZfZ3JvdXAubW92ZSEodHIwKQpl
bmQjaWYKIyMjIC0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tCiMjIyBjb250aW51
ZSB3aXRoIHJvb2YgZ3JvdXAgc2V0IHVwICMjIy0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLQplZWRnZXM9ZmFjZS5vdXRlcl9sb29wLmVkZ2Vz
CmV2ZXJ0cz1mYWNlLm91dGVyX2xvb3AudmVydGljZXMjIyMKZXBvaW50cz1b
XTtldmVydHMuZWFjaHt8ZXxlcG9pbnRzLnB1c2goZS5wb3NpdGlvbi50b19h
KX0KIyMjIG1ha2UgYSBjb3B5IGZvciB0aGUgc29mZml0IGZvciB1c2UgbGF0
ZXIuLi4Kc29mZml0X2dyb3VwPXJvb2ZfZ3JvdXAuY29weQpzb2ZmaXRfZ3Jv
dXAubWFrZV91bmlxdWUKIyMjIHJlbW92ZSBhbnkgaW5uZXIgbG9vcCBlZGdl
cyBpbiByb29mIGdyb3VwLi4uCmVkZ2VzX2luPVtdO2VkZ2VzX291dD1bXQpy
b29mX2VudGl0aWVzLmVhY2h7fGV8CiAgaWYgZS50eXBlbmFtZT09IkVkZ2Ui
CiAgICBpZiBlLmZhY2VzWzFdIyMjIGlubmVyIGxvb3AKICAgICAgZWRnZXNf
aW4ucHVzaChlKQogICAgZWxzZSMjIyBvdXRlciBsb29wCiAgICAgIGVkZ2Vz
X291dC5wdXNoKGUpCiAgICBlbmQjaWYKICBlbmQjaWYKfQplZGdlc19pbi5l
YWNoe3xlfGUuZXJhc2UhfSBpZiBAZWF2ZXNfID4gMAplZGdlc19vdXQuZWFj
aHt8ZXxlLmVyYXNlIX0gaWYgQGVhdmVzXyA8IDAKZmFjZT1lZGdlc19pblsw
XS5mYWNlc1swXSBpZiBlZGdlc19pblswXSAmJiBlZGdlc19pblswXS52YWxp
ZD8KZmFjZT1lZGdlc19vdXRbMF0uZmFjZXNbMF0gaWYgZWRnZXNfb3V0WzBd
ICYmIGVkZ2VzX291dFswXS52YWxpZD8KZXBvaW50cz1Sb29mLm9yZGVyZWRf
ZWRnZV9wb2ludHMoZmFjZSkKZWVkZ2VzPWZhY2Uub3V0ZXJfbG9vcC5lZGdl
cwplZWRnZXMuZWFjaHt8ZXxlLmVyYXNlISBpZiBlLnZhbGlkP30KZmFjZT1y
b29mX2VudGl0aWVzLmFkZF9mYWNlKGVwb2ludHMpCmVlZGdlcz1mYWNlLm91
dGVyX2xvb3AuZWRnZXMKZXZlcnRzPWZhY2Uub3V0ZXJfbG9vcC52ZXJ0aWNl
cwojIyMgbWFrZSBwYXRoIGFuZCBwcm9maWxlIGV0YyAjIyMtLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0KIyMjIHdvcmsgb3V0IHdo
aWNoIHZlcnRleCBnaXZlcyBsYXJnZXN0IGRpc3QgZGltICMjIy0tLS0tLS0t
LS0tLS0tLS0tLS0tCmRpbXM9WzAubW0sbmlsXSMjI2ZvciBkaXN0LGV2ZXJ0
CmRvd249MQpldmVydHMuZWFjaHt8ZXZlcnR8CiAgU2tldGNodXA6OnNldF9z
dGF0dXNfdGV4dCgiSGlwcGVkIFJvb2Y6IEZpbmRpbmcgRmFjZXMgIisoMTAw
KmRvd24vY291bnQpLnRvX2kudG9fcysiJS4gUGxlYXNlIFdhaXQuLi4iLFNC
X1BST01QVCkKICBkb3duPWRvd24rMQogIGRpc3Q9MS5tbSAjIyMgPSBtaW4g
cm9vZiBzaXplICEKICBlZGdlMW9yaWc9ZXZlcnQKICBlZGdlMm9yaWc9ZXZl
cnQKICBlZGdlMT1lZGdlMW9yaWcuZWRnZXNbMF0KICBlZGdlMj1lZGdlMm9y
aWcuZWRnZXNbMV0KICBlZGdlMW90aGVyPWVkZ2UxLm90aGVyX3ZlcnRleChl
ZGdlMW9yaWcpCiAgZWRnZTJvdGhlcj1lZGdlMi5vdGhlcl92ZXJ0ZXgoZWRn
ZTJvcmlnKQogIHZlY3RvcjE9ZWRnZTFvcmlnLnBvc2l0aW9uLnZlY3Rvcl90
byhlZGdlMW90aGVyLnBvc2l0aW9uKQogIHZlY3RvcjI9ZWRnZTJvcmlnLnBv
c2l0aW9uLnZlY3Rvcl90byhlZGdlMm90aGVyLnBvc2l0aW9uKQogIGFuZ2xl
MT12ZWN0b3IxLnRvX2ZsYXRfYW5nbGUKICBhbmdsZTI9dmVjdG9yMi50b19m
bGF0X2FuZ2xlCiAgYW5nbGVfYmV0d2Vlbj1hbmdsZTEtYW5nbGUyCiAgYW5n
bGU9YW5nbGVfYmV0d2Vlbi8yCiAgcHQxPWV2ZXJ0LnBvc2l0aW9uCiAgcHQy
PXB0MS5vZmZzZXQodmVjdG9yMiwxLm1tKQogIHJvdGF0ZT1HZW9tOjpUcmFu
c2Zvcm1hdGlvbi5yb3RhdGlvbihwdDEsWzAsMCwxXSxhbmdsZSkKICBwdDI9
cHQyLnRyYW5zZm9ybSEocm90YXRlKQogICMjIyBzb3J0IHdoaWNoIGFuZ2xl
IGdpdmVzIGEgcG9pbnQgb24gdGhlIGZhY2UgIyMjCiAgaWYgYW5nbGUgPiAw
CiAgICBhbmdsZT1hbmdsZSsxODAuZGVncmVlcyBpZiBub3QgcHQyLmlzX29u
X2ZhY2U/KGZhY2UsdHJ1ZSkKICBlbHNlCiAgICBhbmdsZT1hbmdsZS0xODAu
ZGVncmVlcyBpZiBub3QgcHQyLmlzX29uX2ZhY2U/KGZhY2UsdHJ1ZSkKICBl
bmQjaWYKICAjIyMgZmluZCBiaWdnZXN0IG9uZQogIG9uX2ZhY2U9dHJ1ZQog
IHdoaWxlIG9uX2ZhY2UKICAgIHB0Mj1wdDEub2Zmc2V0KHZlY3RvcjIsZGlz
dCkKICAgIHJvdGF0ZT1HZW9tOjpUcmFuc2Zvcm1hdGlvbi5yb3RhdGlvbihw
dDEsWzAsMCwxXSxhbmdsZSkKICAgIHB0Mj1wdDIudHJhbnNmb3JtIShyb3Rh
dGUpCiAgICBpZiBub3QgcHQyLmlzX29uX2ZhY2U/KGZhY2UsdHJ1ZSkgIyMj
IGdvbmUgb2ZmIHRoZSBmYWNlCiAgICAgIGlmIGRpc3QgPiBkaW1zWzBdCiAg
ICAgICAgZGltcz1bZGlzdC0xMDAubW0sZXZlcnRdCiAgICAgIGVuZCNpZgog
ICAgICBvbl9mYWNlPWZhbHNlCiAgICBlbmQjaWYKICAgIGRpc3Q9ZGlzdCsx
MDAubW0jIyNpbmNyZW1lbnQgZGlzdCAxMDBtbSB0aWxsIGl0IGdvZXMgb2Zm
IGZhY2UuCiAgZW5kI3doaWxlCn0jZW5kIGV2ZXJ0cy5lYWNoCiMjIyBsYXJn
ZXN0IGRpc3QgIyMjLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLQpkaXN0PShkaW1zWzBdLzEuMDEpLmFicyMu
MTU3MDA1NCMjIyBuZXZlciA+IChzcXJ0MyAtICgxL3NxcnQzKSkgPyAjIyMK
ZXZlcnQ9ZGltc1sxXQogIGVkZ2Uxb3JpZz1ldmVydAogIGVkZ2Uyb3JpZz1l
dmVydAogIGVkZ2UxPWVkZ2Uxb3JpZy5lZGdlc1swXQogIGVkZ2UyPWVkZ2Uy
b3JpZy5lZGdlc1sxXQogIGVkZ2Uxb3RoZXI9ZWRnZTEub3RoZXJfdmVydGV4
KGVkZ2Uxb3JpZykKICBlZGdlMm90aGVyPWVkZ2UyLm90aGVyX3ZlcnRleChl
ZGdlMm9yaWcpCiAgdmVjdG9yMT1lZGdlMW9yaWcucG9zaXRpb24udmVjdG9y
X3RvKGVkZ2Uxb3RoZXIucG9zaXRpb24pCiAgdmVjdG9yMj1lZGdlMm9yaWcu
cG9zaXRpb24udmVjdG9yX3RvKGVkZ2Uyb3RoZXIucG9zaXRpb24pCiAgYW5n
bGUxPXZlY3RvcjEudG9fZmxhdF9hbmdsZQogIGFuZ2xlMj12ZWN0b3IyLnRv
X2ZsYXRfYW5nbGUKICBhbmdsZV9iZXR3ZWVuPWFuZ2xlMS1hbmdsZTIKICBh
bmdsZT1hbmdsZV9iZXR3ZWVuLzIKICBwdDE9ZXZlcnQucG9zaXRpb24KICBw
dDI9cHQxLm9mZnNldCh2ZWN0b3IyLDEubW0pCiAgcm90YXRlPUdlb206OlRy
YW5zZm9ybWF0aW9uLnJvdGF0aW9uKHB0MSxbMCwwLDFdLGFuZ2xlKQogIHB0
Mj1wdDIudHJhbnNmb3JtIShyb3RhdGUpCiAgIyMjIHNvcnQgd2hpY2ggYW5n
bGUgZ2l2ZXMgYSBwb2ludCBvbiB0aGUgZmFjZSAjIyMKICBpZiBhbmdsZSA+
IDAKICAgIGFuZ2xlPWFuZ2xlKzE4MC5kZWdyZWVzIGlmIG5vdCBwdDIuaXNf
b25fZmFjZT8oZmFjZSx0cnVlKQogIGVsc2UKICAgIGFuZ2xlPWFuZ2xlLTE4
MC5kZWdyZWVzIGlmIG5vdCBwdDIuaXNfb25fZmFjZT8oZmFjZSx0cnVlKQog
IGVuZCNpZgogIHB0Mj1wdDEub2Zmc2V0KHZlY3RvcjIsZGlzdCkKICByb3Rh
dGU9R2VvbTo6VHJhbnNmb3JtYXRpb24ucm90YXRpb24ocHQxLFswLDAsMV0s
YW5nbGUpCiAgcHQyPXB0Mi50cmFuc2Zvcm0hKHJvdGF0ZSkKIyMjIHNvcnQg
b3V0IHRyYW5zZm9ybWF0aW9uICMjIy0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tCnB0MT1HZW9tOjpQb2ludDNkLm5ldyhwdDEp
LnRyYW5zZm9ybShyb29mX2dyb3VwLnRyYW5zZm9ybWF0aW9uKWlmIG5vdCBv
cmlnaW4KcHQyPUdlb206OlBvaW50M2QubmV3KHB0MikudHJhbnNmb3JtKHJv
b2ZfZ3JvdXAudHJhbnNmb3JtYXRpb24paWYgbm90IG9yaWdpbgojIyMgbmVl
ZCB0byBhZGp1c3Qgb3BwIGZvciBiZWluZyBvbiBkaWFnb25hbCAoc2luKQpm
YW5nbGU9YW5nbGUuYWJzCmlmIGZhbmdsZSA+MAogd2hpbGUgZmFuZ2xlID4g
MTgwLmRlZ3JlZXMKICBmYW5nbGU9ZmFuZ2xlLTE4MC5kZWdyZWVzCiBlbmQj
d2hpbGUKZW5kI2lmCiMjIwojIyMgZ2V0IG9wcG9zaXRlID0gaGVpZ2h0IG9m
IHJpZGdlIGF0IGRpc3QgZnJvbSBwdDEKb3BwPShkaXN0Kk1hdGg6OnNpbihm
YW5nbGUpKk1hdGg6OnRhbihAcGl0Y2hfcikpLmFicwojIyMgbWFrZSB1cHNp
ZGUgZG93biB0cmlhbmd1bGFyIGZhY2UgZm9yIGZvbGxvd21lICMjIy0tLS0t
LS0tLS0tLS0tLS0tLS0KcHRhPXB0MQpwdGI9W3B0MS54LHB0MS55LHB0MS56
K29wcF0KcHRjPVtwdDIueCxwdDIueSxwdDIueitvcHBdCmZmYWNlPXJvb2Zf
ZW50aXRpZXMuYWRkX2ZhY2UocHRhLHB0YixwdGMpCiMjIyByZS1zb3J0IHNv
IHN0YXJ0cyBmcm9tIHB0MQppbmRleD0wCjAudXB0byhlZWRnZXMubGVuZ3Ro
LTEpIGRvIHxpfAogIGluZGV4PWkgaWYgZWVkZ2VzW2ldLmVuZC5wb3NpdGlv
bj09cHQxCmVuZCN1cHRvIGkKdGVkZ2VzPShlZWRnZXMuc2xpY2UoaW5kZXgu
Li0xKSkrKGVlZGdlcy5zbGljZSgwLi5pbmRleC0xKSkKIyMjCmZmYWNlLmZv
bGxvd21lKHRlZGdlcykjIyMgbWFrZSBtYWluIHJvb2YgZmFjZXMgIyMjLS0t
LS0tLS0tLS0tLS0tLS0tLS0tCiMjIyBUaGUgdGlkeSB1cCAjIyMtLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LQojIyMgSW50ZXJzZWN0IDoKIyMjIFRoZSBpbnRlcnNlY3Rfd2l0aCBtZXRo
b2QgaXMgdXNlZCB0byBpbnRlcnNlY3QgZW50aXRpZXMsIGEgY29tcG9uZW50
CiMjIyBpbnN0YW5jZSwgb3IgZ3JvdXAgIyMjIHdpdGggYW4gZW50aXRpZXMg
b2JqZWN0LgojIyMgICBlbnRpdGllcy5pbnRlcnNlY3Rfd2l0aChyZWN1cnNl
LHRyYW5zZm9ybWF0aW9uMSxlbnRpdGllczEsdHJhbnNmb3JtYXRpb24yLGhp
ZGRlbixlbnRpdGllczIpCiMjIyByZWN1cnNlIC0gdHJ1ZSBpZiB5b3Ugd2Fu
dCB0aGlzIGVudGl0aWVzIG9iamVjdCB0byBiZSByZWN1cnNlZCAuCiMjIyAg
IChpbnRlcnNlY3Rpb24gbGluZXMgd2lsbCBiZSBwdXQgaW5zaWRlIG9mIGdy
b3VwcyBhbmQgY29tcG9uZW50cyAKIyMjICAgIHdpdGhpbiB0aGlzIGVudGl0
aWVzIG9iamVjdCkKIyMjIHRyYW5zZm9ybWF0aW9uMSAtIHRoZSB0cmFuc2Zv
cm1hdGlvbiBmb3IgdGhpcyBlbnRpdGllcyBvYmplY3QuCiMjIyBlbnRpdGll
czEgLSB0aGUgZW50aXRpZXMgKGdyb3VwIGV0Yykgd2hlcmUgeW91IHdhbnQg
dGhlIGludGVyc2VjdGlvbgojIyMgbGluZXMgdG8gYXBwZWFyLgojIyMgdHJh
bnNmb3JtYXRpb24yIC0gdGhlIHRyYW5zZm9ybWF0aW9uIGZvciBlbnRpdGll
czEuCiMjIyBoaWRkZW4gLSB0cnVlIGlmIHlvdSB3YW50IGhpZGRlbiBnZW9t
ZXRyeSBpbiB0aGlzIGVudGl0aWVzLW9iamVjdCB0byAKIyMjIGJlIHVzZWQg
aW4gdGhlIGludGVyc2VjdGlvbi4KIyMjIGVudGl0aWVzMiAtIGFuIGVudGl0
aWVzIG9iamVjdCAob3IgYW4gYXJyYXkgb2YgZW50aXRpZXMgPykgPSAnZmFj
ZXMnLgp0b3A9KGNvdW50KmNvdW50LzgpLnRvX2k7ZG93bj0xCnRvcC50aW1l
cyBkb3x0aGlzfAogIFNrZXRjaHVwOjpzZXRfc3RhdHVzX3RleHQoIkhpcHBl
ZCBSb29mOiBGaW5kaW5nIEVkZ2VzICIrKDEwMCpkb3duL3RvcCkudG9faS50
b19zKyIlLiBQbGVhc2UgV2FpdC4uLiIsU0JfUFJPTVBUKQogIGRvd249ZG93
bisxCiAgcm9vZl9lbnRpdGllcy5lYWNoe3xlfAogICAgcnRyPVswLDAsMF0K
ICAgIHJvb2ZfZW50aXRpZXMuaW50ZXJzZWN0X3dpdGgodHJ1ZSxydHIscm9v
Zl9ncm91cCxydHIsdHJ1ZSxlKWlmIGUudHlwZW5hbWU9PSJGYWNlIgogIH0K
ZW5kI3RpbWVzCiMjIyBJdCByZXBlYXRzIHRvIGNhdGNoIGFsbCBpbnRlcnNl
Y3Rpb25zIGluIGNvbXBsZXggc2V0cy0tLS0tLS0tLS0tLS0tLQpTa2V0Y2h1
cDo6c2V0X3N0YXR1c190ZXh0KCJIaXBwZWQgUm9vZjogRmluaXNoaW5nLiIs
U0JfUFJPTVBUKQp6ej1yb29mX2dyb3VwLmJvdW5kcy5taW4ueiAjIyMgbmVl
ZGVkIGxhdGVyLi4uCnJlcD0oY291bnQqY291bnQvNCkudG9faQojIyMgcmVt
b3ZlIGZsYXQgZmFjZXMuLi4KcmVwLnRpbWVzIGRvIHx0aGlzfAogcm9vZl9l
bnRpdGllcy5lYWNoe3xlfAogIGlmIGUudHlwZW5hbWU9PSJGYWNlIiAmJiBl
ICE9IGZhY2UKICAgIGUuZXJhc2UhIGlmIGUubm9ybWFsLm5vcm1hbGl6ZSEu
eC5hYnM8MS4wZS0wMDYgJiYgZS5ub3JtYWwubm9ybWFsaXplIS55LmFiczwx
LjBlLTAwNgogIGVuZCNpZgogfQplbmQjdGhpcwpTa2V0Y2h1cDo6c2V0X3N0
YXR1c190ZXh0KCJIaXBwZWQgUm9vZjogRmluaXNoaW5nLi4iLFNCX1BST01Q
VCkKIyMjIGVyYXNlIGFsbCAidmVydGljYWwiIGVkZ2VzLi4uCnJlcC50aW1l
cyBkbyB8dGhpc3wKIHJvb2ZfZW50aXRpZXMuZWFjaHt8ZXwKICBpZiBlLnR5
cGVuYW1lPT0iRWRnZSIKICAgIGUuZXJhc2UhIGlmIGUuc3RhcnQucG9zaXRp
b24ueD09ZS5lbmQucG9zaXRpb24ueCAmJiBlLnN0YXJ0LnBvc2l0aW9uLnk9
PWUuZW5kLnBvc2l0aW9uLnkKICBlbmQjaWYKIH0KZW5kI3RoaXMKU2tldGNo
dXA6OnNldF9zdGF0dXNfdGV4dCgiSGlwcGVkIFJvb2Y6IEZpbmlzaGluZy4u
LiIsU0JfUFJPTVBUKQojIyMgZXJhc2UgZmFjZWxlc3MgZWRnZXMuLi4KcmVw
LnRpbWVzIGRvIHx0aGlzfAogcm9vZl9lbnRpdGllcy5lYWNoe3xlfAogIGlm
IGUudHlwZW5hbWU9PSJFZGdlIgogICAgZS5lcmFzZSEgaWYgISBlLmZhY2Vz
WzBdCiAgZW5kI2lmCiB9CmVuZCN0aGlzClNrZXRjaHVwOjpzZXRfc3RhdHVz
X3RleHQoIkhpcHBlZCBSb29mOiBGaW5pc2hpbmcuLi4uIixTQl9QUk9NUFQp
CiMjIyByZW1vdmUgb25lIGZhY2UgZWRnZXMgPSBvZmYgYmFzZS4uLgpyZXAu
dGltZXMgZG8gfHRoaXN8CiByb29mX2VudGl0aWVzLmVhY2h7fGV8CiAgaWYg
ZS50eXBlbmFtZT09IkVkZ2UiCiAgICBlLmVyYXNlISBpZiAhIGUuZmFjZXNb
MV0KICBlbmQjaWYKIH0KZW5kI3RoaXMKU2tldGNodXA6OnNldF9zdGF0dXNf
dGV4dCgiSGlwcGVkIFJvb2Y6IEZpbmlzaGluZy4uLi4uIixTQl9QUk9NUFQp
CiMjIyBub3cgcmV2ZXJzZSBmYWNlcyBzbyAndXAnCnJvb2ZfZW50aXRpZXMu
ZWFjaHt8ZXwKICBpZiBlLnR5cGVuYW1lPT0iRmFjZSIKICAgIGUucmV2ZXJz
ZSEgaWYgZS5ub3JtYWwubm9ybWFsaXplIS56IDwwCiAgZW5kI2lmCn0KU2tl
dGNodXA6OnNldF9zdGF0dXNfdGV4dCgiSGlwcGVkIFJvb2Y6IEZpbmlzaGlu
Zy4uLi4uLiIsU0JfUFJPTVBUKQojIyMgcmVtb3ZlIGFsbCAnZmxhdCcgZmFj
ZXMgYWdhaW4uLi4KcmVwLnRpbWVzIGRvIHx0aGlzfAogcm9vZl9lbnRpdGll
cy5lYWNoe3xlfAogIGlmIGUudHlwZW5hbWU9PSJGYWNlIgogICAgZS5lcmFz
ZSEgaWYgZS5ub3JtYWwubm9ybWFsaXplIS54LmFiczwxLjBlLTAwNiAmJiBl
Lm5vcm1hbC5ub3JtYWxpemUhLnkuYWJzPDEuMGUtMDA2CiAgZW5kI2lmCiB9
CmVuZCN0aGlzClNrZXRjaHVwOjpzZXRfc3RhdHVzX3RleHQoIkhpcHBlZCBS
b29mOiBGaW5pc2hpbmcuLi4uLi4uIixTQl9QUk9NUFQpCiMjIyB0cmFwIGFu
eSBub24tYmFzZSBub24tZmxhdCBmYWNlcy4uLgpmYWNlc19oaT1bXQpyb29m
X2VudGl0aWVzLmVhY2h7fGV8CiAgZmFjZXNfaGkucHVzaChlKSBpZiBlLnR5
cGVuYW1lPT0iRmFjZSIgJiYgZS5ib3VuZHMubWluLnogPiB6egp9CmZhY2Vz
X2hpLmVhY2h7fGZ8CiAgY29wbGFuYXI9ZmFsc2UKICBmLmVkZ2VzLmVhY2h7
fGV8CiAgICBjb3BsYW5hcj10cnVlIGlmIGUuZmFjZXNbMV0gJiYgZS5mYWNl
c1swXS5ub3JtYWw9PWUuZmFjZXNbMV0ubm9ybWFsCiAgICBjb3BsYW5hcj10
cnVlIGlmIGUuZmFjZXNbMl0gJiYgZS5mYWNlc1swXS5ub3JtYWw9PWUuZmFj
ZXNbMl0ubm9ybWFsCiAgICBjb3BsYW5hcj10cnVlIGlmIGUuZmFjZXNbMl0g
JiYgZS5mYWNlc1sxXS5ub3JtYWw9PWUuZmFjZXNbMl0ubm9ybWFsCiAgICBj
b3BsYW5hcj10cnVlIGlmIGUuZmFjZXNbM10gJiYgZS5mYWNlc1swXS5ub3Jt
YWw9PWUuZmFjZXNbM10ubm9ybWFsCiAgICBjb3BsYW5hcj10cnVlIGlmIGUu
ZmFjZXNbM10gJiYgZS5mYWNlc1sxXS5ub3JtYWw9PWUuZmFjZXNbM10ubm9y
bWFsCiAgICBjb3BsYW5hcj10cnVlIGlmIGUuZmFjZXNbM10gJiYgZS5mYWNl
c1syXS5ub3JtYWw9PWUuZmFjZXNbM10ubm9ybWFsCiAgfQogIGYuZXJhc2Uh
IGlmIGYudmFsaWQ/ICYmICEgY29wbGFuYXIKfQpmYWNlc19oaS5lYWNoe3xm
fAogIGlmIGYudmFsaWQ/CiAgICBmLmVkZ2VzLmVhY2h7fGV8CiAgICAgIGUu
ZXJhc2UhIGlmIGUudmFsaWQ/ICYmICEgZS5mYWNlc1sxXQogICAgfQogIGVu
ZCNpZgp9ClNrZXRjaHVwOjpzZXRfc3RhdHVzX3RleHQoIkhpcHBlZCBSb29m
OiBGaW5pc2hpbmcuLi4uLi4uIixTQl9QUk9NUFQpCiMjIyB0aWR5IHVwIGZh
Y2VsZXNzIGFuZCBjb3BsYW5hciBlZGdlcyBldGMuLi4KcmVwLnRpbWVzIGRv
IHx0aGlzfAogcm9vZl9lbnRpdGllcy5lYWNoe3xlfAogIGlmIGUudHlwZW5h
bWU9PSJFZGdlIgogICAgZS5lcmFzZSEgaWYgISBlLmZhY2VzWzBdIyMjIGZh
Y2VsZXNzCiAgZW5kI2lmIAogIGlmIGUudmFsaWQ/ICYmIGUudHlwZW5hbWU9
PSJFZGdlIgogICAgZS5lcmFzZSEgaWYgZS5mYWNlc1sxXSAmJiBlLmZhY2Vz
WzBdLm5vcm1hbD09ZS5mYWNlc1sxXS5ub3JtYWwjIyNjb3BsYW5hcgogIGVu
ZCNpZgogfQplbmQjdGhpcwpTa2V0Y2h1cDo6c2V0X3N0YXR1c190ZXh0KCJI
aXBwZWQgUm9vZjogRmluaXNoaW5nLi4uLi4uLi4iLFNCX1BST01QVCkKIyMj
IHJlbW92ZSBvbmUgZmFjZSBlZGdlcyB0aGF0IGFyZSBhYm92ZSBiYXNlIGFu
ZCBvbmx5IGhhdmUgb25lIGZhY2UuLi4KcmVwLnRpbWVzIGRvIHx0aGlzfAog
cm9vZl9lbnRpdGllcy5lYWNoe3xlfAogIGlmIGUudHlwZW5hbWU9PSJGYWNl
IgogICAgaWYgZS5ib3VuZHMubWluLnogPiB6egogICAgICBlZGdlcz1lLmVk
Z2VzCiAgICAgIGVkZ2VzLmVhY2h7fGVlfGVlLmVyYXNlISBpZiBlZS52YWxp
ZD8gJiYgISBlZS5mYWNlc1sxXX0KICAgIGVuZCNpZgogIGVuZCNpZgogfQpl
bmQjdGhpcwpTa2V0Y2h1cDo6c2V0X3N0YXR1c190ZXh0KCJIaXBwZWQgUm9v
ZjogRmluaXNoaW5nLi4uLi4uLi4uIixTQl9QUk9NUFQpCiMjIyBlcmFzZSBh
bnkgJ2Zsb2F0aW5nJyBiaXRzIG9mIHJvb2YgYWJvdmUgdGhlIG1haW4gYm9k
eS4uLgpyZXAudGltZXMgZG8gfHRoaXN8CiByb29mX2VudGl0aWVzLmVhY2h7
fGV8CiAgaWYgZS50eXBlbmFtZT09IkZhY2UiCiAgICBpZiBlLmJvdW5kcy5t
aW4ueiA+IHp6CiAgICAgIGVkZ2VzPWUuZWRnZXMKICAgICAgZWRnZXMuZWFj
aHt8ZWV8ZWUuZXJhc2UhIGlmIGVlLnZhbGlkP30KICAgIGVuZCNpZgogIGVu
ZCNpZgogfQplbmQjdGhpcwpTa2V0Y2h1cDo6c2V0X3N0YXR1c190ZXh0KCJI
aXBwZWQgUm9vZjogRmluaXNoZWQuIixTQl9QUk9NUFQpCiMjIyBlcmFzZSBm
YWNlbGVzcyBlZGdlcyBhZ2Fpbi4uLgpyZXAudGltZXMgZG8gfHRoaXN8CiBy
b29mX2VudGl0aWVzLmVhY2h7fGV8CiAgaWYgZS50eXBlbmFtZT09IkVkZ2Ui
CiAgICBlLmVyYXNlISBpZiAhIGUuZmFjZXNbMF0KICBlbmQjaWYKIH0KZW5k
I3RpbWVzCiMjIyBpZiBmYWlscy4uLgppZiAhIHJvb2ZfZW50aXRpZXNbMF0g
fHwgcm9vZl9lbnRpdGllcy5sZW5ndGggPD0gY291bnQqMgogIFVJLm1lc3Nh
Z2Vib3goIkhpcHBlZCBSb29mIEVycm9yOlxuXG5JdCB3YXMgbm90IHBvc3Np
YmxlIHRvIG1ha2UgYSBzaW5nbGUgcGl0Y2ggaGlwcGVkIHJvb2YgZnJvbSB0
aGlzIGZhY2UuXG5cblNvbWV0aW1lcyB0aGUgZmFjZS9lZGdlIHJlbGF0aW9u
c2hpcHMgZ2V0IG11ZGRsZWQgaW4gdGhlIG1vZGVsJ3MgZGF0YWJhc2UuXG5U
cnkgcmUtbWFraW5nIHRoZSBvcmlnaW5hbCBmYWNlOlxuLSBEZWxldGUgaXQg
YW5kIHJlZHJhdyBvdmVyIG9uZSBlZGdlIHRvIHJlbWFrZSBpdC4gIFxuT3Ig
Y29weSB0aGUgZmFjZSB0byBvbmUgc2lkZSwgZGVsZXRlIHRoZSBvcmlnaW5h
bCBhbmQgbW92ZSB0aGUgY29weSBiYWNrLiAgXG5UaGlzIG1ldGhvZHMgY2Fu
IG9mdGVuIG1ha2UgYSBmYWNlICdyb29mJy5cblxuSWYgbm90LCB0aGVuIHRy
eSBzdWItZGl2aWRpbmcgdGhlIGZhY2UgaW50byBwaWVjZXMgYW5kIGpvaW5p
bmcgdGhlaXIgcm9vZnMgbWFudWFsbHkuXG5cbk5vdGUgdGhhdCBzb21lIGZh
Y2Ugc2hhcGVzIGNhbiBuZXZlciBiZSByb29mZWQgd2l0aCBhIHNpbmdsZSBw
aXRjaC5cbmUuZy4gY3Jvb2tlZCBzdGFycy5cblxuRXhpdGluZy4uLiIpCiAg
cm9vZl9ncm91cC5lcmFzZSEgaWYgcm9vZl9ncm91cC52YWxpZD8KICBzb2Zm
aXRfZ3JvdXAuZXJhc2UhIGlmIHNvZmZpdF9ncm91cC52YWxpZD8KICAjIyMg
dGlkeSB1cCBhdCBlbmQgIyMjLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0KICBAbW9kZWwuc2VsZWN0aW9uLmNs
ZWFyCiAgQG1vZGVsLnNlbGVjdGlvbi5hZGQob2ZhY2UpIyMjIGVuZCB3aXRo
IG9yaWdpbmFsIGZhY2UgcmUtc2VsZWN0ZWQKICBAbW9kZWwuYWN0aXZlX3Zp
ZXcuaW52YWxpZGF0ZQogIEBtb2RlbC5jb21taXRfb3BlcmF0aW9uCiAgU2tl
dGNodXAuc2VuZF9hY3Rpb24ic2VsZWN0U2VsZWN0aW9uVG9vbDoiCiAgcmV0
dXJuIG5pbAplbmQjaWYKIyMjLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tCiMj
IyBjb3JyZWN0IGZvciBmYXNjaWEKcm9vZl9ncm91cC5tb3ZlIShHZW9tOjpU
cmFuc2Zvcm1hdGlvbi5uZXcoWzAsMCxAZmFzY2lhX10pKWlmIEBmYXNjaWFf
PjAKIyMjIHNvcnQgb3V0IHNvZmZpdCAjIyMtLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tCnNvZmZpdF9lbnRpdGll
cz1zb2ZmaXRfZ3JvdXAuZW50aXRpZXMKc2ZhY2U9bmlsCnNvZmZpdF9lbnRp
dGllcy5lYWNoe3xlfAogIGlmIGUudHlwZW5hbWU9PSJGYWNlIgogICAgZS5y
ZXZlcnNlISBpZiBlLm5vcm1hbC5ub3JtYWxpemUhLnogIT0tMQogICAgZS5l
cmFzZSEgaWYgISBlLmxvb3BzWzFdICYmIEBlYXZlc18hPTAjIyMgaW5uZXIg
ZmFjZSBhbmQgTk9UIGFsbAogIGVuZCNpZgp9CiMjIyBzb3J0IG91dCBlYXZl
cyAjIyMtLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLQpmYXNjaWFfZ3JvdXA9c29mZml0X2dyb3VwLmNvcHk7IGZh
c2NpYV9ncm91cC5tYWtlX3VuaXF1ZQojIyMgZmlyc3QgYWRqdXN0IHNvZmZp
dC4uLgpzb2ZmaXRfZ3JvdXAubW92ZSEoWzAsMCxAZmFzY2lhX10pIGlmIEBm
YXNjaWFfIDwgMApzb2ZmaXRfZW50aXRpZXMuZWFjaHt8ZXxlLmVyYXNlISBp
ZiBlLnR5cGVuYW1lPT0iRmFjZSIgJiYgQGVhdmVzXz09MH0KIyMjIGZpbmlz
aCBmYXNjaWEgIyMjLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tCmZhc2NpYV9lbnRpdGllcz1mYXNjaWFfZ3Jv
dXAuZW50aXRpZXMKeGZhY2U9bmlsCmZhc2NpYV9lbnRpdGllcy5lYWNoe3xl
fHhmYWNlPWUgaWYgZS50eXBlbmFtZT09IkZhY2UifSMjI29ubHkgZmFjZQp4
ZWRnZXM9eGZhY2Uub3V0ZXJfbG9vcC5lZGdlcwp4dmVydHM9eGZhY2Uub3V0
ZXJfbG9vcC52ZXJ0aWNlcwp4bG9vcHM9eGZhY2UubG9vcHMtW3hmYWNlLm91
dGVyX2xvb3BdCnhsb29wcy5lYWNoe3xsb29wfGxvb3AuZWRnZXMuZWFjaHt8
ZXxlLmVyYXNlIX19Cnh4cG9pbnRzPVtdCnh2ZXJ0cy5lYWNoe3xlfAogIGVl
PWUucG9zaXRpb24udG9fYQogIHh4cG9pbnRzLnB1c2goW2VlWzBdLGVlWzFd
LGVlWzJdK0BmYXNjaWFfXSkKfQpmYXNjaWFfZW50aXRpZXMuYWRkX2ZhY2Uo
eHhwb2ludHMpCmZhc2NpYV9lbnRpdGllcy5lYWNoe3xlfGUuZXJhc2UhIGlm
IGUudHlwZW5hbWU9PSJGYWNlIn0KdmxpbmVzPVtdCnh2ZXJ0cy5lYWNoe3xl
fAogIGVlPWUucG9zaXRpb24udG9fYQogIHY9ZmFzY2lhX2VudGl0aWVzLmFk
ZF9saW5lKGVlLFtlZVswXSxlZVsxXSxlZVsyXStAZmFzY2lhX10pCiAgdmxp
bmVzLnB1c2godikKfQp2bGluZXMuZWFjaHt8ZXxlLmZpbmRfZmFjZXMgaWYg
ZX0jIyMKaWYgQGZhc2NpYV8gPCAwCiAgZmFzY2lhX2VudGl0aWVzLmVhY2h7
fGV8ZS5yZXZlcnNlISBpZiBlLnR5cGVuYW1lPT0iRmFjZSJ9CmVuZCNpZgoj
IyMgc29ydCBvdXQgbGF5ZXIsIG1hdGVyaWFscyBldGMgIyMjLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0KaWYgQG90aGVyPT0iWWVzIgog
ICMjIyBub3RlIHRoYXQgbGF5ZXIgaXMgc2V0IGFmdGVyIGdyb3VwcyBjb21i
aW5lZC4uLgogIGV4dGc9bmlsO0Btb2RlbC5sYXllcnMuZWFjaHt8bHlyfGV4
dGc9bHlyIGlmIGx5ci5uYW1lPT1AbGF5ZXJ9CiAgaWYgQGxheWVyPT0iPERl
ZmF1bHQ+IgogICAgbGF5cj1uaWwKICBlbHNlCiAgICBpZiBleHRnCiAgICAg
IGxheXI9ZXh0ZwogICAgZWxzZQogICAgICBsYXlyPUBtb2RlbC5sYXllcnMu
YWRkKEBsYXllcikKICAgIGVuZCNpZgogIGVuZCNpZgogICMjIyBtYXRlcmlh
bHMuLi4KICAjIyMgcm9vZgogIGV4dGc9bmlsO0Btb2RlbC5tYXRlcmlhbHMu
ZWFjaHt8bWF0fGV4dGc9bWF0IGlmIG1hdC5uYW1lPT1AbWF0X3Jvb2Z9CiAg
aWYgQG1hdF9yb29mPT0iPERlZmF1bHQ+IgogICAgbWF0X3I9bmlsCiAgZWxz
ZQogICAgaWYgZXh0ZwogICAgICBtYXRfcj1leHRnCiAgICBlbHNlCiAgICAg
IG1hdF9yPUBtb2RlbC5tYXRlcmlhbHMuYWRkKEBtYXRfcm9vZikKICAgICAg
bWF0X3IuY29sb3I9WzExMSwxMTEsMTExXSMjIyBhZGp1c3QgZGVmYXVsdCBj
b2xvdXJzIGhlcmUuCiAgICBlbmQjaWYKICBlbmQjaWYKICByb29mX2VudGl0
aWVzLmVhY2h7fGV8ZS5tYXRlcmlhbD1tYXRfciBpZiBlLnR5cGVuYW1lPT0i
RmFjZSJ9CiAgIyMjIGZhc2NpYQogIGV4dGc9bmlsO0Btb2RlbC5tYXRlcmlh
bHMuZWFjaHt8bWF0fGV4dGc9bWF0IGlmIG1hdC5uYW1lPT1AbWF0X2Zhc2Np
YX0KICBpZiBAbWF0X2Zhc2NpYT09IjxEZWZhdWx0PiIKICAgIG1hdF9mPW5p
bAogIGVsc2UKICAgIGlmIGV4dGcKICAgICAgbWF0X2Y9ZXh0ZwogICAgZWxz
ZQogICAgICBtYXRfZj1AbW9kZWwubWF0ZXJpYWxzLmFkZChAbWF0X2Zhc2Np
YSkKICAgICAgbWF0X2YuY29sb3I9WzY2LDY2LDY2XSMjIyBhZGp1c3QgZGVm
YXVsdCBjb2xvdXJzIGhlcmUuCiAgICBlbmQjaWYKICBlbmQjaWYKICBmYXNj
aWFfZW50aXRpZXMuZWFjaHt8ZXxlLm1hdGVyaWFsPW1hdF9mIGlmIGUudHlw
ZW5hbWU9PSJGYWNlIn0KICAjIyMgc29mZml0CiAgZXh0Zz1uaWw7QG1vZGVs
Lm1hdGVyaWFscy5lYWNoe3xtYXR8ZXh0Zz1tYXQgaWYgbWF0Lm5hbWU9PUBt
YXRfc29mZml0fQogIGlmIEBtYXRfc29mZml0PT0iPERlZmF1bHQ+IgogICAg
bWF0X3M9bmlsCiAgZWxzZQogICAgaWYgZXh0ZwogICAgICBtYXRfcz1leHRn
CiAgICBlbHNlCiAgICAgIG1hdF9zPUBtb2RlbC5tYXRlcmlhbHMuYWRkKEBt
YXRfc29mZml0KQogICAgICBtYXRfcy5jb2xvcj1bMjIyLDIyMiwyMjJdIyMj
IGFkanVzdCBkZWZhdWx0IGNvbG91cnMgaGVyZS4KICAgIGVuZCNpZgogIGVu
ZCNpZgogIHNvZmZpdF9lbnRpdGllcy5lYWNoe3xlfGUubWF0ZXJpYWw9bWF0
X3MgaWYgZS50eXBlbmFtZT09IkZhY2UifQogICMjIwplbmQjaWYKIyMjIG1v
dmUgb3JpZ2luIGJhc2VkIGZhY2VzIGV0YyBiYWNrIGludG8gcGxhY2UgdG8g
YXZvaWQgYnVnc3BsYXRzICMjIy0tCmlmIG9yaWdpbgogIHRyPUdlb206OlRy
YW5zZm9ybWF0aW9uLm5ldyhvcnB0KQogIHRyej1HZW9tOjpUcmFuc2Zvcm1h
dGlvbi5uZXcoWzAsMCwwXSkKICByb29mX2dyb3VwLm1vdmUhKHRyeikKICAj
IyMgY29ycmVjdCBmb3IgZmFzY2lhID8KICByb29mX2dyb3VwLm1vdmUhKEdl
b206OlRyYW5zZm9ybWF0aW9uLm5ldyhbMCwwLEBmYXNjaWFfXSkpaWYgQGZh
c2NpYV8+MAogIHNvZmZpdF9ncm91cC5tb3ZlISh0cnopCiAgZmFzY2lhX2dy
b3VwLm1vdmUhKHRyeikKZW5kI2lmCiMjIyBjb21iaW5lIHBpZWNlcyAjIyMt
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLQp0Z3JvdXA9ZW50aXRpZXMuYWRkX2dyb3VwKHJvb2ZfZ3JvdXAsc29m
Zml0X2dyb3VwLGZhc2NpYV9ncm91cCkKcm9vZl9ncm91cC5leHBsb2RlCnNv
ZmZpdF9ncm91cC5leHBsb2RlCmZhc2NpYV9ncm91cC5leHBsb2RlCnJvb2Zf
Z3JvdXA9dGdyb3VwCnJvb2ZfZ3JvdXAubGF5ZXI9bGF5ciBpZiBAb3RoZXI9
PSJZZXMiIyMjIGxheWVyIHNldCBoZXJlLi4uCiMjIyB0aWR5IHVwIGF0IGVu
ZCAjIyMtLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLQpAbW9kZWwuc2VsZWN0aW9uLmNsZWFyCkBtb2RlbC5zZWxl
Y3Rpb24uYWRkKG9mYWNlKSMjIyBlbmQgd2l0aCBvcmlnaW5hbCBmYWNlIHJl
LXNlbGVjdGVkCkBtb2RlbC5hY3RpdmVfdmlldy5pbnZhbGlkYXRlCkBtb2Rl
bC5jb21taXRfb3BlcmF0aW9uClNrZXRjaHVwLnNlbmRfYWN0aW9uInNlbGVj
dFNlbGVjdGlvblRvb2w6IgogICMjIwogZW5kI2RlZiBoaXAKIyMjLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tCgoKZGVmIFJvb2Y6Om1hbnNhcmQoKQogICMj
IyB2ZXJzaW9uIGVycm9yICMjIy0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0KICBpZiBTa2V0Y2h1cC52ZXJzaW9u
LnNwbGl0KCIuIilbMF0udG9faTw1CiAgICAgVUkubWVzc2FnZWJveCgiU29y
cnkgYnV0ICdNYW5zYXJkL1Nwcm9ja2V0IFJvb2YnIG9ubHkgd29ya3Mgd2l0
aCBWZXJzaW9uIDUgYW5kIG92ZXIuLi4iKQogICAgIHJldHVybiBuaWwKICBl
bmQjaWYKICAjIyMgY2hlY2sgZmFjZSAtLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tCiAgQG1vZGVsPVNr
ZXRjaHVwLmFjdGl2ZV9tb2RlbAogIHNzPUBtb2RlbC5zZWxlY3Rpb24KICBm
YWNlcz1bXQogIHNzLmVhY2h7fGV8ZmFjZXMucHVzaChlKWlmIGUudHlwZW5h
bWU9PSJGYWNlIn0KICBpZiBzcy5lbXB0eT8gfHwgZmFjZXMuZW1wdHk/CiAg
ICBVSS5tZXNzYWdlYm94KCJNYW5zYXJkL1Nwcm9ja2V0IFJvb2Y6XG5cbllv
dSBtdXN0IHNlbGVjdCBvbmUgaG9yaXpvbnRhbCBGQUNFICEiKQogICAgcmV0
dXJuIG5pbAogIGVuZCNpZgogIGlmIGZhY2VzWzFdCiAgICBVSS5tZXNzYWdl
Ym94KCJNYW5zYXJkL1Nwcm9ja2V0IFJvb2Y6XG5cbllvdSBtdXN0IHNlbGVj
dCBPTkUgaG9yaXpvbnRhbCBmYWNlICEiKQogICAgcmV0dXJuIG5pbAogIGVu
ZCNpZgogIG9mYWNlPWZhY2VzWzBdIyMjIHN0YXJ0aW5nIGZhY2UKICBpZiBv
ZmFjZS5ub3JtYWwubm9ybWFsaXplIS56LmFicyAhPTEuMAogICAgVUkubWVz
c2FnZWJveCgiTWFuc2FyZC9TcHJvY2tldCBSb29mOlxuXG5Zb3UgbXVzdCBz
ZWxlY3Qgb25lIEhPUklaT05UQUwgZmFjZSAhIikKICAgIHJldHVybiBuaWwK
ICBlbmQjaWYKZGVmIGRpYWxvZ19tYW4gKCkKIyMjIGhpcCBkaWFsb2cgIyMj
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLQpAcGl0Y2gxPSIyOjEiIGlmICEgQHBpdGNoMSAmJiBA
bW9kZWwub3B0aW9uc1siVW5pdHNPcHRpb25zIl1bIkxlbmd0aFVuaXQiXTwy
CkBwaXRjaDE9IjYwIiBpZiAhIEBwaXRjaDEgJiYgQG1vZGVsLm9wdGlvbnNb
IlVuaXRzT3B0aW9ucyJdWyJMZW5ndGhVbml0Il0+MQpAcGl0Y2gyPSIxOjIi
IGlmICEgQHBpdGNoMiAmJiBAbW9kZWwub3B0aW9uc1siVW5pdHNPcHRpb25z
Il1bIkxlbmd0aFVuaXQiXTwyCkBwaXRjaDI9IjMwIiBpZiAhIEBwaXRjaDIg
JiYgQG1vZGVsLm9wdGlvbnNbIlVuaXRzT3B0aW9ucyJdWyJMZW5ndGhVbml0
Il0+MQpAaHQ9NDguaW5jaCBpZiAhIEBodCAmJiBAbW9kZWwub3B0aW9uc1si
VW5pdHNPcHRpb25zIl1bIkxlbmd0aFVuaXQiXTwyCkBodD0xMjAwLm1tIGlm
ICEgQGh0ICYmIEBtb2RlbC5vcHRpb25zWyJVbml0c09wdGlvbnMiXVsiTGVu
Z3RoVW5pdCJdPjEKQGZhc2NpYT04LmluY2ggaWYgISBAZmFzY2lhICYmIEBt
b2RlbC5vcHRpb25zWyJVbml0c09wdGlvbnMiXVsiTGVuZ3RoVW5pdCJdPDIK
QGZhc2NpYT0yMDAubW0gaWYgISBAZmFzY2lhICYmIEBtb2RlbC5vcHRpb25z
WyJVbml0c09wdGlvbnMiXVsiTGVuZ3RoVW5pdCJdPjEKQGVhdmVzPTE2Lmlu
Y2ggaWYgISBAZWF2ZXMgJiYgQG1vZGVsLm9wdGlvbnNbIlVuaXRzT3B0aW9u
cyJdWyJMZW5ndGhVbml0Il08MgpAZWF2ZXM9NDAwLm1tIGlmICEgQGVhdmVz
ICYmIEBtb2RlbC5vcHRpb25zWyJVbml0c09wdGlvbnMiXVsiTGVuZ3RoVW5p
dCJdPjEKQG90aGVyPSJObyIgaWYgISBAb3RoZXIKdW5pdHM9ImluY2hlcyIg
aWYgQG1vZGVsLm9wdGlvbnNbIlVuaXRzT3B0aW9ucyJdWyJMZW5ndGhVbml0
Il09PTAKdW5pdHM9ImZlZXQiIGlmIEBtb2RlbC5vcHRpb25zWyJVbml0c09w
dGlvbnMiXVsiTGVuZ3RoVW5pdCJdPT0xCnVuaXRzPSJtbSIgaWYgQG1vZGVs
Lm9wdGlvbnNbIlVuaXRzT3B0aW9ucyJdWyJMZW5ndGhVbml0Il09PTIKdW5p
dHM9ImNtIiBpZiBAbW9kZWwub3B0aW9uc1siVW5pdHNPcHRpb25zIl1bIkxl
bmd0aFVuaXQiXT09Mwp1bml0cz0ibSIgaWYgQG1vZGVsLm9wdGlvbnNbIlVu
aXRzT3B0aW9ucyJdWyJMZW5ndGhVbml0Il09PTQKZW51bXM9WyIiLCIiLCIi
LCIiLCIiLCJZZXN8Tm8iXQpwcm9tcHRzPVsiTG93ZXIgU2xvcGUgKERlZ3Jl
ZXMgT1IgQTpCKTogICIsIlVwcGVyIFNsb3BlIChEZWdyZWVzIE9SIEE6Qik6
ICAiLCJIZWlnaHQgb2YgTG93ZXIgUm9vZiAoI3t1bml0c30pOiAgIiwiT3Zl
cmFsbCBFYXZlcyBGYXNjaWEgSGVpZ2h0ICgje3VuaXRzfSk6ICAiLCJPdmVy
YWxsIEVhdmVzIFNvZmZpdCBPdmVyaGFuZyAoI3t1bml0c30pOiAgIiwiU2V0
IExheWVyICsgTWF0ZXJpYWxzID8gOiJdCnZhbHVlcz1bQHBpdGNoMSxAcGl0
Y2gyLEBodCxAZmFzY2lhLEBlYXZlcyxAb3RoZXJdCkByZXN1bHRzPShpbnB1
dGJveCBwcm9tcHRzLHZhbHVlcyxlbnVtcywiTWFuc2FyZC9TcHJvY2tldCBS
b29mIFNldHRpbmdzIikKcmV0dXJuIG5pbCBpZiAhIEByZXN1bHRzCmJsYW5r
PWZhbHNlIyMjCkByZXN1bHRzLmVhY2h7fGV8Ymxhbms9dHJ1ZSBpZiBlLnRv
X3M9PSIifQppZiBibGFuawogIFVJLm1lc3NhZ2Vib3goIk1hbnNhcmQvU3By
b2NrZXQ6XG5cbllvdSBjYW5ub3QgaGF2ZSBibGFuayBlbnRyaWVzLlxuUmV0
cnkuLi4iKQogIGRpYWxvZ19tYW4KZW5kI2lmIyMjCihAcGl0Y2gxX3MsQHBp
dGNoMl9zLEBodF8sQGZhc2NpYV8sQGVhdmVzXyxAb3RoZXJfKT1AcmVzdWx0
cwpAcGl0Y2gxPUBwaXRjaDFfcztAcGl0Y2gyPUBwaXRjaDJfcztAaHQ9QGh0
XzsKQGZhc2NpYT1AZmFzY2lhXztAZWF2ZXM9QGVhdmVzXztAb3RoZXI9QG90
aGVyXwojIyMgZ2V0IGFuZ2xlIG9mIHJvb2YgaW4gcmFkaWFucwpyYXRpbz1A
cGl0Y2gxX3Muc3BsaXQoIjoiKS50b19mCmlmIHJhdGlvWzFdCiAgdGFuPXJh
dGlvWzBdL3JhdGlvWzFdCiAgQHBpdGNoMV9kPShNYXRoOjphdGFuKHRhbikp
LnJhZGlhbnMKZWxzZQogIEBwaXRjaDFfZD1yYXRpb1swXQplbmQjaWYKQHBp
dGNoMV9yPUBwaXRjaDFfZC5kZWdyZWVzICAjIyMgdG8gcmFkaWFucyAjIyMt
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0KcmF0aW89QHBpdGNoMl9zLnNwbGl0
KCI6IikudG9fZgppZiByYXRpb1sxXQogIHRhbj1yYXRpb1swXS9yYXRpb1sx
XQogIEBwaXRjaDJfZD0oTWF0aDo6YXRhbih0YW4pKS5yYWRpYW5zCmVsc2UK
ICBAcGl0Y2gyX2Q9cmF0aW9bMF0KZW5kI2lmCkBwaXRjaDJfcj1AcGl0Y2gy
X2QuZGVncmVlcyAgIyMjIHRvIHJhZGlhbnMgIyMjLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tCmlmIEBwaXRjaDFfZDwxCiAgVUkubWVzc2FnZWJveCgiTWFu
c2FyZC9TcHJvY2tldCBSb29mOlxuXG5Mb3dlciBwaXRjaCBjYW4ndCBiZSBs
ZXNzIHRoYW4gMSBkZWdyZWUuIikKICBAcGl0Y2gxPSIxIjtAcGl0Y2gxX3M9
IjEiO0BwaXRjaDFfZD0xO0BwaXRjaDFfcj0xLmRlZ3JlZXMKICBkaWFsb2df
bWFuCmVuZCNpZgppZiBAcGl0Y2gyX2Q8MQogIFVJLm1lc3NhZ2Vib3goIk1h
bnNhcmQvU3Byb2NrZXQgUm9vZjpcblxuVXBwZXIgcGl0Y2ggY2FuJ3QgYmUg
bGVzcyB0aGFuIDEgZGVncmVlLiIpCiAgQHBpdGNoMj0iMSI7QHBpdGNoMl9z
PSIxIjtAcGl0Y2gyX2Q9MTtAcGl0Y2gyX3I9MS5kZWdyZWVzCiAgZGlhbG9n
X21hbgplbmQjaWYKaWYgQHBpdGNoMV9kPjg5IAogIFVJLm1lc3NhZ2Vib3go
Ik1hbnNhcmQvU3Byb2NrZXQgUm9vZjpcblxuTG93ZXIgcGl0Y2ggY2FuJ3Qg
YmUgbW9yZSB0aGFuIDg5IGRlZ3JlZXMuIikKICBAcGl0Y2gxPSI4OSI7QHBp
dGNoMV9zPSI4OSI7QHBpdGNoMV9kPTg5O0BwaXRjaDFfcj04OS5kZWdyZWVz
CiAgZGlhbG9nX21hbgplbmQjaWYKaWYgQHBpdGNoMl9kPjg5IAogIFVJLm1l
c3NhZ2Vib3goIk1hbnNhcmQvU3Byb2NrZXQgUm9vZjpcblxuVXBwZXIgcGl0
Y2ggY2FuJ3QgYmUgbW9yZSB0aGFuIDg5IGRlZ3JlZXMuIikKICBAcGl0Y2gy
PSI4OSI7QHBpdGNoMl9zPSI4OSI7QHBpdGNoMl9kPTg5O0BwaXRjaDJfcj04
OS5kZWdyZWVzCiAgZGlhbG9nX21hbgplbmQjaWYKaWYgQGVhdmVzXyA8MAog
IFVJLm1lc3NhZ2Vib3goIk1hbnNhcmQvU3Byb2NrZXQgUm9vZjpcblxuRWF2
ZXMgY2FuJ3QgYmUgTEVTUyBUSEFOIFpFUk8uXG5SZXNldHRpbmcgaXQgdG8g
WkVSTy4uLlxuXG5Gb3IgYSAncGFyYXBldC1lYXZlcycgZmlyc3QgdXNlICdP
ZmZzZXQnIG9uIHRoZSBmYWNlIHRvIGluc2V0IGl0cyBlZGdlcyAuLi4iKQog
IEBlYXZlcz0wLnRvX2w7QGVhdmVzXz0wLnRvX2wKICBkaWFsb2dfbWFuCmVu
ZCNpZgojIyMKaWYgQGh0XyA8MAogIFVJLm1lc3NhZ2Vib3goIk1hbnNhcmQv
U3Byb2NrZXQgUm9vZjpcblxuTG93ZXIgUm9vZiBIZWlnaHQgY2FuJ3QgYmUg
TEVTUyBUSEFOIFpFUk8uXG5cblJlc2V0dGluZyBpdCB0byBaRVJPLi4uIikK
ICBAaHQ9MC50b19sO0BodF89MC50b19sCiAgZGlhbG9nX21hbgplbmQjaWYK
IyMjCmVuZCNkZWYKIyMjIHJ1biBoaXAgZGlhbG9nCiAgZGlhbG9nX21hbigp
CiAgcmV0dXJuIG5pbCBpZiAhIEByZXN1bHRzCiMjIwpkZWYgZGlhbG9nX21h
dHMgKCkKIyMjIG1hdGVyaWFscyBkaWFsb2cgIyMjLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tCiAgbW9kZWw9U2tl
dGNodXAuYWN0aXZlX21vZGVsCiAgIyMjIGxheWVycy4uLgogIG1sYXllcnM9
bW9kZWwubGF5ZXJzCiAgYWxheWVyPW1vZGVsLmFjdGl2ZV9sYXllcgogIG1v
ZGVsLmFjdGl2ZV9sYXllcj1uaWwKICBkZWZsYXllcj1tb2RlbC5hY3RpdmVf
bGF5ZXIubmFtZQogIG1vZGVsLmFjdGl2ZV9sYXllcj1hbGF5ZXIKICBybGF5
ZXI9Ii1ST09GIiMjIyBlZGl0IHRoaXMgdG8gc3VpdCB5b3VyIGRlc2lyZWQg
ZGVmYXVsdCByb29mIGxheWVyLgogIGxheWVycz1bXQogIG1sYXllcnMuZWFj
aHt8bGF5ZXJ8bGF5ZXJzLnB1c2gobGF5ZXIubmFtZSlpZiBsYXllci5uYW1l
IT1kZWZsYXllcn0KICBsYXllcnM9W3JsYXllcixkZWZsYXllcl0rbGF5ZXJz
LnNvcnQhCiAgbGF5ZXJzPWxheWVycy51bmlxLmpvaW4oJ3wnKQogICMjIyBt
YXRlcmlhbHMuLi4KICBtYXRfcm9vZj0iUm9vZiBTdXJmYWNlIgogIG1hdF9m
YXNjaWE9IlJvb2YgRmFzY2lhIgogIG1hdF9zb2ZmaXQ9IlJvb2YgU29mZml0
IgogIG1hdGVyaWFscz1tb2RlbC5tYXRlcmlhbHMKICBtYXRzPVtdCiAgbWF0
ZXJpYWxzLmVhY2h7fG1hdHxtYXRzLnB1c2gobWF0Lm5hbWUpfQogIG1hdHMu
c29ydCEKICBsaXN0X21hdF9yb29mPSgoWyI8RGVmYXVsdD4iXStbbWF0X3Jv
b2ZdK21hdHMpLnVuaXEpLmpvaW4oInwiKQogIGxpc3RfbWF0X2Zhc2NpYT0o
KFsiPERlZmF1bHQ+Il0rW21hdF9mYXNjaWFdK21hdHMpLnVuaXEpLmpvaW4o
InwiKQogIGxpc3RfbWF0X3NvZmZpdD0oKFsiPERlZmF1bHQ+Il0rW21hdF9z
b2ZmaXRdK21hdHMpLnVuaXEpLmpvaW4oInwiKQogICMjIyBzZXQgdXAgdmFy
aWFibGVzLi4uCiAgQGxheWVyPXJsYXllciBpZiAhIEBsYXllcgogIEBtYXRf
cm9vZj1tYXRfcm9vZiBpZiAhIEBtYXRfcm9vZgogIEBtYXRfZmFzY2lhPW1h
dF9mYXNjaWEgaWYgISBAbWF0X2Zhc2NpYQogIEBtYXRfc29mZml0PW1hdF9z
b2ZmaXQgaWYgISBAbWF0X3NvZmZpdAogIGVudW1zPVtsYXllcnMsbGlzdF9t
YXRfcm9vZixsaXN0X21hdF9mYXNjaWEsbGlzdF9tYXRfc29mZml0XQogIHBy
b21wdHM9WyJSb29mIExheWVyOiAgIiwiUm9vZiBTdXJmYWNlOiAgIiwiUm9v
ZiBGYXNjaWE6ICAiLCJSb29mIFNvZmZpdDogIl0KICB2YWx1ZXM9W0BsYXll
cixAbWF0X3Jvb2YsQG1hdF9mYXNjaWEsQG1hdF9zb2ZmaXRdCiAgQG90aGVy
X3Jlc3VsdHM9KGlucHV0Ym94IHByb21wdHMsdmFsdWVzLGVudW1zLCJSb29m
IExheWVyIGFuZCBNYXRlcmlhbHMiKQogIEBsYXllcixAbWF0X3Jvb2YsQG1h
dF9mYXNjaWEsQG1hdF9zb2ZmaXQ9QG90aGVyX3Jlc3VsdHMgaWYgQG90aGVy
X3Jlc3VsdHMKICBAb3RoZXI9Ik5vIiBpZiAhIEBvdGhlcl9yZXN1bHRzCiAg
IyMjCmVuZCNkZWYKIyMjIHJ1biBtYXRlcmlhbCBkaWFsb2cKICBkaWFsb2df
bWF0cygpIGlmIEBvdGhlcj09IlllcyIKIyMjIAojIyMgZG8gTWFuc2FyZC9T
cHJvY2tldCByb29mICMjIy0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tCkBtb2RlbC5zdGFydF9vcGVyYXRpb24o
Ik1hbnNhcmQvU3Byb2NrZXQgUm9vZiIpCmVudGl0aWVzPUBtb2RlbC5hY3Rp
dmVfZW50aXRpZXMKb2VkZ2VzPW9mYWNlLm91dGVyX2xvb3AuZWRnZXMKb3Zl
cnRzPW9mYWNlLm91dGVyX2xvb3AudmVydGljZXMKY291bnQ9b3ZlcnRzLmxl
bmd0aCMjIyB1c2VkIGZvciAlIGV0YyBsYXRlci4uLgpvcG9pbnRzPVtdO292
ZXJ0cy5lYWNoe3xlfG9wb2ludHMucHVzaChlLnBvc2l0aW9uLnRvX2EpfQoj
IyMgc2V0IHVwIHJvb2YgZ3JvdXAgZXRjICMjIy0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0Kcm9vZl9ncm91cD1lbnRpdGll
cy5hZGRfZ3JvdXAKcm9vZl9lbnRpdGllcz1yb29mX2dyb3VwLmVudGl0aWVz
CmlmYWNlPXJvb2ZfZW50aXRpZXMuYWRkX2ZhY2Uob3BvaW50cykKaWYgQGVh
dmVzPT0wCiAgZmFjZT1pZmFjZQplbHNlCiAgZmFjZT1pZmFjZS5vZmZzZXRf
ZWF2ZXMoQGVhdmVzKQogIGZhY2U9aWZhY2UgaWYgbm90IGZhY2UKZW5kI2lm
CiMjIyB0cmFwIGZvciBmb2xsb3dtZSBidWdzcGxhdCBpZiBmYWNlIGhhcyBj
b3JuZXIgYXQgb3JpZ2luICMjIy0tLS0tLS0tLQpvcmlnaW49ZmFsc2UKaWYg
cm9vZl9ncm91cC5ib3VuZHMubWluLno9PTAKICBvcmlnaW49dHJ1ZQogIG9y
cHQ9cm9vZl9ncm91cC5ib3VuZHMubWluCiAgcHQwPUdlb206OlBvaW50M2Qu
bmV3KDAsMCwxKyhAZmFzY2lhXypAZmFzY2lhXykpCiAgdHIwPUdlb206OlRy
YW5zZm9ybWF0aW9uLm5ldyhwdDApCiAgcm9vZl9ncm91cC5tb3ZlISh0cjAp
CmVuZCNpZgojIyMgLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0KIyMjIGNvbnRp
bnVlIHdpdGggcm9vZiBncm91cCBzZXQgdXAgIyMjLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tCmVlZGdlcz1mYWNlLm91dGVyX2xvb3AuZWRn
ZXMKZXZlcnRzPWZhY2Uub3V0ZXJfbG9vcC52ZXJ0aWNlcyMjIwplcG9pbnRz
PVtdO2V2ZXJ0cy5lYWNoe3xlfGVwb2ludHMucHVzaChlLnBvc2l0aW9uLnRv
X2EpfQojIyMgbWFrZSBhIGNvcHkgZm9yIHRoZSBzb2ZmaXQgZm9yIHVzZSBs
YXRlci4uLgpzb2ZmaXRfZ3JvdXA9cm9vZl9ncm91cC5jb3B5CnNvZmZpdF9n
cm91cC5tYWtlX3VuaXF1ZQojIyMgcmVtb3ZlIGFueSBpbm5lciBsb29wIGVk
Z2VzIGluIHJvb2YgZ3JvdXAuLi4KZWRnZXNfaW49W107ZWRnZXNfb3V0PVtd
CnJvb2ZfZW50aXRpZXMuZWFjaHt8ZXwKICBpZiBlLnR5cGVuYW1lPT0iRWRn
ZSIKICAgIGlmIGUuZmFjZXNbMV0jIyMgaW5uZXIgbG9vcAogICAgICBlZGdl
c19pbi5wdXNoKGUpCiAgICBlbHNlIyMjIG91dGVyIGxvb3AKICAgICAgZWRn
ZXNfb3V0LnB1c2goZSkKICAgIGVuZCNpZgogIGVuZCNpZgp9CmVkZ2VzX2lu
LmVhY2h7fGV8ZS5lcmFzZSF9IGlmIEBlYXZlc18gPiAwCmVkZ2VzX291dC5l
YWNoe3xlfGUuZXJhc2UhfSBpZiBAZWF2ZXNfIDwgMApmYWNlPWVkZ2VzX2lu
WzBdLmZhY2VzWzBdIGlmIGVkZ2VzX2luWzBdICYmIGVkZ2VzX2luWzBdLnZh
bGlkPwpmYWNlPWVkZ2VzX291dFswXS5mYWNlc1swXSBpZiBlZGdlc19vdXRb
MF0gJiYgZWRnZXNfb3V0WzBdLnZhbGlkPwplcG9pbnRzPVJvb2Yub3JkZXJl
ZF9lZGdlX3BvaW50cyhmYWNlKQplZWRnZXM9ZmFjZS5vdXRlcl9sb29wLmVk
Z2VzCmVlZGdlcy5lYWNoe3xlfGUuZXJhc2UhIGlmIGUudmFsaWQ/fQpmYWNl
PXJvb2ZfZW50aXRpZXMuYWRkX2ZhY2UoZXBvaW50cykKZWVkZ2VzPWZhY2Uu
b3V0ZXJfbG9vcC5lZGdlcwpldmVydHM9ZmFjZS5vdXRlcl9sb29wLnZlcnRp
Y2VzCiMjIyBtYWtlIHBhdGggYW5kIHByb2ZpbGUgZXRjICMjIy0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLQojIyMgd29yayBvdXQg
d2hpY2ggdmVydGV4IGdpdmVzIGxhcmdlc3QgZGlzdCBkaW0gIyMjLS0tLS0t
LS0tLS0tLS0tLS0tLS0KZGltcz1bMC5tbSxuaWxdIyMjZm9yIGRpc3QsZXZl
cnQKZG93bj0xCmV2ZXJ0cy5lYWNoe3xldmVydHwKICBTa2V0Y2h1cDo6c2V0
X3N0YXR1c190ZXh0KCJNYW5zYXJkL1Nwcm9ja2V0IFJvb2Y6IEZpbmRpbmcg
RmFjZXMgIisoMTAwKmRvd24vY291bnQpLnRvX2kudG9fcysiJS4gUGxlYXNl
IFdhaXQuLi4iLFNCX1BST01QVCkKICBkb3duPWRvd24rMQogIGRpc3Q9MS5t
bSAjIyMgPSBtaW4gcm9vZiBzaXplICEKICBlZGdlMW9yaWc9ZXZlcnQKICBl
ZGdlMm9yaWc9ZXZlcnQKICBlZGdlMT1lZGdlMW9yaWcuZWRnZXNbMF0KICBl
ZGdlMj1lZGdlMm9yaWcuZWRnZXNbMV0KICBlZGdlMW90aGVyPWVkZ2UxLm90
aGVyX3ZlcnRleChlZGdlMW9yaWcpCiAgZWRnZTJvdGhlcj1lZGdlMi5vdGhl
cl92ZXJ0ZXgoZWRnZTJvcmlnKQogIHZlY3RvcjE9ZWRnZTFvcmlnLnBvc2l0
aW9uLnZlY3Rvcl90byhlZGdlMW90aGVyLnBvc2l0aW9uKQogIHZlY3RvcjI9
ZWRnZTJvcmlnLnBvc2l0aW9uLnZlY3Rvcl90byhlZGdlMm90aGVyLnBvc2l0
aW9uKQogIGFuZ2xlMT12ZWN0b3IxLnRvX2ZsYXRfYW5nbGUKICBhbmdsZTI9
dmVjdG9yMi50b19mbGF0X2FuZ2xlCiAgYW5nbGVfYmV0d2Vlbj1hbmdsZTEt
YW5nbGUyCiAgYW5nbGU9YW5nbGVfYmV0d2Vlbi8yCiAgcHQxPWV2ZXJ0LnBv
c2l0aW9uCiAgcHQyPXB0MS5vZmZzZXQodmVjdG9yMiwxLm1tKQogIHJvdGF0
ZT1HZW9tOjpUcmFuc2Zvcm1hdGlvbi5yb3RhdGlvbihwdDEsWzAsMCwxXSxh
bmdsZSkKICBwdDI9cHQyLnRyYW5zZm9ybSEocm90YXRlKQogICMjIyBzb3J0
IHdoaWNoIGFuZ2xlIGdpdmVzIGEgcG9pbnQgb24gdGhlIGZhY2UgIyMjCiAg
aWYgYW5nbGUgPiAwCiAgICBhbmdsZT1hbmdsZSsxODAuZGVncmVlcyBpZiBu
b3QgcHQyLmlzX29uX2ZhY2U/KGZhY2UsdHJ1ZSkKICBlbHNlCiAgICBhbmds
ZT1hbmdsZS0xODAuZGVncmVlcyBpZiBub3QgcHQyLmlzX29uX2ZhY2U/KGZh
Y2UsdHJ1ZSkKICBlbmQjaWYKICAjIyMgZmluZCBiaWdnZXN0IG9uZQogIG9u
X2ZhY2U9dHJ1ZQogIHdoaWxlIG9uX2ZhY2UKICAgIHB0Mj1wdDEub2Zmc2V0
KHZlY3RvcjIsZGlzdCkKICAgIHJvdGF0ZT1HZW9tOjpUcmFuc2Zvcm1hdGlv
bi5yb3RhdGlvbihwdDEsWzAsMCwxXSxhbmdsZSkKICAgIHB0Mj1wdDIudHJh
bnNmb3JtIShyb3RhdGUpCiAgICBpZiBub3QgcHQyLmlzX29uX2ZhY2U/KGZh
Y2UsdHJ1ZSkgIyMjIGdvbmUgb2ZmIHRoZSBmYWNlCiAgICAgIGlmIGRpc3Qg
PiBkaW1zWzBdCiAgICAgICAgZGltcz1bZGlzdC0xMDAubW0sZXZlcnRdCiAg
ICAgIGVuZCNpZgogICAgICBvbl9mYWNlPWZhbHNlCiAgICBlbmQjaWYKICAg
IGRpc3Q9ZGlzdCsxMDAubW0jIyNpbmNyZW1lbnQgZGlzdCAxMDBtbSB0aWxs
IGl0IGdvZXMgb2ZmIGZhY2UuCiAgZW5kI3doaWxlCn0jZW5kIGV2ZXJ0cy5l
YWNoCiMjIyBsYXJnZXN0IGRpc3QgIyMjLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLQpkaXN0PShkaW1zWzBd
LzEuMDEpLmFicyMuMTU3MDA1NCMjIyBuZXZlciA+IChzcXJ0MyAtICgxL3Nx
cnQzKSkgIyMjID8/Pz8/PwpldmVydD1kaW1zWzFdCiAgZWRnZTFvcmlnPWV2
ZXJ0CiAgZWRnZTJvcmlnPWV2ZXJ0CiAgZWRnZTE9ZWRnZTFvcmlnLmVkZ2Vz
WzBdCiAgZWRnZTI9ZWRnZTJvcmlnLmVkZ2VzWzFdCiAgZWRnZTFvdGhlcj1l
ZGdlMS5vdGhlcl92ZXJ0ZXgoZWRnZTFvcmlnKQogIGVkZ2Uyb3RoZXI9ZWRn
ZTIub3RoZXJfdmVydGV4KGVkZ2Uyb3JpZykKICB2ZWN0b3IxPWVkZ2Uxb3Jp
Zy5wb3NpdGlvbi52ZWN0b3JfdG8oZWRnZTFvdGhlci5wb3NpdGlvbikKICB2
ZWN0b3IyPWVkZ2Uyb3JpZy5wb3NpdGlvbi52ZWN0b3JfdG8oZWRnZTJvdGhl
ci5wb3NpdGlvbikKICBhbmdsZTE9dmVjdG9yMS50b19mbGF0X2FuZ2xlCiAg
YW5nbGUyPXZlY3RvcjIudG9fZmxhdF9hbmdsZQogIGFuZ2xlX2JldHdlZW49
YW5nbGUxLWFuZ2xlMgogIGFuZ2xlPWFuZ2xlX2JldHdlZW4vMgogIHB0MT1l
dmVydC5wb3NpdGlvbgogIHB0Mj1wdDEub2Zmc2V0KHZlY3RvcjIsMS5tbSkK
ICByb3RhdGU9R2VvbTo6VHJhbnNmb3JtYXRpb24ucm90YXRpb24ocHQxLFsw
LDAsMV0sYW5nbGUpCiAgcHQyPXB0Mi50cmFuc2Zvcm0hKHJvdGF0ZSkKICAj
IyMgc29ydCB3aGljaCBhbmdsZSBnaXZlcyBhIHBvaW50IG9uIHRoZSBmYWNl
ICMjIwogIGlmIGFuZ2xlID4gMAogICAgYW5nbGU9YW5nbGUrMTgwLmRlZ3Jl
ZXMgaWYgbm90IHB0Mi5pc19vbl9mYWNlPyhmYWNlLHRydWUpCiAgZWxzZQog
ICAgYW5nbGU9YW5nbGUtMTgwLmRlZ3JlZXMgaWYgbm90IHB0Mi5pc19vbl9m
YWNlPyhmYWNlLHRydWUpCiAgZW5kI2lmCiAgcHQyPXB0MS5vZmZzZXQodmVj
dG9yMixkaXN0KQogIHJvdGF0ZT1HZW9tOjpUcmFuc2Zvcm1hdGlvbi5yb3Rh
dGlvbihwdDEsWzAsMCwxXSxhbmdsZSkKICBwdDI9cHQyLnRyYW5zZm9ybSEo
cm90YXRlKQojIyMgc29ydCBvdXQgdHJhbnNmb3JtYXRpb24gIyMjLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0KcHQxPUdlb206
OlBvaW50M2QubmV3KHB0MSkudHJhbnNmb3JtKHJvb2ZfZ3JvdXAudHJhbnNm
b3JtYXRpb24paWYgbm90IG9yaWdpbgpwdDI9R2VvbTo6UG9pbnQzZC5uZXco
cHQyKS50cmFuc2Zvcm0ocm9vZl9ncm91cC50cmFuc2Zvcm1hdGlvbilpZiBu
b3Qgb3JpZ2luCiMjIyBuZWVkIHRvIGFkanVzdCBvcHAgZm9yIGJlaW5nIG9u
IGRpYWdvbmFsIChzaW4pCmZhbmdsZT1hbmdsZS5hYnMKaWYgZmFuZ2xlID4w
CiB3aGlsZSBmYW5nbGUgPiAxODAuZGVncmVlcwogIGZhbmdsZT1mYW5nbGUt
MTgwLmRlZ3JlZXMKIGVuZCN3aGlsZQplbmQjaWYKIyMjCiMjIyBnZXQgb3Bw
b3NpdGVzID0gaGVpZ2h0IG9mIHJpZGdlIGF0IGRpc3QgZnJvbSBwdDEKZGlz
dDE9QGh0Xy9NYXRoOjp0YW4oQHBpdGNoMV9yKQpkaXN0Mj1kaXN0LWRpc3Qx
Cm9wcDE9QGh0XwpvcHAyPShkaXN0MipNYXRoOjpzaW4oZmFuZ2xlKSpNYXRo
Ojp0YW4oQHBpdGNoMl9yKSkuYWJzCm9wcD1vcHAxK29wcDIKIyMjIG1ha2Ug
dXBzaWRlIGRvd24gdHJpYW5ndWxhciBjcmFua2VkIGZhY2UgZm9yIGZvbGxv
d21lICMjIy0tLS0tLS0tLS0tCnB0YT1wdDEKcHRiPVtwdDEueCxwdDEueSxw
dDEueitvcHBdCnB0Yz1bcHQyLngscHQyLnkscHQyLnorb3BwXQpwdGQ9W3B0
MS54KygocHQyLngtcHQxLngpKihkaXN0MS9kaXN0KS9NYXRoOjpzaW4oZmFu
Z2xlKSkscHQxLnkrKChwdDIueS1wdDEueSkqKGRpc3QxL2Rpc3QpL01hdGg6
OnNpbihmYW5nbGUpKSxwdDEueitvcHAxXQpyb29mX2VudGl0aWVzLmFkZF9l
ZGdlcyhwdGEscHRiLHB0YyxwdGQpCmZmYWNlPXJvb2ZfZW50aXRpZXMuYWRk
X2ZhY2UocHRhLHB0YixwdGMscHRkKQojIyMgcmUtc29ydCBzbyBzdGFydHMg
ZnJvbSBwdDEKaW5kZXg9MAowLnVwdG8oZWVkZ2VzLmxlbmd0aC0xKSBkbyB8
aXwKICBpbmRleD1pIGlmIGVlZGdlc1tpXS5lbmQucG9zaXRpb249PXB0MQpl
bmQjdXB0byBpCnRlZGdlcz0oZWVkZ2VzLnNsaWNlKGluZGV4Li4tMSkpKyhl
ZWRnZXMuc2xpY2UoMC4uaW5kZXgtMSkpCiMjIwpmZmFjZS5mb2xsb3dtZSh0
ZWRnZXMpIyMjIG1ha2UgbWFpbiByb29mIGZhY2VzICMjIy0tLS0tLS0tLS0t
LS0tLS0tLS0tLQojIyMgVGhlIHRpZHkgdXAgIyMjLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0KIyMjIElu
dGVyc2VjdCA6CiMjIyBUaGUgaW50ZXJzZWN0X3dpdGggbWV0aG9kIGlzIHVz
ZWQgdG8gaW50ZXJzZWN0IGVudGl0aWVzLCBhIGNvbXBvbmVudAojIyMgaW5z
dGFuY2UsIG9yIGdyb3VwICMjIyB3aXRoIGFuIGVudGl0aWVzIG9iamVjdC4K
IyMjICAgZW50aXRpZXMuaW50ZXJzZWN0X3dpdGgocmVjdXJzZSx0cmFuc2Zv
cm1hdGlvbjEsZW50aXRpZXMxLHRyYW5zZm9ybWF0aW9uMixoaWRkZW4sZW50
aXRpZXMyKQojIyMgcmVjdXJzZSAtIHRydWUgaWYgeW91IHdhbnQgdGhpcyBl
bnRpdGllcyBvYmplY3QgdG8gYmUgcmVjdXJzZWQgLgojIyMgICAoaW50ZXJz
ZWN0aW9uIGxpbmVzIHdpbGwgYmUgcHV0IGluc2lkZSBvZiBncm91cHMgYW5k
IGNvbXBvbmVudHMgCiMjIyAgICB3aXRoaW4gdGhpcyBlbnRpdGllcyBvYmpl
Y3QpCiMjIyB0cmFuc2Zvcm1hdGlvbjEgLSB0aGUgdHJhbnNmb3JtYXRpb24g
Zm9yIHRoaXMgZW50aXRpZXMgb2JqZWN0LgojIyMgZW50aXRpZXMxIC0gdGhl
IGVudGl0aWVzIChncm91cCBldGMpIHdoZXJlIHlvdSB3YW50IHRoZSBpbnRl
cnNlY3Rpb24KIyMjIGxpbmVzIHRvIGFwcGVhci4KIyMjIHRyYW5zZm9ybWF0
aW9uMiAtIHRoZSB0cmFuc2Zvcm1hdGlvbiBmb3IgZW50aXRpZXMxLgojIyMg
aGlkZGVuIC0gdHJ1ZSBpZiB5b3Ugd2FudCBoaWRkZW4gZ2VvbWV0cnkgaW4g
dGhpcyBlbnRpdGllcy1vYmplY3QgdG8gCiMjIyBiZSB1c2VkIGluIHRoZSBp
bnRlcnNlY3Rpb24uCiMjIyBlbnRpdGllczIgLSBhbiBlbnRpdGllcyBvYmpl
Y3QgKG9yIGFuIGFycmF5IG9mIGVudGl0aWVzID8pID0gJ2ZhY2VzJy4KdG9w
PShjb3VudCpjb3VudC84KS50b19pO2Rvd249MQp0b3AudGltZXMgZG98dGhp
c3wKICBTa2V0Y2h1cDo6c2V0X3N0YXR1c190ZXh0KCJNYW5zYXJkL1Nwcm9j
a2V0IFJvb2Y6IEZpbmRpbmcgRWRnZXMgIisoMTAwKmRvd24vdG9wKS50b19p
LnRvX3MrIiUuIFBsZWFzZSBXYWl0Li4uIixTQl9QUk9NUFQpCiAgZG93bj1k
b3duKzEKICByb29mX2VudGl0aWVzLmVhY2h7fGV8CiAgICBydHI9WzAsMCww
XQogICAgcm9vZl9lbnRpdGllcy5pbnRlcnNlY3Rfd2l0aCh0cnVlLHJ0cixy
b29mX2dyb3VwLHJ0cix0cnVlLGUpaWYgZS50eXBlbmFtZT09IkZhY2UiCiAg
fQplbmQjdGltZXMKIyMjIEl0IHJlcGVhdHMgdG8gY2F0Y2ggYWxsIGludGVy
c2VjdGlvbnMgaW4gY29tcGxleCBzZXRzLS0tLS0tLS0tLS0tLS0tClNrZXRj
aHVwOjpzZXRfc3RhdHVzX3RleHQoIk1hbnNhcmQvU3Byb2NrZXQgUm9vZjog
RmluaXNoaW5nLiIsU0JfUFJPTVBUKQp6ej1yb29mX2dyb3VwLmJvdW5kcy5t
aW4ueiAjIyMgbmVlZGVkIGxhdGVyLi4uCnJlcD0oY291bnQqY291bnQvNCku
dG9faQojIyMgcmVtb3ZlIGZsYXQgZmFjZXMuLi4KcmVwLnRpbWVzIGRvIHx0
aGlzfAogcm9vZl9lbnRpdGllcy5lYWNoe3xlfAogIGlmIGUudHlwZW5hbWU9
PSJGYWNlIiAmJiBlICE9IGZhY2UKICAgIGUuZXJhc2UhIGlmIGUubm9ybWFs
Lm5vcm1hbGl6ZSEueC5hYnM8MS4wZS0wMDYgJiYgZS5ub3JtYWwubm9ybWFs
aXplIS55LmFiczwxLjBlLTAwNgogIGVuZCNpZgogfQplbmQjdGhpcwpTa2V0
Y2h1cDo6c2V0X3N0YXR1c190ZXh0KCJNYW5zYXJkL1Nwcm9ja2V0IFJvb2Y6
IEZpbmlzaGluZy4uIixTQl9QUk9NUFQpCiMjIyBlcmFzZSBhbGwgInZlcnRp
Y2FsIiBlZGdlcy4uLgpyZXAudGltZXMgZG8gfHRoaXN8CiByb29mX2VudGl0
aWVzLmVhY2h7fGV8CiAgaWYgZS50eXBlbmFtZT09IkVkZ2UiCiAgICBlLmVy
YXNlISBpZiBlLnN0YXJ0LnBvc2l0aW9uLng9PWUuZW5kLnBvc2l0aW9uLngg
JiYgZS5zdGFydC5wb3NpdGlvbi55PT1lLmVuZC5wb3NpdGlvbi55CiAgZW5k
I2lmCiB9CmVuZCN0aGlzClNrZXRjaHVwOjpzZXRfc3RhdHVzX3RleHQoIk1h
bnNhcmQvU3Byb2NrZXQgUm9vZjogRmluaXNoaW5nLi4uIixTQl9QUk9NUFQp
CiMjIyBlcmFzZSBmYWNlbGVzcyBlZGdlcy4uLgpyZXAudGltZXMgZG8gfHRo
aXN8CiByb29mX2VudGl0aWVzLmVhY2h7fGV8CiAgaWYgZS50eXBlbmFtZT09
IkVkZ2UiCiAgICBlLmVyYXNlISBpZiAhIGUuZmFjZXNbMF0KICBlbmQjaWYK
IH0KZW5kI3RoaXMKU2tldGNodXA6OnNldF9zdGF0dXNfdGV4dCgiTWFuc2Fy
ZC9TcHJvY2tldCBSb29mOiBGaW5pc2hpbmcuLi4uIixTQl9QUk9NUFQpCiMj
IyByZW1vdmUgb25lIGZhY2UgZWRnZXMgPSBvZmYgYmFzZS4uLgpyZXAudGlt
ZXMgZG8gfHRoaXN8CiByb29mX2VudGl0aWVzLmVhY2h7fGV8CiAgaWYgZS50
eXBlbmFtZT09IkVkZ2UiCiAgICBlLmVyYXNlISBpZiAhIGUuZmFjZXNbMV0K
ICBlbmQjaWYKIH0KZW5kI3RoaXMKU2tldGNodXA6OnNldF9zdGF0dXNfdGV4
dCgiTWFuc2FyZC9TcHJvY2tldCBSb29mOiBGaW5pc2hpbmcuLi4uLiIsU0Jf
UFJPTVBUKQojIyMgbm93IHJldmVyc2UgZmFjZXMgc28gJ3VwJwpyb29mX2Vu
dGl0aWVzLmVhY2h7fGV8CiAgaWYgZS50eXBlbmFtZT09IkZhY2UiCiAgICBl
LnJldmVyc2UhIGlmIGUubm9ybWFsLm5vcm1hbGl6ZSEueiA8MAogIGVuZCNp
Zgp9ClNrZXRjaHVwOjpzZXRfc3RhdHVzX3RleHQoIk1hbnNhcmQvU3Byb2Nr
ZXQgUm9vZjogRmluaXNoaW5nLi4uLi4uIixTQl9QUk9NUFQpCiMjIyByZW1v
dmUgYWxsICdmbGF0JyBmYWNlcyBhZ2Fpbi4uLgpyZXAudGltZXMgZG8gfHRo
aXN8CiByb29mX2VudGl0aWVzLmVhY2h7fGV8CiAgaWYgZS50eXBlbmFtZT09
IkZhY2UiCiAgICBlLmVyYXNlISBpZiBlLm5vcm1hbC5ub3JtYWxpemUhLngu
YWJzPDEuMGUtMDA2ICYmIGUubm9ybWFsLm5vcm1hbGl6ZSEueS5hYnM8MS4w
ZS0wMDYKICBlbmQjaWYKIH0KZW5kI3RoaXMKU2tldGNodXA6OnNldF9zdGF0
dXNfdGV4dCgiTWFuc2FyZC9TcHJvY2tldCBSb29mOiBGaW5pc2hpbmcuLi4u
Li4uIixTQl9QUk9NUFQpCiMjIyB0cmFwIGFueSBub24tYmFzZSBub24tZmxh
dCBmYWNlcy4uLgpmYWNlc19oaT1bXQpyb29mX2VudGl0aWVzLmVhY2h7fGV8
CiAgYXR0YWNoZWQ9dHJ1ZQogIGlmIGUudHlwZW5hbWU9PSJGYWNlIiAmJiBl
LmJvdW5kcy5taW4ueiA+IHp6CiAgICBlLmVkZ2VzLmVhY2h7fGVlfAogICAg
ICB6eno9ZS5ib3VuZHMubWluLnogIyMjIGJvdHRvbSBlZGdlcwogICAgICBp
ZiBlZS5ib3VuZHMubWluLno9PXp6eiAmJiBlZS5zdGFydC5wb3NpdGlvbi56
PT1lZS5lbmQucG9zaXRpb24ueiAjIyMgaXQgaXMgbGV2ZWwKICAgICAgICBv
dGhlcmZhY2VzPWVlLmZhY2VzLVtlXQogICAgICAgIG90aGVyZmFjZXMuZWFj
aHt8ZnwKICAgICAgICAgIGF0dGFjaGVkPWZhbHNlIGlmIGYuYm91bmRzLm1p
bi56ICE9IHp6CiAgICAgICAgfQogICAgICBlbmQjaWYKICAgIH0KICAgIGZh
Y2VzX2hpLnB1c2goZSkgaWYgbm90IGF0dGFjaGVkCiAgZW5kI2lmCn0KZmFj
ZXNfaGkuZWFjaHt8ZnwKICBjb3BsYW5hcj1mYWxzZQogIGYuZWRnZXMuZWFj
aHt8ZXwKICAgIGNvcGxhbmFyPXRydWUgaWYgZS5mYWNlc1sxXSAmJiBlLmZh
Y2VzWzBdLm5vcm1hbD09ZS5mYWNlc1sxXS5ub3JtYWwKICAgIGNvcGxhbmFy
PXRydWUgaWYgZS5mYWNlc1syXSAmJiBlLmZhY2VzWzBdLm5vcm1hbD09ZS5m
YWNlc1syXS5ub3JtYWwKICAgIGNvcGxhbmFyPXRydWUgaWYgZS5mYWNlc1sy
XSAmJiBlLmZhY2VzWzFdLm5vcm1hbD09ZS5mYWNlc1syXS5ub3JtYWwKICAg
IGNvcGxhbmFyPXRydWUgaWYgZS5mYWNlc1szXSAmJiBlLmZhY2VzWzBdLm5v
cm1hbD09ZS5mYWNlc1szXS5ub3JtYWwKICAgIGNvcGxhbmFyPXRydWUgaWYg
ZS5mYWNlc1szXSAmJiBlLmZhY2VzWzFdLm5vcm1hbD09ZS5mYWNlc1szXS5u
b3JtYWwKICAgIGNvcGxhbmFyPXRydWUgaWYgZS5mYWNlc1szXSAmJiBlLmZh
Y2VzWzJdLm5vcm1hbD09ZS5mYWNlc1szXS5ub3JtYWwKICB9CiAgZi5lcmFz
ZSEgaWYgZi52YWxpZD8gJiYgISBjb3BsYW5hcgp9CmZhY2VzX2hpLmVhY2h7
fGZ8CiAgaWYgZi52YWxpZD8KICAgIGYuZWRnZXMuZWFjaHt8ZXwKICAgICAg
ZS5lcmFzZSEgaWYgZS52YWxpZD8gJiYgISBlLmZhY2VzWzFdCiAgICB9CiAg
ZW5kI2lmCn0KU2tldGNodXA6OnNldF9zdGF0dXNfdGV4dCgiTWFuc2FyZC9T
cHJvY2tldCBSb29mOiBGaW5pc2hpbmcuLi4uLi4uIixTQl9QUk9NUFQpCiMj
IyB0aWR5IHVwIGZhY2VsZXNzIGFuZCBjb3BsYW5hciBlZGdlcyBldGMuLi4K
cmVwLnRpbWVzIGRvIHx0aGlzfAogcm9vZl9lbnRpdGllcy5lYWNoe3xlfAog
IGlmIGUudHlwZW5hbWU9PSJFZGdlIgogICAgZS5lcmFzZSEgaWYgISBlLmZh
Y2VzWzBdIyMjIGZhY2VsZXNzCiAgZW5kI2lmIAogIGlmIGUudmFsaWQ/ICYm
IGUudHlwZW5hbWU9PSJFZGdlIgogICAgZS5lcmFzZSEgaWYgZS5mYWNlc1sx
XSAmJiBlLmZhY2VzWzBdLm5vcm1hbD09ZS5mYWNlc1sxXS5ub3JtYWwjIyNj
b3BsYW5hcgogIGVuZCNpZgogfQplbmQjdGhpcwpTa2V0Y2h1cDo6c2V0X3N0
YXR1c190ZXh0KCJNYW5zYXJkL1Nwcm9ja2V0IFJvb2Y6IEZpbmlzaGluZy4u
Li4uLi4uIixTQl9QUk9NUFQpCiMjIyByZW1vdmUgb25lIGZhY2UgZWRnZXMg
dGhhdCBhcmUgYWJvdmUgYmFzZSBhbmQgb25seSBoYXZlIG9uZSBmYWNlLi4u
CnJlcC50aW1lcyBkbyB8dGhpc3wKIHJvb2ZfZW50aXRpZXMuZWFjaHt8ZXwK
ICBpZiBlLnR5cGVuYW1lPT0iRmFjZSIKICAgIGlmIGUuYm91bmRzLm1pbi56
ID4genoKICAgICAgZWRnZXM9ZS5lZGdlcwogICAgICBlZGdlcy5lYWNoe3xl
ZXxlZS5lcmFzZSEgaWYgZWUudmFsaWQ/ICYmICEgZWUuZmFjZXNbMV19CiAg
ICBlbmQjaWYKICBlbmQjaWYKIH0KZW5kI3RoaXMKU2tldGNodXA6OnNldF9z
dGF0dXNfdGV4dCgiTWFuc2FyZC9TcHJvY2tldCBSb29mOiBGaW5pc2hpbmcu
Li4uLi4uLi4iLFNCX1BST01QVCkKIyMjIGVyYXNlIGFueSAnZmxvYXRpbmcn
IGJpdHMgb2Ygcm9vZiBhYm92ZSB0aGUgbWFpbiBib2R5Li4uCnJlcC50aW1l
cyBkbyB8dGhpc3wKIHJvb2ZfZW50aXRpZXMuZWFjaHt8ZXwKICBpZiBlLnR5
cGVuYW1lPT0iRmFjZSIgJiYgZmFjZXNfaGkuaW5jbHVkZT8oZSkKICAgIGlm
IGUuYm91bmRzLm1pbi56ID4genoKICAgICAgZWRnZXM9ZS5lZGdlcwogICAg
ICBlZGdlcy5lYWNoe3xlZXxlZS5lcmFzZSEgaWYgZWUudmFsaWQ/fQogICAg
ZW5kI2lmCiAgZW5kI2lmCiB9CmVuZCN0aGlzClNrZXRjaHVwOjpzZXRfc3Rh
dHVzX3RleHQoIk1hbnNhcmQvU3Byb2NrZXQgUm9vZjogRmluaXNoZWQuIixT
Ql9QUk9NUFQpCiMjIyBlcmFzZSBmYWNlbGVzcyBlZGdlcyBhZ2Fpbi4uLgpy
ZXAudGltZXMgZG8gfHRoaXN8CiByb29mX2VudGl0aWVzLmVhY2h7fGV8CiAg
aWYgZS50eXBlbmFtZT09IkVkZ2UiCiAgICBlLmVyYXNlISBpZiAhIGUuZmFj
ZXNbMF0KICBlbmQjaWYKIH0KZW5kI3RpbWVzCiMjIyBpZiBmYWlscy4uLgpp
ZiAhIHJvb2ZfZW50aXRpZXNbMF0gfHwgcm9vZl9lbnRpdGllcy5sZW5ndGgg
PD0gY291bnQqMgogIFVJLm1lc3NhZ2Vib3goIk1hbnNhcmQvU3Byb2NrZXQg
Um9vZiBFcnJvcjpcblxuSXQgd2FzIG5vdCBwb3NzaWJsZSB0byBtYWtlIGEg
c2luZ2xlIHBpdGNoIG1hbnNhcmQvc3Byb2NrZXQgcm9vZiBmcm9tIHRoaXMg
ZmFjZS5cblxuU29tZXRpbWVzIHRoZSBmYWNlL2VkZ2UgcmVsYXRpb25zaGlw
cyBnZXQgbXVkZGxlZCBpbiB0aGUgbW9kZWwncyBkYXRhYmFzZS5cblRyeSBy
ZS1tYWtpbmcgdGhlIG9yaWdpbmFsIGZhY2U6XG4tIERlbGV0ZSBpdCBhbmQg
cmVkcmF3IG92ZXIgb25lIGVkZ2UgdG8gcmVtYWtlIGl0LiAgXG5PciBjb3B5
IHRoZSBmYWNlIHRvIG9uZSBzaWRlLCBkZWxldGUgdGhlIG9yaWdpbmFsIGFu
ZCBtb3ZlIHRoZSBjb3B5IGJhY2suICBcblRoaXMgbWV0aG9kcyBjYW4gb2Z0
ZW4gbWFrZSBhIGZhY2UgJ3Jvb2YnLlxuXG5JZiBub3QsIHRoZW4gdHJ5IHN1
Yi1kaXZpZGluZyB0aGUgZmFjZSBpbnRvIHBpZWNlcyBhbmQgam9pbmluZyB0
aGVpciByb29mcyBtYW51YWxseS5cblxuTm90ZSB0aGF0IHNvbWUgZmFjZSBz
aGFwZXMgY2FuIG5ldmVyIGJlIHJvb2ZlZCB3aXRoIGEgc2luZ2xlIHBpdGNo
LlxuZS5nLiBjcm9va2VkIHN0YXJzLlxuXG5FeGl0aW5nLi4uIikKICByb29m
X2dyb3VwLmVyYXNlISBpZiByb29mX2dyb3VwLnZhbGlkPwogIHNvZmZpdF9n
cm91cC5lcmFzZSEgaWYgc29mZml0X2dyb3VwLnZhbGlkPwogICMjIyB0aWR5
IHVwIGF0IGVuZCAjIyMtLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLQogIEBtb2RlbC5zZWxlY3Rpb24uY2xlYXIK
ICBAbW9kZWwuc2VsZWN0aW9uLmFkZChvZmFjZSkjIyMgZW5kIHdpdGggb3Jp
Z2luYWwgZmFjZSByZS1zZWxlY3RlZAogIEBtb2RlbC5hY3RpdmVfdmlldy5p
bnZhbGlkYXRlCiAgQG1vZGVsLmNvbW1pdF9vcGVyYXRpb24KICBTa2V0Y2h1
cC5zZW5kX2FjdGlvbiJzZWxlY3RTZWxlY3Rpb25Ub29sOiIKICByZXR1cm4g
bmlsCmVuZCNpZgojIyMtLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0KIyMjIGNv
cnJlY3QgZm9yIGZhc2NpYQpyb29mX2dyb3VwLm1vdmUhKEdlb206OlRyYW5z
Zm9ybWF0aW9uLm5ldyhbMCwwLEBmYXNjaWFfXSkpaWYgQGZhc2NpYV8+MAoj
IyMgc29ydCBvdXQgc29mZml0ICMjIy0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0Kc29mZml0X2VudGl0aWVzPXNv
ZmZpdF9ncm91cC5lbnRpdGllcwpzZmFjZT1uaWwKc29mZml0X2VudGl0aWVz
LmVhY2h7fGV8CiAgaWYgZS50eXBlbmFtZT09IkZhY2UiCiAgICBlLnJldmVy
c2UhIGlmIGUubm9ybWFsLm5vcm1hbGl6ZSEueiAhPS0xCiAgICBlLmVyYXNl
ISBpZiAhIGUubG9vcHNbMV0gJiYgQGVhdmVzXyE9MCMjIyBpbm5lciBmYWNl
IGFuZCBOT1QgYWxsCiAgZW5kI2lmCn0KIyMjIHNvcnQgb3V0IGVhdmVzICMj
Iy0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tCmZhc2NpYV9ncm91cD1zb2ZmaXRfZ3JvdXAuY29weTsgZmFzY2lh
X2dyb3VwLm1ha2VfdW5pcXVlCiMjIyBmaXJzdCBhZGp1c3Qgc29mZml0Li4u
CnNvZmZpdF9ncm91cC5tb3ZlIShbMCwwLEBmYXNjaWFfXSkgaWYgQGZhc2Np
YV8gPCAwCnNvZmZpdF9lbnRpdGllcy5lYWNoe3xlfGUuZXJhc2UhIGlmIGUu
dHlwZW5hbWU9PSJGYWNlIiAmJiBAZWF2ZXNfPT0wfQojIyMgZmluaXNoIGZh
c2NpYSAjIyMtLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0KZmFzY2lhX2VudGl0aWVzPWZhc2NpYV9ncm91cC5l
bnRpdGllcwp4ZmFjZT1uaWwKZmFzY2lhX2VudGl0aWVzLmVhY2h7fGV8eGZh
Y2U9ZSBpZiBlLnR5cGVuYW1lPT0iRmFjZSJ9IyMjb25seSBmYWNlCnhlZGdl
cz14ZmFjZS5vdXRlcl9sb29wLmVkZ2VzCnh2ZXJ0cz14ZmFjZS5vdXRlcl9s
b29wLnZlcnRpY2VzCnhsb29wcz14ZmFjZS5sb29wcy1beGZhY2Uub3V0ZXJf
bG9vcF0KeGxvb3BzLmVhY2h7fGxvb3B8bG9vcC5lZGdlcy5lYWNoe3xlfGUu
ZXJhc2UhfX0KeHhwb2ludHM9W10KeHZlcnRzLmVhY2h7fGV8CiAgZWU9ZS5w
b3NpdGlvbi50b19hCiAgeHhwb2ludHMucHVzaChbZWVbMF0sZWVbMV0sZWVb
Ml0rQGZhc2NpYV9dKQp9CmZhc2NpYV9lbnRpdGllcy5hZGRfZmFjZSh4eHBv
aW50cykKZmFzY2lhX2VudGl0aWVzLmVhY2h7fGV8ZS5lcmFzZSEgaWYgZS50
eXBlbmFtZT09IkZhY2UifQp2bGluZXM9W10KeHZlcnRzLmVhY2h7fGV8CiAg
ZWU9ZS5wb3NpdGlvbi50b19hCiAgdj1mYXNjaWFfZW50aXRpZXMuYWRkX2xp
bmUoZWUsW2VlWzBdLGVlWzFdLGVlWzJdK0BmYXNjaWFfXSkKICB2bGluZXMu
cHVzaCh2KQp9CnZsaW5lcy5lYWNoe3xlfGUuZmluZF9mYWNlcyBpZiBlfQpp
ZiBAZmFzY2lhXyA8IDAKICBmYXNjaWFfZW50aXRpZXMuZWFjaHt8ZXxlLnJl
dmVyc2UhIGlmIGUudHlwZW5hbWU9PSJGYWNlIn0KZW5kI2lmCiMjIyBzb3J0
IG91dCBsYXllciwgbWF0ZXJpYWxzIGV0YyAjIyMtLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLQppZiBAb3RoZXI9PSJZZXMiCiAgIyMjIG5v
dGUgdGhhdCBsYXllciBpcyBzZXQgYWZ0ZXIgZ3JvdXBzIGNvbWJpbmVkLi4u
CiAgZXh0Zz1uaWw7QG1vZGVsLmxheWVycy5lYWNoe3xseXJ8ZXh0Zz1seXIg
aWYgbHlyLm5hbWU9PUBsYXllcn0KICBpZiBAbGF5ZXI9PSI8RGVmYXVsdD4i
CiAgICBsYXlyPW5pbAogIGVsc2UKICAgIGlmIGV4dGcKICAgICAgbGF5cj1l
eHRnCiAgICBlbHNlCiAgICAgIGxheXI9QG1vZGVsLmxheWVycy5hZGQoQGxh
eWVyKQogICAgZW5kI2lmCiAgZW5kI2lmCiAgIyMjIG1hdGVyaWFscy4uLgog
ICMjIyByb29mCiAgZXh0Zz1uaWw7QG1vZGVsLm1hdGVyaWFscy5lYWNoe3xt
YXR8ZXh0Zz1tYXQgaWYgbWF0Lm5hbWU9PUBtYXRfcm9vZn0KICBpZiBAbWF0
X3Jvb2Y9PSI8RGVmYXVsdD4iCiAgICBtYXRfcj1uaWwKICBlbHNlCiAgICBp
ZiBleHRnCiAgICAgIG1hdF9yPWV4dGcKICAgIGVsc2UKICAgICAgbWF0X3I9
QG1vZGVsLm1hdGVyaWFscy5hZGQoQG1hdF9yb29mKQogICAgICBtYXRfci5j
b2xvcj1bMTExLDExMSwxMTFdIyMjIGFkanVzdCBkZWZhdWx0IGNvbG91cnMg
aGVyZS4KICAgIGVuZCNpZgogIGVuZCNpZgogIHJvb2ZfZW50aXRpZXMuZWFj
aHt8ZXxlLm1hdGVyaWFsPW1hdF9yIGlmIGUudHlwZW5hbWU9PSJGYWNlIn0K
ICAjIyMgZmFzY2lhCiAgZXh0Zz1uaWw7QG1vZGVsLm1hdGVyaWFscy5lYWNo
e3xtYXR8ZXh0Zz1tYXQgaWYgbWF0Lm5hbWU9PUBtYXRfZmFzY2lhfQogIGlm
IEBtYXRfZmFzY2lhPT0iPERlZmF1bHQ+IgogICAgbWF0X2Y9bmlsCiAgZWxz
ZQogICAgaWYgZXh0ZwogICAgICBtYXRfZj1leHRnCiAgICBlbHNlCiAgICAg
IG1hdF9mPUBtb2RlbC5tYXRlcmlhbHMuYWRkKEBtYXRfZmFzY2lhKQogICAg
ICBtYXRfZi5jb2xvcj1bNjYsNjYsNjZdIyMjIGFkanVzdCBkZWZhdWx0IGNv
bG91cnMgaGVyZS4KICAgIGVuZCNpZgogIGVuZCNpZgogIGZhc2NpYV9lbnRp
dGllcy5lYWNoe3xlfGUubWF0ZXJpYWw9bWF0X2YgaWYgZS50eXBlbmFtZT09
IkZhY2UifQogICMjIyBzb2ZmaXQKICBleHRnPW5pbDtAbW9kZWwubWF0ZXJp
YWxzLmVhY2h7fG1hdHxleHRnPW1hdCBpZiBtYXQubmFtZT09QG1hdF9zb2Zm
aXR9CiAgaWYgQG1hdF9zb2ZmaXQ9PSI8RGVmYXVsdD4iCiAgICBtYXRfcz1u
aWwKICBlbHNlCiAgICBpZiBleHRnCiAgICAgIG1hdF9zPWV4dGcKICAgIGVs
c2UKICAgICAgbWF0X3M9QG1vZGVsLm1hdGVyaWFscy5hZGQoQG1hdF9zb2Zm
aXQpCiAgICAgIG1hdF9zLmNvbG9yPVsyMjIsMjIyLDIyMl0jIyMgYWRqdXN0
IGRlZmF1bHQgY29sb3VycyBoZXJlLgogICAgZW5kI2lmCiAgZW5kI2lmCiAg
c29mZml0X2VudGl0aWVzLmVhY2h7fGV8ZS5tYXRlcmlhbD1tYXRfcyBpZiBl
LnR5cGVuYW1lPT0iRmFjZSJ9CiAgIyMjCmVuZCNpZgojIyMgbW92ZSBvcmln
aW4gYmFzZWQgZmFjZXMgZXRjIGJhY2sgaW50byBwbGFjZSB0byBhdm9pZCBi
dWdzcGxhdHMgIyMjLS0KaWYgb3JpZ2luCiAgdHI9R2VvbTo6VHJhbnNmb3Jt
YXRpb24ubmV3KG9ycHQpCiAgdHJ6PUdlb206OlRyYW5zZm9ybWF0aW9uLm5l
dyhbMCwwLDBdKQogIHJvb2ZfZ3JvdXAubW92ZSEodHJ6KQogICMjIyBjb3Jy
ZWN0IGZvciBmYXNjaWEgPwogIHJvb2ZfZ3JvdXAubW92ZSEoR2VvbTo6VHJh
bnNmb3JtYXRpb24ubmV3KFswLDAsQGZhc2NpYV9dKSlpZiBAZmFzY2lhXz4w
CiAgc29mZml0X2dyb3VwLm1vdmUhKHRyeikKICBmYXNjaWFfZ3JvdXAubW92
ZSEodHJ6KQplbmQjaWYKIyMjIGNvbWJpbmUgcGllY2VzICMjIy0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tCnRn
cm91cD1lbnRpdGllcy5hZGRfZ3JvdXAocm9vZl9ncm91cCxzb2ZmaXRfZ3Jv
dXAsZmFzY2lhX2dyb3VwKQpyb29mX2dyb3VwLmV4cGxvZGUKc29mZml0X2dy
b3VwLmV4cGxvZGUKZmFzY2lhX2dyb3VwLmV4cGxvZGUKcm9vZl9ncm91cD10
Z3JvdXAKcm9vZl9ncm91cC5sYXllcj1sYXlyIGlmIEBvdGhlcj09IlllcyIj
IyMgbGF5ZXIgc2V0IGhlcmUuLi4KIyMjIHRpZHkgdXAgYXQgZW5kICMjIy0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tCkBtb2RlbC5zZWxlY3Rpb24uY2xlYXIKQG1vZGVsLnNlbGVjdGlvbi5h
ZGQob2ZhY2UpIyMjIGVuZCB3aXRoIG9yaWdpbmFsIGZhY2UgcmUtc2VsZWN0
ZWQKQG1vZGVsLmFjdGl2ZV92aWV3LmludmFsaWRhdGUKQG1vZGVsLmNvbW1p
dF9vcGVyYXRpb24KU2tldGNodXAuc2VuZF9hY3Rpb24ic2VsZWN0U2VsZWN0
aW9uVG9vbDoiCiAgIyMjCmVuZCNkZWYgbWFuc2FyZAoKCgpkZWYgUm9vZjo6
Z2FibGUoKQogICMjIyBjaGVjayBmYWNlIC0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0KICBAbW9kZWw9
U2tldGNodXAuYWN0aXZlX21vZGVsCiAgc3M9QG1vZGVsLnNlbGVjdGlvbgog
IGZhY2VzPVtdO2VkZ2VzPVtdCiAgc3MuZWFjaHt8ZXwKICAgIGZhY2VzLnB1
c2goZSlpZiBlLnR5cGVuYW1lPT0iRmFjZSIKICAgIGVkZ2VzLnB1c2goZSlp
ZiBlLnR5cGVuYW1lPT0iRWRnZSIKICB9CiAgaWYgc3MuZW1wdHk/IHx8IGZh
Y2VzLmVtcHR5PwogICAgVUkubWVzc2FnZWJveCgiR2FibGUgUm9vZjpcblxu
WW91IG11c3Qgc2VsZWN0IG9uZSBob3Jpem9udGFsIHJlY3Rhbmd1bGFyIEZB
Q0UsIGFuZCBvbmUgZWRnZSAodGhhdCdzIGF0IHRoZSAnZ2FibGUnKSAhIikK
ICAgIHJldHVybiBuaWwKICBlbmQjaWYKICBpZiBmYWNlc1sxXQogICAgVUku
bWVzc2FnZWJveCgiR2FibGUgUm9vZjpcblxuWW91IG11c3Qgc2VsZWN0IE9O
RSBob3Jpem9udGFsIHJlY3Rhbmd1bGFyIGZhY2UsIGFuZCBvbmUgZWRnZSAo
dGhhdCdzIGF0IHRoZSAnZ2FibGUnKSAhIikKICAgIHJldHVybiBuaWwKICBl
bmQjaWYKICBvZmFjZT1mYWNlc1swXSMjIyBzdGFydGluZyBmYWNlCiAgaWYg
b2ZhY2Uubm9ybWFsLm5vcm1hbGl6ZSEuei5hYnMgIT0gMQogICAgVUkubWVz
c2FnZWJveCgiR2FibGUgUm9vZjpcblxuWW91IG11c3Qgc2VsZWN0IG9uZSBI
T1JJWk9OVEFMIHJlY3Rhbmd1bGFyIGZhY2UsIGFuZCBvbmUgZWRnZSAodGhh
dCdzIGF0IHRoZSAnZ2FibGUnKSAhIikKICAgIHJldHVybiBuaWwKICBlbmQj
aWYKICAjIyMgY2hlY2sgc2lkZXMgYXJlIHBhcmFsbGVsIGFuZCBhdCA5MCBk
ZWdyZWVzCiAgb3BvaW50cz1Sb29mLm9yZGVyZWRfZWRnZV9wb2ludHMob2Zh
Y2UpCiAgIyMjCiAgaWYgb3BvaW50cy5sZW5ndGggIT0gNAogICAgVUkubWVz
c2FnZWJveCgiR2FibGUgUm9vZjpcblxuWW91IG11c3Qgc2VsZWN0IG9uZSBo
b3Jpem9udGFsIFJFQ1RBTkdVTEFSIFs9IDQgc2lkZXNdIGZhY2UsIGFuZCBv
bmUgZWRnZSAodGhhdCdzIGF0IHRoZSAnZ2FibGUnKSAhIikKICAgIHJldHVy
biBuaWwKICBlbmQjaWYKICBwdDA9b3BvaW50c1swXTsgcHQxPW9wb2ludHNb
MV07IHB0Mj1vcG9pbnRzWzJdOyBwdDM9b3BvaW50c1szXQogIHB0MD1HZW9t
OjpQb2ludDNkLm5ldyhwdDBbMF0scHQwWzFdLHB0MFsyXSkgCiAgcHQxPUdl
b206OlBvaW50M2QubmV3KHB0MVswXSxwdDFbMV0scHQxWzJdKSAKICBwdDI9
R2VvbTo6UG9pbnQzZC5uZXcocHQyWzBdLHB0MlsxXSxwdDJbMl0pIAogIHB0
Mz1HZW9tOjpQb2ludDNkLm5ldyhwdDNbMF0scHQzWzFdLHB0M1syXSkgCiAg
dmVjMD1wdDAudmVjdG9yX3RvKHB0MSkKICB2ZWMxPXB0MS52ZWN0b3JfdG8o
cHQyKQogIHZlYzI9cHQyLnZlY3Rvcl90byhwdDMpCiAgdmVjMz1wdDMudmVj
dG9yX3RvKHB0MCkKICByZWN0YW5nbGU9dHJ1ZQogIHJlY3RhbmdsZT1mYWxz
ZSBpZiAhIHZlYzAucGFyYWxsZWw/KHZlYzIucmV2ZXJzZSkKICByZWN0YW5n
bGU9ZmFsc2UgaWYgISB2ZWMxLnBhcmFsbGVsPyh2ZWMzLnJldmVyc2UpCiAg
cmVjdGFuZ2xlPWZhbHNlIGlmICh2ZWMwLnRvX2ZsYXRfYW5nbGUtdmVjMS50
b19mbGF0X2FuZ2xlKS5hYnMudG9fcyAhPSA5MC5kZWdyZWVzLnRvX3MKICBy
ZWN0YW5nbGU9ZmFsc2UgaWYgKHZlYzIudG9fZmxhdF9hbmdsZS12ZWMzLnRv
X2ZsYXRfYW5nbGUpLmFicy50b19zICE9IDkwLmRlZ3JlZXMudG9fcwogIGlm
IG5vdCByZWN0YW5nbGUKICAgIFVJLm1lc3NhZ2Vib3goIkdhYmxlIFJvb2Y6
XG5cbllvdSBtdXN0IHNlbGVjdCBvbmUgaG9yaXpvbnRhbCBSRUNUQU5HVUxB
UiBbPSByaWdodC1hbmdsZWRdIGZhY2UsIGFuZCBvbmUgZWRnZSAodGhhdCdz
IGF0IHRoZSAnZ2FibGUnKSAhIikKICAgIHJldHVybiBuaWwKICBlbmQjaWYK
ICBpZiBlZGdlc1sxXSB8fCAhIGVkZ2VzWzBdCiAgICBVSS5tZXNzYWdlYm94
KCJHYWJsZSBSb29mOlxuXG5Zb3UgbXVzdCBzZWxlY3Qgb25seSBvbmUgZmFj
ZSBBTkQgT05FIGVkZ2UgKHRoYXQncyBhdCB0aGUgJ2dhYmxlJykgISIpCiAg
ICByZXR1cm4gbmlsCiAgZW5kI2lmCiAgaWYgISBmYWNlc1swXS5lZGdlcy5p
bmNsdWRlPyhlZGdlc1swXSkKICAgIFVJLm1lc3NhZ2Vib3goIkdhYmxlIFJv
b2Y6XG5cbllvdSBtdXN0IHNlbGVjdCBvbmx5IG9uZSBmYWNlIGFuZCBvbmUg
ZWRnZSAodGhhdCdzIGF0IHRoZSAnZ2FibGUnKS5cbkJVVCB0aGF0IGVkZ2Ug
bXVzdCBiZWxvbmcgdG8gdGhlIGZhY2UgISIpCiAgICByZXR1cm4gbmlsCiAg
ZW5kI2lmCiAgQG9lZGdlPWVkZ2VzWzBdIyMjIHVzZSB0aGlzIGluZm8gbGF0
ZXIuLi4KICBvcHQwPUBvZWRnZS5zdGFydC5wb3NpdGlvbgogIG9wdDE9QG9l
ZGdlLmVuZC5wb3NpdGlvbgojIyMgZG8gZ2FibGUgZGlhbG9nLi4uCmRlZiBk
aWFsb2dfZ2FibGUgKCkKIyMjIGRpYWxvZyAjIyMtLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tCkBw
aXRjaEc9IjE6MiIgaWYgISBAcGl0Y2hHICYmIEBtb2RlbC5vcHRpb25zWyJV
bml0c09wdGlvbnMiXVsiTGVuZ3RoVW5pdCJdPDIKQHBpdGNoRz0iMzAiIGlm
ICEgQHBpdGNoRyAmJiBAbW9kZWwub3B0aW9uc1siVW5pdHNPcHRpb25zIl1b
Ikxlbmd0aFVuaXQiXT4xCkBmYXNjaWE9OC5pbmNoIGlmICEgQGZhc2NpYSAm
JiBAbW9kZWwub3B0aW9uc1siVW5pdHNPcHRpb25zIl1bIkxlbmd0aFVuaXQi
XTwyCkBmYXNjaWE9MjAwLm1tIGlmICEgQGZhc2NpYSAmJiBAbW9kZWwub3B0
aW9uc1siVW5pdHNPcHRpb25zIl1bIkxlbmd0aFVuaXQiXT4xCkBlYXZlcz0x
Ni5pbmNoIGlmICEgQGVhdmVzICYmIEBtb2RlbC5vcHRpb25zWyJVbml0c09w
dGlvbnMiXVsiTGVuZ3RoVW5pdCJdPDIKQGdhYmxlMT00MDAubW0gaWYgISBA
Z2FibGUxICYmIEBtb2RlbC5vcHRpb25zWyJVbml0c09wdGlvbnMiXVsiTGVu
Z3RoVW5pdCJdPjEKQGdhYmxlMT0xNi5pbmNoIGlmICEgQGdhYmxlMSAmJiBA
bW9kZWwub3B0aW9uc1siVW5pdHNPcHRpb25zIl1bIkxlbmd0aFVuaXQiXTwy
CkBnYWJsZTI9NDAwLm1tIGlmICEgQGdhYmxlMiAmJiBAbW9kZWwub3B0aW9u
c1siVW5pdHNPcHRpb25zIl1bIkxlbmd0aFVuaXQiXT4xCkBnYWJsZTI9MTYu
aW5jaCBpZiAhIEBnYWJsZTIgJiYgQG1vZGVsLm9wdGlvbnNbIlVuaXRzT3B0
aW9ucyJdWyJMZW5ndGhVbml0Il08MgpAZWF2ZXM9NDAwLm1tIGlmICEgQGVh
dmVzICYmIEBtb2RlbC5vcHRpb25zWyJVbml0c09wdGlvbnMiXVsiTGVuZ3Ro
VW5pdCJdPjEKQGdhYmxlMXR5cGU9IlZlcmdlIGZyb20gRmFzY2lhIiBpZiAh
IEBnYWJsZTF0eXBlCkBnYWJsZTJ0eXBlPSJWZXJnZSBmcm9tIEZhc2NpYSIg
aWYgISBAZ2FibGUydHlwZQpAb3RoZXI9Ik5vIiBpZiAhIEBvdGhlcgpAdW5p
dHM9ImluY2hlcyIgaWYgQG1vZGVsLm9wdGlvbnNbIlVuaXRzT3B0aW9ucyJd
WyJMZW5ndGhVbml0Il09PTAKQHVuaXRzPSJmZWV0IiBpZiBAbW9kZWwub3B0
aW9uc1siVW5pdHNPcHRpb25zIl1bIkxlbmd0aFVuaXQiXT09MQpAdW5pdHM9
Im1tIiBpZiBAbW9kZWwub3B0aW9uc1siVW5pdHNPcHRpb25zIl1bIkxlbmd0
aFVuaXQiXT09MgpAdW5pdHM9ImNtIiBpZiBAbW9kZWwub3B0aW9uc1siVW5p
dHNPcHRpb25zIl1bIkxlbmd0aFVuaXQiXT09MwpAdW5pdHM9Im0iIGlmIEBt
b2RlbC5vcHRpb25zWyJVbml0c09wdGlvbnMiXVsiTGVuZ3RoVW5pdCJdPT00
CmdhYmxldHlwZXM9IkJsYW5rfEJsYW5rIHdpdGggRmFzY2lhfFZlcmdlIGZy
b20gRmFzY2lhfFZlcmdlIGZyb20gU29mZml0fFZlcmdlIGJ5IEhlaWdodHxW
ZXJnZSBieSBXaWR0aHxWZXJnZSBieSBIZWlnaHQsIHdpdGggRmFzY2lhfFZl
cmdlIGJ5IFdpZHRoLCB3aXRoIEZhc2NpYXxWZXJnZSB3aXRoIEZhc2NpYSBb
QWxsIEVxdWFsXXxWZXJnZSBieSBIZWlnaHQsIHdpdGggQm94LUVhdmVzfFZl
cmdlIGJ5IFdpZHRoLCB3aXRoIEJveC1FYXZlcyIKZW51bXM9WyIiLCIiLCIi
LCIiLCIiLGdhYmxldHlwZXMsZ2FibGV0eXBlcywiWWVzfE5vIl0KcHJvbXB0
cz1bIlJvb2YgJ1Nsb3BlJyAoaW4gRGVncmVlcyBvciBBOkIgb3IgXkhlaWdo
dCgje0B1bml0c30pKTogICIsIk92ZXJhbGwgRWF2ZXMgRmFzY2lhIEhlaWdo
dCAoI3tAdW5pdHN9KTogICIsIk92ZXJhbGwgRWF2ZXMgU29mZml0IE92ZXJo
YW5nICgje0B1bml0c30pOiAgIiwiRmlyc3QgR2FibGUgT3ZlcmhhbmcgKCN7
QHVuaXRzfSk6ICAiLCJTZWNvbmQgR2FibGUgT3ZlcmhhbmcgKCN7QHVuaXRz
fSk6ICAiLCJGaXJzdCBHYWJsZSBUeXBlOiAgIiwiU2Vjb25kIEdhYmxlIFR5
cGU6ICAiLCJTZXQgTGF5ZXIgYW5kIE1hdGVyaWFscyA/IDoiXQp2YWx1ZXM9
W0BwaXRjaEcsQGZhc2NpYSxAZWF2ZXMsQGdhYmxlMSxAZ2FibGUyLEBnYWJs
ZTF0eXBlLEBnYWJsZTJ0eXBlLEBvdGhlcl0KQHJlc3VsdHM9KGlucHV0Ym94
IHByb21wdHMsdmFsdWVzLGVudW1zLCJHYWJsZSBSb29mIFNldHRpbmdzIikK
cmV0dXJuIG5pbCBpZiAhIEByZXN1bHRzCihAcGl0Y2hfcyxAZmFzY2lhXyxA
ZWF2ZXNfLEBnYWJsZTFfLEBnYWJsZTJfLEBnYWJsZTF0eXBlXyxAZ2FibGUy
dHlwZV8sQG90aGVyXyk9QHJlc3VsdHMKQHBpdGNoRz1AcGl0Y2hfcztAZmFz
Y2lhPUBmYXNjaWFfO0BlYXZlcz1AZWF2ZXNfCkBnYWJsZTE9QGdhYmxlMV87
QGdhYmxlMj1AZ2FibGUyXzsKQGdhYmxlMXR5cGU9QGdhYmxlMXR5cGVfO0Bn
YWJsZTJ0eXBlPUBnYWJsZTJ0eXBlXztAb3RoZXI9QG90aGVyXwojIyMgc29y
dCBpZiBeaGVpZ2h0IG9yIHNsb3BlLi4uCmlmIEBwaXRjaF9zLnNwbGl0KCIi
KVswXT09Il4iCiAgZ2h0PUBwaXRjaF9zWzEuLi0xXS50b19mCiAgZ2h0PWdo
dC50b19sIGlmIEB1bml0cz09ImluY2hlcyIKICBnaHQ9Z2h0LmZlZXQgaWYg
QHVuaXRzPT0iZmVldCIKICBnaHQ9Z2h0Lm1tIGlmIEB1bml0cz09Im1tIgog
IGdodD1naHQuY20gaWYgQHVuaXRzPT0iY20iCiAgZ2h0PWdodC5tIGlmIEB1
bml0cz09Im0iCiAgYWRqPShAb2VkZ2UubGVuZ3RoLzIpK0BlYXZlcwogIEBw
aXRjaF9kPShNYXRoOjphdGFuKGdodC9hZGopKS5yYWRpYW5zCmVsc2UjaXQn
cyBhbiBhbmdsZQogICMjIyBnZXQgYW5nbGUgb2Ygcm9vZiBpbiByYWRpYW5z
CiAgcmF0aW89QHBpdGNoX3Muc3BsaXQoIjoiKS50b19mCiAgaWYgcmF0aW9b
MV0KICAgIHRhbj1yYXRpb1swXS9yYXRpb1sxXQogICAgQHBpdGNoX2Q9KE1h
dGg6OmF0YW4odGFuKSkucmFkaWFucwogIGVsc2UKICAgIEBwaXRjaF9kPXJh
dGlvWzBdCiAgZW5kI2lmCmVuZCNpZgpAcGl0Y2hfcj1AcGl0Y2hfZC5kZWdy
ZWVzICAjIyMgdG8gcmFkaWFucyAjIyMtLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0KaWYgQHBpdGNoX2Q8MQogIFVJLm1lc3NhZ2Vib3goIkdhYmxlIFJvb2Y6
XG5cblBpdGNoIGNhbid0IGJlIGxlc3MgdGhhbiAxIGRlZ3JlZS4iKQogIEBw
aXRjaEc9IjEiO0BwaXRjaF9zPSIxIjtAcGl0Y2hfZD0xO0BwaXRjaF9yPTEu
ZGVncmVlcwogIGRpYWxvZ19nYWJsZQogIHJldHVybiBuaWwKZW5kI2lmCmlm
IEBwaXRjaF9kPjg5IAogIFVJLm1lc3NhZ2Vib3goIkdhYmxlIFJvb2Y6XG5c
blBpdGNoIGNhbid0IGJlIG1vcmUgdGhhbiA4OSBkZWdyZWVzLiIpCiAgQHBp
dGNoRz0iODkiO0BwaXRjaF9zPSI4OSI7QHBpdGNoX2Q9ODk7QHBpdGNoX3I9
ODkuZGVncmVlcwogIGRpYWxvZ19nYWJsZQogIHJldHVybiBuaWwKZW5kI2lm
CmlmIEBmYXNjaWFfIDwwCiAgVUkubWVzc2FnZWJveCgiR2FibGUgUm9vZjpc
blxuRmFzY2lhIGNhbid0IGJlIExFU1MgVEhBTiBaRVJPLlxuUmVzZXR0aW5n
IGl0IHRvIFpFUk8uLi4iKQogIEBmYXNjaWE9MC50b19sO0BmYXNjaWFfPTAu
dG9fbAogIGRpYWxvZ19nYWJsZQogIHJldHVybiBuaWwKZW5kI2lmCmlmIEBl
YXZlc18gPDAKICBVSS5tZXNzYWdlYm94KCJHYWJsZSBSb29mOlxuXG5FYXZl
cyBjYW4ndCBiZSBMRVNTIFRIQU4gWkVSTy5cblJlc2V0dGluZyBpdCB0byBa
RVJPLi4uXG5cbkZvciBhICdwYXJhcGV0LWVhdmVzJyBmaXJzdCB1c2UgJ09m
ZnNldCcgb24gdGhlIGZhY2UgdG8gaW5zZXQgaXRzIGVkZ2VzIC4uLiIpCiAg
QGVhdmVzPTAudG9fbDtAZWF2ZXNfPTAudG9fbAogIGRpYWxvZ19nYWJsZQog
IHJldHVybiBuaWwKZW5kI2lmCiMjIwppZiBAZ2FibGUxXyA8MAogIFVJLm1l
c3NhZ2Vib3goIkdhYmxlIFJvb2Y6XG5cbkZpcnN0IEdhYmxlIGNhbid0IGJl
IExFU1MgVEhBTiBaRVJPLlxuUmVzZXR0aW5nIGl0IHRvIFpFUk8uLi5cblxu
Rm9yIGEgJ3BhcmFwZXQtZ2FibGUnIGZpcnN0IHVzZSAnT2Zmc2V0JyBvbiB0
aGUgZmFjZSB0byBpbnNldCBpdHMgZWRnZXMgLi4uIikKICBAZWF2ZXM9MC50
b19sO0BlYXZlc189MC50b19sCiAgZGlhbG9nX2dhYmxlCiAgcmV0dXJuIG5p
bAplbmQjaWYKaWYgQGdhYmxlMl8gPDAKICBVSS5tZXNzYWdlYm94KCJHYWJs
ZSBSb29mOlxuXFNlY29uZCBHYWJsZSBjYW4ndCBiZSBMRVNTIFRIQU4gWkVS
Ty5cblJlc2V0dGluZyBpdCB0byBaRVJPLi4uXG5cbkZvciBhICdwYXJhcGV0
LWdhYmxlJyBmaXJzdCB1c2UgJ09mZnNldCcgb24gdGhlIGZhY2UgdG8gaW5z
ZXQgaXRzIGVkZ2VzIC4uLiIpCiAgQGVhdmVzPTAudG9fbDtAZWF2ZXNfPTAu
dG9fbAogIGRpYWxvZ19nYWJsZQogIHJldHVybiBuaWwKZW5kI2lmCmlmIEBm
YXNjaWFfPT0wICYmIChAZ2FibGUxdHlwZV89PSJWZXJnZSBmcm9tIEZhc2Np
YSJ8fEBnYWJsZTF0eXBlXz09IlZlcmdlIHdpdGggRmFzY2lhIFtBbGwgRXF1
YWxdIikKICBVSS5tZXNzYWdlYm94KCJHYWJsZSBSb29mOlxuXG5GYXNjaWEg
aXMgWkVSTy5cblRoZXJlZm9yZSBjYW5ub3QgbWFrZSAnVmVyZ2UgZnJvbSBG
YXNjaWEnIC4uLiIpCiAgQGdhYmxlMXR5cGVfPSJCbGFuayI7QGdhYmxlMXR5
cGU9IkJsYW5rIgogIGRpYWxvZ19nYWJsZQogIHJldHVybiBuaWwKZW5kI2lm
CmlmIEBmYXNjaWFfPT0wICYmIChAZ2FibGUydHlwZV89PSJWZXJnZSBmcm9t
IEZhc2NpYSJ8fEBnYWJsZTJ0eXBlXz09IlZlcmdlIHdpdGggRmFzY2lhIFtB
bGwgRXF1YWxdIikKICBVSS5tZXNzYWdlYm94KCJHYWJsZSBSb29mOlxuXG5G
YXNjaWEgaXMgWkVSTy5cblRoZXJlZm9yZSBjYW5ub3QgbWFrZSAnVmVyZ2Ug
ZnJvbSBGYXNjaWEnIC4uLiIpCiAgQGdhYmxlMnR5cGVfPSJCbGFuayI7QGdh
YmxlMnR5cGU9IkJsYW5rIgogIGRpYWxvZ19nYWJsZQogIHJldHVybiBuaWwK
ZW5kI2lmCmlmIEBlYXZlc189PTAgJiYgQGdhYmxlMXR5cGVfPT0iVmVyZ2Ug
ZnJvbSBTb2ZmaXQiCiAgVUkubWVzc2FnZWJveCgiR2FibGUgUm9vZjpcblxT
b2ZmaXQgaXMgWkVSTy5cblRoZXJlZm9yZSBjYW5ub3QgbWFrZSAnVmVyZ2Ug
ZnJvbSBTb2ZmaXQnIC4uLiIpCiAgQGdhYmxlMXR5cGVfPSJCbGFuayI7QGdh
YmxlMXR5cGU9IkJsYW5rIgogIGRpYWxvZ19nYWJsZQogIHJldHVybiBuaWwK
ZW5kI2lmCmlmIEBlYXZlc189PTAgJiYgQGdhYmxlMnR5cGVfPT0iVmVyZ2Ug
ZnJvbSBTb2ZmaXQiCiAgVUkubWVzc2FnZWJveCgiR2FibGUgUm9vZjpcblxT
b2ZmaXQgaXMgWkVSTy5cblRoZXJlZm9yZSBjYW5ub3QgbWFrZSAnVmVyZ2Ug
ZnJvbSBTb2ZmaXQnIC4uLiIpCiAgQGdhYmxlMnR5cGVfPSJCbGFuayI7QGdh
YmxlMnR5cGU9IkJsYW5rIgogIGRpYWxvZ19nYWJsZQogIHJldHVybiBuaWwK
ZW5kI2lmCmlmIEBmYXNjaWFfPT0wICYmIEBnYWJsZTF0eXBlPT0iVmVyZ2Ug
YnkgSGVpZ2h0LCB3aXRoIEZhc2NpYSIKICBVSS5tZXNzYWdlYm94KCJHYWJs
ZSBSb29mOlxuXG5GYXNjaWEgaXMgWkVSTy5cblRoZXJlZm9yZSBjYW5ub3Qg
bWFrZSAnVmVyZ2UgYnkgSGVpZ2h0LCB3aXRoIEZhc2NpYScgLi4uIikKICBA
Z2FibGUxdHlwZV89IkJsYW5rIjtAZ2FibGUxdHlwZT0iQmxhbmsiCiAgZGlh
bG9nX2dhYmxlCiAgcmV0dXJuIG5pbAplbmQjaWYKaWYgQGZhc2NpYV89PTAg
JiYgQGdhYmxlMnR5cGU9PSJWZXJnZSBieSBIZWlnaHQsIHdpdGggRmFzY2lh
IgogIFVJLm1lc3NhZ2Vib3goIkdhYmxlIFJvb2Y6XG5cbkZhc2NpYSBpcyBa
RVJPLlxuVGhlcmVmb3JlIGNhbm5vdCBtYWtlICdWZXJnZSBieSBIZWlnaHQs
IHdpdGggRmFzY2lhJyAuLi4iKQogIEBnYWJsZTJ0eXBlXz0iQmxhbmsiO0Bn
YWJsZTJ0eXBlPSJCbGFuayIKICBkaWFsb2dfZ2FibGUKICByZXR1cm4gbmls
CmVuZCNpZgppZiBAZmFzY2lhXz09MCAmJiBAZ2FibGUxdHlwZT09IkJsYW5r
IHdpdGggRmFzY2lhIgogIFVJLm1lc3NhZ2Vib3goIkdhYmxlIFJvb2Y6XG5c
bkZhc2NpYSBpcyBaRVJPLlxuVGhlcmVmb3JlIGNhbm5vdCBtYWtlICdCbGFu
ayB3aXRoIEZhc2NpYScgLi4uIikKICBAZ2FibGUxdHlwZV89IkJsYW5rIjtA
Z2FibGUxdHlwZT0iQmxhbmsiCiAgZGlhbG9nX2dhYmxlCiAgcmV0dXJuIG5p
bAplbmQjaWYKaWYgQGZhc2NpYV89PTAgJiYgQGdhYmxlMnR5cGU9PSJCbGFu
ayB3aXRoIEZhc2NpYSIKICBVSS5tZXNzYWdlYm94KCJHYWJsZSBSb29mOlxu
XG5GYXNjaWEgaXMgWkVSTy5cblRoZXJlZm9yZSBjYW5ub3QgbWFrZSAnQmxh
bmsgd2l0aCBGYXNjaWEnIC4uLiIpCiAgQGdhYmxlMnR5cGVfPSJCbGFuayI7
QGdhYmxlMnR5cGU9IkJsYW5rIgogIGRpYWxvZ19nYWJsZQogIHJldHVybiBu
aWwKZW5kI2lmCmlmIChAZmFzY2lhXz09MCAmJiBAZWF2ZXM9PTApICYmIChA
Z2FibGUxdHlwZT09IlZlcmdlIGJ5IEhlaWdodCwgd2l0aCBCb3gtRWF2ZXMi
fHxAZ2FibGUxdHlwZT09IlZlcmdlIGJ5IFdpZHRoLCB3aXRoIEJveC1FYXZl
cyIpCiAgVUkubWVzc2FnZWJveCgiR2FibGUgUm9vZjpcblxuRmFzY2lhIEFO
RCBTb2ZmaXQgYXJlIFpFUk8uXG5UaGVyZWZvcmUgY2Fubm90IG1ha2UgYSAn
Qm94IEVhdmVzJyAuLi4iKQogIEBnYWJsZTF0eXBlXz0iQmxhbmsiO0BnYWJs
ZTF0eXBlPSJCbGFuayIKICBkaWFsb2dfZ2FibGUKICByZXR1cm4gbmlsCmVu
ZCNpZgppZiAoQGZhc2NpYV89PTAgJiYgQGVhdmVzPT0wKSAmJiAoQGdhYmxl
MnR5cGU9PSJWZXJnZSBieSBIZWlnaHQsIHdpdGggQm94LUVhdmVzInx8QGdh
YmxlMnR5cGU9PSJWZXJnZSBieSBXaWR0aCwgd2l0aCBCb3gtRWF2ZXMiKQog
IFVJLm1lc3NhZ2Vib3goIkdhYmxlIFJvb2Y6XG5cbkZhc2NpYSBBTkQgU29m
Zml0IGFyZSBaRVJPLlxuVGhlcmVmb3JlIGNhbm5vdCBtYWtlIGEgJ0JveCBF
YXZlcycgLi4uIikKICBAZ2FibGUydHlwZV89IkJsYW5rIjtAZ2FibGUydHlw
ZT0iQmxhbmsiCiAgZGlhbG9nX2dhYmxlCiAgcmV0dXJuIG5pbAplbmQjaWYK
IyMjCmVuZCNkZWYgZGlhbG9nCiMjIyBydW4gZGlhbG9nCiAgZGlhbG9nX2dh
YmxlKCkKICByZXR1cm4gbmlsIGlmICEgQHJlc3VsdHMKIyMjCiMjIy0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLQojIyMgZG8gZ2FibGUgcm9vZi4uLgpAbW9k
ZWwuc3RhcnRfb3BlcmF0aW9uKCJHYWJsZSBSb29mIikKZW50aXRpZXM9QG1v
ZGVsLmFjdGl2ZV9lbnRpdGllcwojIyMgQG9lZGdlIGlzIHNlbGVjdGVkIGdh
YmxlIGVkZ2UsIG9mYWNlIHRoZSBzZWxlY3RlZCBmYWNlCm9lZGdlcz1vZmFj
ZS5vdXRlcl9sb29wLmVkZ2VzCm92ZXJ0cz1vZmFjZS5vdXRlcl9sb29wLnZl
cnRpY2VzCm9wb2ludHM9W107b3ZlcnRzLmVhY2h7fGV8b3BvaW50cy5wdXNo
KGUucG9zaXRpb24udG9fYSl9CiMjIyBzZXQgdXAgcm9vZiBncm91cCBldGMg
IyMjLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LQpyb29mX2dyb3VwPWVudGl0aWVzLmFkZF9ncm91cApyb29mX2VudGl0aWVz
PXJvb2ZfZ3JvdXAuZW50aXRpZXMKaWZhY2U9cm9vZl9lbnRpdGllcy5hZGRf
ZmFjZShvcG9pbnRzKQppZiBAZWF2ZXM9PTAKICBmYWNlPWlmYWNlCmVsc2UK
ICBmYWNlPWlmYWNlLm9mZnNldF9lYXZlcyhAZWF2ZXMpCiAgaWYgbm90IGZh
Y2UKICAgIGZhY2U9aWZhY2UKICBlbHNlCiAgICBpZmFjZS5lZGdlcy5lYWNo
e3xlfGUuZXJhc2UhIGlmIGUudmFsaWQ/fQogIGVuZCNpZgplbmQjaWYKZXBv
aW50cz1Sb29mLm9yZGVyZWRfZWRnZV9wb2ludHMoZmFjZSkKcm9vZl9lbnRp
dGllcy5lYWNoe3xlfGUuZXJhc2UhIGlmIGUudmFsaWQ/ICYmIGUudHlwZW5h
bWU9PSJGYWNlIn0KZWZwb2ludHM9ZXBvaW50czsgZWZwb2ludHM9ZWZwb2lu
dHMucHVzaChlZnBvaW50c1swXSkKZWVkZ2VzPXJvb2ZfZW50aXRpZXMuYWRk
X2VkZ2VzKGVmcG9pbnRzKQojIyMgLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0K
IyMjIGNvbnRpbnVlIHdpdGggcm9vZiBncm91cCBzZXQgdXAgIyMjLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tCiMjIyBmaW5kIGEgbmV3IGVk
Z2UgbmV4dCB0byBhbmQgcGFyYWxsZWwgd2l0aCBAb2VkZ2UuLi4Kb3ZlY3Q9
b3B0MC52ZWN0b3JfdG8ob3B0MSkubm9ybWFsaXplCmdlZGdlPWVlZGdlc1sw
XSAjIyMgZ2FibGUgZWRnZSBpbiByb29mIGdyb3VwLgplZWRnZXMuZWFjaHt8
ZXwKICBpZiBlLnN0YXJ0LnBvc2l0aW9uLnZlY3Rvcl90byhlLmVuZC5wb3Np
dGlvbikubm9ybWFsaXplPT1vdmVjdAogICAgZ2VkZ2U9ZQogIGVuZCNpZgp9
CiMjIyB0cmFwIGZvciBmb2xsb3dtZSBidWdzcGxhdCBpZiBmYWNlIGhhcyBj
b3JuZXIgYXQgb3JpZ2luICMjIy0tLS0tLS0tLQpvcmlnaW49ZmFsc2UKaWYg
cm9vZl9ncm91cC5ib3VuZHMubWluLno9PTAKICBvcmlnaW49dHJ1ZQogIG9y
cHQ9cm9vZl9ncm91cC5ib3VuZHMubWluCiAgcHQwPUdlb206OlBvaW50M2Qu
bmV3KDAsMCwxKyhAZmFzY2lhXypAZmFzY2lhXykpCiAgdHIwPUdlb206OlRy
YW5zZm9ybWF0aW9uLm5ldyhwdDApCiAgcm9vZl9ncm91cC5tb3ZlISh0cjAp
CmVuZCNpZgojIyMgbWlkLXBvaW50IG9uIGdlZGdlCmdzPWdlZGdlLnN0YXJ0
LnBvc2l0aW9uOyBnZT1nZWRnZS5lbmQucG9zaXRpb24KY3A9R2VvbTo6UG9p
bnQzZC5saW5lYXJfY29tYmluYXRpb24oMC41LGdzLDAuNSxnZSkKYWRqPWdz
LmRpc3RhbmNlKGNwKQpvcHA9YWRqKk1hdGg6OnRhbihAcGl0Y2hfcikKZmUx
PXJvb2ZfZW50aXRpZXMuYWRkX2xpbmUoZ2UsW2dlLngsZ2UueSxnZS56K0Bm
YXNjaWFdKWlmIEBmYXNjaWEhPTAKZ2UxPXJvb2ZfZW50aXRpZXMuYWRkX2xp
bmUoW2dlLngsZ2UueSxnZS56K0BmYXNjaWFdLFtjcC54LGNwLnksY3Aueitv
cHArQGZhc2NpYV0pCmdlMj1yb29mX2VudGl0aWVzLmFkZF9saW5lKFtjcC54
LGNwLnksY3AueitvcHArQGZhc2NpYV0sW2dzLngsZ3MueSxncy56K0BmYXNj
aWFdKQpmZTI9cm9vZl9lbnRpdGllcy5hZGRfbGluZShbZ3MueCxncy55LGdz
LnorQGZhc2NpYV0sZ3MpaWYgQGZhc2NpYSE9MAojIyMKaWYgQGZhc2NpYT09
MAogIGdmYWNlPXJvb2ZfZW50aXRpZXMuYWRkX2ZhY2UoZ2VkZ2UsZ2UxLGdl
MikKZWxzZQogIGdmYWNlPXJvb2ZfZW50aXRpZXMuYWRkX2ZhY2UoZ2VkZ2Us
ZmUxLGdlMSxnZTIsZmUyKQplbmQjaWYKZWU9Z2VkZ2Uuc3RhcnQuZWRnZXNb
MV0KZ2ZhY2UuZm9sbG93bWUoZWUpIyMjIG1ha2Ugcm9vZiBzaGFwZQojIyMg
cmV2ZXJzZSBob3Jpem9udGFsIHJvb2YgZmFjZSBldGMuLi4Kc29mZml0PW5p
bDt2ZXJ0aWNhbHM9W10Kcm9vZl9lbnRpdGllcy5lYWNoe3xlfAogIGlmIGUu
dHlwZW5hbWU9PSJGYWNlIgogICAgZS5yZXZlcnNlISBpZiBlLm5vcm1hbC5u
b3JtYWxpemUuej09LTEjIyNzb2ZmaXQKICAgIHNvZmZpdD1lIGlmIGUubm9y
bWFsLm5vcm1hbGl6ZS56LmFicz09MQogICAgdmVydGljYWxzLnB1c2goZSkg
aWYgZS5ub3JtYWwubm9ybWFsaXplLnouYWJzPDEuMGUtMDA2IyMjIH4gPT0w
CiAgZW5kI2lmCn0Kc29mZml0LnJldmVyc2UhCiMjIyBpZiB2ZXJ0aWNhbHMg
PSAyIE5PIGZhc2NpYQpnYWJsZXM9W107ZmFzY2lhcz1bXQppZiB2ZXJ0aWNh
bHMubGVuZ3RoPT0yCiAgZ2FibGVzPXZlcnRpY2FscwplbHNlCiAgdmVydGlj
YWxzLmVhY2h7fGV8CiAgICBpZiBlLmVkZ2VzLmxlbmd0aD09MyB8fCBlLmVk
Z2VzLmxlbmd0aD09NQogICAgICBnYWJsZXMucHVzaChlKQogICAgZWxzZQog
ICAgICBmYXNjaWFzLnB1c2goZSkKICAgIGVuZCNpZgogIH0KZW5kI2lmCiMj
IyBwdXQgaW5pdGlhbCBnYWJsZXMgaW4gcmlnaHQgcGxhY2VzCmdhYmxlMT1u
aWw7IGdhYmxlMj1uaWwKZ2FibGVzWzBdLmVkZ2VzLmVhY2h7fGV8CiAgZ2Fi
bGUxPWdhYmxlc1swXSBpZiBlLnN0YXJ0LnBvc2l0aW9uPT1ncyB8fCBlLmVu
ZC5wb3NpdGlvbj09Z2UKICBnYWJsZTI9Z2FibGVzWzFdIGlmIGUuc3RhcnQu
cG9zaXRpb249PWdzIHx8IGUuZW5kLnBvc2l0aW9uPT1nZQp9CmdhYmxlc1sx
XS5lZGdlcy5lYWNoe3xlfAogIGdhYmxlMT1nYWJsZXNbMV0gaWYgZS5zdGFy
dC5wb3NpdGlvbj09Z3MgfHwgZS5lbmQucG9zaXRpb249PWdlCiAgZ2FibGUy
PWdhYmxlc1swXSBpZiBlLnN0YXJ0LnBvc2l0aW9uPT1ncyB8fCBlLmVuZC5w
b3NpdGlvbj09Z2UKfQpnYWJsZTEucHVzaHB1bGwoQGdhYmxlMS1AZWF2ZXMs
ZmFsc2UpaWYgZ2FibGUxLnZhbGlkPwpnYWJsZTIucHVzaHB1bGwoQGdhYmxl
Mi1AZWF2ZXMsZmFsc2UpaWYgZ2FibGUyLnZhbGlkPwojIyMKZ2VkZ2UxPW5p
bApnYWJsZTEuZWRnZXMuZWFjaHt8ZXwKICBnZWRnZTE9ZSBpZiBlLnN0YXJ0
LnBvc2l0aW9uLno9PWUuZW5kLnBvc2l0aW9uLnoKfQpnczE9Z2VkZ2UxLnN0
YXJ0LnBvc2l0aW9uOyBnZTE9Z2VkZ2UxLmVuZC5wb3NpdGlvbgpjcDE9R2Vv
bTo6UG9pbnQzZC5saW5lYXJfY29tYmluYXRpb24oMC41LGdzMSwwLjUsZ2Ux
KQpnZWRnZTI9bmlsCmdhYmxlMi5lZGdlcy5lYWNoe3xlfAogIGdlZGdlMj1l
IGlmIGUuc3RhcnQucG9zaXRpb24uej09ZS5lbmQucG9zaXRpb24uegp9Cmdz
Mj1nZWRnZTIuc3RhcnQucG9zaXRpb247IGdlMj1nZWRnZTIuZW5kLnBvc2l0
aW9uCmNwMj1HZW9tOjpQb2ludDNkLmxpbmVhcl9jb21iaW5hdGlvbigwLjUs
Z3MyLDAuNSxnZTIpCmlmIEBnYWJsZTF0eXBlPT0iQmxhbmsgd2l0aCBGYXNj
aWEiCiAgbG4xPXJvb2ZfZW50aXRpZXMuYWRkX2xpbmUoW2dzMS54LGdzMS55
LGdzMS56K0BmYXNjaWFdLFtnZTEueCxnZTEueSxnZTEueitAZmFzY2lhXSkK
ZW5kI2lmCmlmIEBnYWJsZTJ0eXBlPT0iQmxhbmsgd2l0aCBGYXNjaWEiCiAg
bG4xPXJvb2ZfZW50aXRpZXMuYWRkX2xpbmUoW2dzMi54LGdzMi55LGdzMi56
K0BmYXNjaWFdLFtnZTIueCxnZTIueSxnZTIueitAZmFzY2lhXSkKZW5kI2lm
CiMjIyBtYWtlIGdhYmxlIHR5cGVzCiMjIyA9IEJsYW5rfEJsYW5rIHdpdGgg
RmFzY2lhfEVhdmVzIGludG8gVmVyZ2V8U29mZml0IGludG8gVmVyZ2UgZXRj
CmlmIEBnYWJsZTF0eXBlPT0iVmVyZ2UgZnJvbSBGYXNjaWEiCiAgbG4xPXJv
b2ZfZW50aXRpZXMuYWRkX2xpbmUoZ2UxLFtjcDEueCxjcDEueSxjcDEueitv
cHBdKQogIHJvb2ZfZW50aXRpZXMuYWRkX2xpbmUoW2NwMS54LGNwMS55LGNw
MS56K29wcF0sZ3MxKQogIGdhYjE9bmlsOyBsbjEuZmFjZXMuZWFjaHt8ZXwK
ICAgIGdhYjE9ZSBpZiBlLmJvdW5kcy5tYXgueiE9cm9vZl9ncm91cC5ib3Vu
ZHMubWF4LnoKICB9CiAgZ2FiMS5wdXNocHVsbCgtQGdhYmxlMSxmYWxzZSkg
aWYgZ2FiMQplbHNpZiBAZ2FibGUxdHlwZT09IlZlcmdlIGZyb20gU29mZml0
IgogIHJpc2U9TWF0aDo6dGFuKEBwaXRjaF9yKSpAZWF2ZXMjIyM/CiAgZ2Ux
PWdlMS5vZmZzZXQoZ2VkZ2UxLmxpbmVbMV0ucmV2ZXJzZSxAZWF2ZXMpCiAg
Z3MxPWdzMS5vZmZzZXQoZ2VkZ2UxLmxpbmVbMV0sQGVhdmVzKQogIGxuMT1y
b29mX2VudGl0aWVzLmFkZF9saW5lKGdlMSxbY3AxLngsY3AxLnksY3AxLnor
b3BwLXJpc2VdKQogIHJvb2ZfZW50aXRpZXMuYWRkX2xpbmUoW2NwMS54LGNw
MS55LGNwMS56K29wcC1yaXNlXSxnczEpCiAgZ2FiMT1uaWw7IGxuMS5mYWNl
cy5lYWNoe3xlfAogICAgZ2FiMT1lIGlmIGUuYm91bmRzLm1heC56IT1yb29m
X2dyb3VwLmJvdW5kcy5tYXguegogIH0KICBnYWIxLnB1c2hwdWxsKC1AZ2Fi
bGUxLGZhbHNlKSBpZiBnYWIxCiAgIyMjVmVyZ2UgYnkgSGVpZ2h0fFZlcmdl
IGJ5IFdpZHRofFZlcmdlIGJ5IEhlaWdodCwgd2l0aCBGYXNjaWF8VmVyZ2Ug
YnkgV2lkdGgsIHdpdGggRmFzY2lhfFZlcmdlIGJ5IEhlaWdodCwgd2l0aCBC
b3gtRWF2ZXN8VmVyZ2UgYnkgV2lkdGgsIHdpdGggQm94LUVhdmVzCmVsc2lm
IEBnYWJsZTF0eXBlPT0iVmVyZ2UgYnkgSGVpZ2h0IgogIEB2ZXJnZTE9QGZh
c2NpYSBpZiAhIEB2ZXJnZTEKICBpZiBAdmVyZ2UxPT0wCiAgICBAdmVyZ2Ux
PTQuaW5jaCBpZiBAbW9kZWwub3B0aW9uc1siVW5pdHNPcHRpb25zIl1bIkxl
bmd0aFVuaXQiXTwyCiAgICBAdmVyZ2UxPTEwMC5tbSBpZiBAbW9kZWwub3B0
aW9uc1siVW5pdHNPcHRpb25zIl1bIkxlbmd0aFVuaXQiXT4xCiAgZW5kI2lm
CiAgbWF4aHQ9KG9wcCtAZmFzY2lhKS50b19sO21heGh0X3M9bWF4aHQudG9f
cwogIHByb21wdHM9WyJGaXJzdCBHYWJsZSBWZXJnZSBIZWlnaHQgKCNAdW5p
dHMpOiAiXQogIHRpdGxlPSJGaXJzdCBHYWJsZSBWZXJnZSBIZWlnaHQ6IG1p
bi4gPiAwLCBtYXguIDwgIittYXhodF9zKyIjQHVuaXRzIgogIHZhbHVlcz1b
QHZlcmdlMV0KICBAdmVyZ2UxLD1pbnB1dGJveChwcm9tcHRzLHZhbHVlcyxb
IiJdLHRpdGxlKQogIEB2ZXJnZTE9QGZhc2NpYSBpZiAhIEB2ZXJnZTEKICB3
aGlsZSBAdmVyZ2UxPm1heGh0IHx8IEB2ZXJnZTE8PTAKICAgIEB2ZXJnZTE9
bWF4aHQKICAgIEB2ZXJnZTEsPWlucHV0Ym94KHByb21wdHMsW0B2ZXJnZTFd
LFsiIl0sdGl0bGUpCiAgZW5kI3doaWxlCiAgIyMjIGRvIGxpbmVzCiAgIyMj
aWYgQGZhc2NpYSE9MAogICAgaWYgQHZlcmdlMTxAZmFzY2lhCgkgIGFkZD1A
ZmFzY2lhLUB2ZXJnZTEKCSAgbG4xPXJvb2ZfZW50aXRpZXMuYWRkX2xpbmUo
W2dlMS54LGdlMS55LGdlMS56K2FkZF0sW2NwMS54LGNwMS55LGNwMS56K29w
cC1AdmVyZ2UxK0BmYXNjaWFdKQogICAgICByb29mX2VudGl0aWVzLmFkZF9s
aW5lKFtnczEueCxnczEueSxnczEueithZGRdLFtjcDEueCxjcDEueSxjcDEu
eitvcHAtQHZlcmdlMStAZmFzY2lhXSkKCWVsc2UKCSAgZGlmZj1AdmVyZ2Ux
LUBmYXNjaWEKCSAgYWRkPWRpZmYvTWF0aDo6dGFuKEBwaXRjaF9yKQoJICBn
ZTE9Z2UxLm9mZnNldChnZWRnZTEubGluZVsxXS5yZXZlcnNlLGFkZCkKCSAg
Z3MxPWdzMS5vZmZzZXQoZ2VkZ2UxLmxpbmVbMV0sYWRkKQoJICBsbjE9cm9v
Zl9lbnRpdGllcy5hZGRfbGluZShbZ2UxLngsZ2UxLnksZ2UxLnpdLFtjcDEu
eCxjcDEueSxjcDEueitvcHAtQHZlcmdlMStAZmFzY2lhXSkKICAgICAgcm9v
Zl9lbnRpdGllcy5hZGRfbGluZShbZ3MxLngsZ3MxLnksZ3MxLnpdLFtjcDEu
eCxjcDEueSxjcDEueitvcHAtQHZlcmdlMStAZmFzY2lhXSkKCWVuZCNpZgog
ICMjI2VuZCNpZgogIGdhYjE9bmlsOyBsbjEuZmFjZXMuZWFjaHt8ZXxnYWIx
PWUgaWYgZS5ib3VuZHMubWF4LnohPXJvb2ZfZ3JvdXAuYm91bmRzLm1heC56
fQogIGdhYjEucHVzaHB1bGwoLUBnYWJsZTEsZmFsc2UpIGlmIGdhYjEKICAj
IyMKZWxzaWYgQGdhYmxlMXR5cGU9PSJWZXJnZSBieSBXaWR0aCIKICBAdmVy
Z2Uxdz1AZmFzY2lhIGlmICEgQHZlcmdlMXcKICBpZiBAdmVyZ2Uxdz09MAog
ICAgQHZlcmdlMXc9NC5pbmNoIGlmIEBtb2RlbC5vcHRpb25zWyJVbml0c09w
dGlvbnMiXVsiTGVuZ3RoVW5pdCJdPDIKICAgIEB2ZXJnZTF3PTEwMC5tbSBp
ZiBAbW9kZWwub3B0aW9uc1siVW5pdHNPcHRpb25zIl1bIkxlbmd0aFVuaXQi
XT4xCiAgZW5kI2lmCiAgdmVydD1AdmVyZ2Uxdy9NYXRoOjpjb3MoQHBpdGNo
X3IpCiAgbWF4aHQ9KChvcHArQGZhc2NpYSkqTWF0aDo6Y29zKEBwaXRjaF9y
KSkudG9fbDttYXhodF9zPW1heGh0LnRvX3MKICBwcm9tcHRzPVsiRmlyc3Qg
R2FibGUgVmVyZ2UgUGVycGVuZGljdWxhciBXaWR0aCAoI0B1bml0cyk6ICJd
CiAgdGl0bGU9IkZpcnN0IEdhYmxlIFZlcmdlOiBtaW4uID4gMCwgbWF4LiA8
ICIrbWF4aHRfcysiI0B1bml0cyIKICB2YWx1ZXM9W0B2ZXJnZTF3XQogIEB2
ZXJnZTF3LD1pbnB1dGJveChwcm9tcHRzLHZhbHVlcyxbIiJdLHRpdGxlKQog
IEB2ZXJnZTF3PUBmYXNjaWEgaWYgISBAdmVyZ2UxdwogIHdoaWxlIEB2ZXJn
ZTF3Pm1heGh0IHx8IEB2ZXJnZTF3PD0wCiAgICBAdmVyZ2Uxdz1tYXhodAog
ICAgQHZlcmdlMXcsPWlucHV0Ym94KHByb21wdHMsW0B2ZXJnZTF3XSxbIiJd
LHRpdGxlKQogIGVuZCN3aGlsZQogICMjIyBkbyBsaW5lcwogIEB2ZXJ0PUB2
ZXJnZTF3L01hdGg6OmNvcyhAcGl0Y2hfcikKICAjIyNpZiBAZmFzY2lhIT0w
CiAgICBpZiBAdmVydDxAZmFzY2lhCgkgIGFkZD1AZmFzY2lhLUB2ZXJ0Cgkg
IGxuMT1yb29mX2VudGl0aWVzLmFkZF9saW5lKFtnZTEueCxnZTEueSxnZTEu
eithZGRdLFtjcDEueCxjcDEueSxjcDEueitvcHAtQHZlcnQrQGZhc2NpYV0p
CiAgICAgIHJvb2ZfZW50aXRpZXMuYWRkX2xpbmUoW2dzMS54LGdzMS55LGdz
MS56K2FkZF0sW2NwMS54LGNwMS55LGNwMS56K29wcC1AdmVydCtAZmFzY2lh
XSkKCWVsc2UKCSAgZGlmZj1AdmVydC1AZmFzY2lhCgkgIGFkZD1kaWZmL01h
dGg6OnRhbihAcGl0Y2hfcikKCSAgZ2UxPWdlMS5vZmZzZXQoZ2VkZ2UxLmxp
bmVbMV0ucmV2ZXJzZSxhZGQpCgkgIGdzMT1nczEub2Zmc2V0KGdlZGdlMS5s
aW5lWzFdLGFkZCkKCSAgbG4xPXJvb2ZfZW50aXRpZXMuYWRkX2xpbmUoW2dl
MS54LGdlMS55LGdlMS56XSxbY3AxLngsY3AxLnksY3AxLnorb3BwLUB2ZXJ0
K0BmYXNjaWFdKQogICAgICByb29mX2VudGl0aWVzLmFkZF9saW5lKFtnczEu
eCxnczEueSxnczEuel0sW2NwMS54LGNwMS55LGNwMS56K29wcC1AdmVydCtA
ZmFzY2lhXSkKCWVuZCNpZgogICMjI2VuZCNpZgogIGdhYjE9bmlsOyBsbjEu
ZmFjZXMuZWFjaHt8ZXxnYWIxPWUgaWYgZS5ib3VuZHMubWF4LnohPXJvb2Zf
Z3JvdXAuYm91bmRzLm1heC56fQogIGdhYjEucHVzaHB1bGwoLUBnYWJsZTEs
ZmFsc2UpIGlmIGdhYjEKICAjIyMKZWxzaWYgQGdhYmxlMXR5cGU9PSJWZXJn
ZSBieSBIZWlnaHQsIHdpdGggRmFzY2lhIgogIEB2ZXJnZTE9QGZhc2NpYSBp
ZiAhIEB2ZXJnZTEKICBpZiBAdmVyZ2UxPT0wCiAgICBAdmVyZ2UxPTQuaW5j
aCBpZiBAbW9kZWwub3B0aW9uc1siVW5pdHNPcHRpb25zIl1bIkxlbmd0aFVu
aXQiXTwyCiAgICBAdmVyZ2UxPTEwMC5tbSBpZiBAbW9kZWwub3B0aW9uc1si
VW5pdHNPcHRpb25zIl1bIkxlbmd0aFVuaXQiXT4xCiAgZW5kI2lmCiAgbWF4
aHQ9KG9wcCtAZmFzY2lhKS50b19sO21heGh0X3M9bWF4aHQudG9fcwogIHBy
b21wdHM9WyJGaXJzdCBHYWJsZSBWZXJnZSBIZWlnaHQgKCNAdW5pdHMpOiAi
XQogIHRpdGxlPSJGaXJzdCBHYWJsZSBWZXJnZSBIZWlnaHQ6IG1pbi4gPiAw
LCBtYXguIDwgIittYXhodF9zKyIjQHVuaXRzIgogIHZhbHVlcz1bQHZlcmdl
MV0KICBAdmVyZ2UxLD1pbnB1dGJveChwcm9tcHRzLHZhbHVlcyxbIiJdLHRp
dGxlKQogIEB2ZXJnZTE9QGZhc2NpYSBpZiAhIEB2ZXJnZTEKICB3aGlsZSBA
dmVyZ2UxPm1heGh0IHx8IEB2ZXJnZTE8PTAKICAgIEB2ZXJnZTE9bWF4aHQK
ICAgIEB2ZXJnZTEsPWlucHV0Ym94KHByb21wdHMsW0B2ZXJnZTFdLFsiIl0s
dGl0bGUpCiAgZW5kI3doaWxlCiAgIyMjIGRvIGxpbmVzLi4uCiAgIyMjIGdl
dCBAcmlzZSBvbiBlYXZlcyBvdmVyIHNvZmZpdCBhdCBhbmdsZQogIEBpbnNl
dD1AdmVyZ2UxL01hdGg6OnRhbihAcGl0Y2hfcikKICBnZTE9Z2UxLm9mZnNl
dChnZWRnZTEubGluZVsxXS5yZXZlcnNlLEBpbnNldCkKICBnczE9Z3MxLm9m
ZnNldChnZWRnZTEubGluZVsxXSxAaW5zZXQpCiAgbG5BPXJvb2ZfZW50aXRp
ZXMuYWRkX2xpbmUoW2dlMS54LGdlMS55LGdlMS56K0BmYXNjaWFdLFtjcDEu
eCxjcDEueSxjcDEueitvcHArQGZhc2NpYS1AdmVyZ2UxXSkKICBsbkI9cm9v
Zl9lbnRpdGllcy5hZGRfbGluZShbY3AxLngsY3AxLnksY3AxLnorb3BwK0Bm
YXNjaWEtQHZlcmdlMV0sW2dzMS54LGdzMS55LGdzMS56K0BmYXNjaWFdKQog
IGxuQz1yb29mX2VudGl0aWVzLmFkZF9saW5lKFtnczEueCxnczEueSxnczEu
eitAZmFzY2lhXSxbZ2UxLngsZ2UxLnksZ2UxLnorQGZhc2NpYV0pCiAgZ2Fi
MT1yb29mX2VudGl0aWVzLmFkZF9mYWNlKGxuQSxsbkIsbG5DKQogIGdhYjEu
cHVzaHB1bGwoLUBnYWJsZTEsZmFsc2UpIGlmIGdhYjEKICAjIyMKZWxzaWYg
QGdhYmxlMXR5cGU9PSJWZXJnZSBieSBXaWR0aCwgd2l0aCBGYXNjaWEiCiAg
QHZlcmdlMXc9QGZhc2NpYSBpZiAhIEB2ZXJnZTF3CiAgaWYgQHZlcmdlMXc9
PTAKICAgIEB2ZXJnZTF3PTQuaW5jaCBpZiBAbW9kZWwub3B0aW9uc1siVW5p
dHNPcHRpb25zIl1bIkxlbmd0aFVuaXQiXTwyCiAgICBAdmVyZ2Uxdz0xMDAu
bW0gaWYgQG1vZGVsLm9wdGlvbnNbIlVuaXRzT3B0aW9ucyJdWyJMZW5ndGhV
bml0Il0+MQogIGVuZCNpZgogIHZlcnQ9QHZlcmdlMXcvTWF0aDo6Y29zKEBw
aXRjaF9yKQogIEByaXNlPU1hdGg6OnRhbihAcGl0Y2hfcikqQGVhdmVzCiAg
bWF4aHQ9KChAcmlzZStAZmFzY2lhKSpNYXRoOjpjb3MoQHBpdGNoX3IpKS50
b19sO21heGh0X3M9bWF4aHQudG9fcwogIHByb21wdHM9WyJGaXJzdCBHYWJs
ZSBWZXJnZSBQZXJwZW5kaWN1bGFyIFdpZHRoICgjQHVuaXRzKTogIl0KICB0
aXRsZT0iRmlyc3QgR2FibGUgVmVyZ2U6IG1pbi4gPiAwLCBtYXguIDwgIitt
YXhodF9zKyIjQHVuaXRzIgogIHZhbHVlcz1bQHZlcmdlMXddCiAgQHZlcmdl
MXcsPWlucHV0Ym94KHByb21wdHMsdmFsdWVzLFsiIl0sdGl0bGUpCiAgQHZl
cmdlMXc9QGZhc2NpYSBpZiAhIEB2ZXJnZTF3CiAgd2hpbGUgQHZlcmdlMXc+
bWF4aHQgfHwgQHZlcmdlMXc8PTAKICAgIEB2ZXJnZTF3PW1heGh0CiAgICBA
dmVyZ2Uxdyw9aW5wdXRib3gocHJvbXB0cyxbQHZlcmdlMXddLFsiIl0sdGl0
bGUpCiAgZW5kI3doaWxlCiAgIyMjIGRvIGxpbmVzCiAgQHZlcnQ9QHZlcmdl
MXcvTWF0aDo6Y29zKEBwaXRjaF9yKQogIEBpbnNldD1AdmVyZ2Uxdy9NYXRo
OjpzaW4oQHBpdGNoX3IpCiAgZ2UxPWdlMS5vZmZzZXQoZ2VkZ2UxLmxpbmVb
MV0ucmV2ZXJzZSxAaW5zZXQpCiAgZ3MxPWdzMS5vZmZzZXQoZ2VkZ2UxLmxp
bmVbMV0sQGluc2V0KQogIGxuQT1yb29mX2VudGl0aWVzLmFkZF9saW5lKFtn
ZTEueCxnZTEueSxnZTEueitAZmFzY2lhXSxbY3AxLngsY3AxLnksY3AxLnor
b3BwK0BmYXNjaWEtQHZlcnRdKQogIGxuQj1yb29mX2VudGl0aWVzLmFkZF9s
aW5lKFtjcDEueCxjcDEueSxjcDEueitvcHArQGZhc2NpYS1AdmVydF0sW2dz
MS54LGdzMS55LGdzMS56K0BmYXNjaWFdKQogIGxuQz1yb29mX2VudGl0aWVz
LmFkZF9saW5lKFtnczEueCxnczEueSxnczEueitAZmFzY2lhXSxbZ2UxLngs
Z2UxLnksZ2UxLnorQGZhc2NpYV0pCiAgZ2FiMT1yb29mX2VudGl0aWVzLmFk
ZF9mYWNlKGxuQSxsbkIsbG5DKQogIGdhYjEucHVzaHB1bGwoLUBnYWJsZTEs
ZmFsc2UpIGlmIGdhYjEKICAjIyMKZWxzaWYgQGdhYmxlMXR5cGU9PSJWZXJn
ZSB3aXRoIEZhc2NpYSBbQWxsIEVxdWFsXSIjIyN8fHx8fHx8fHx8fHx8fHx8
fHx8fHx8fHx8CiAgdmVydGk9QGZhc2NpYS9NYXRoOjpjb3MoQHBpdGNoX3Ip
CiAgaW5zZXQ9dmVydGkvTWF0aDo6dGFuKEBwaXRjaF9yKQogIGdlMT1nZTEu
b2Zmc2V0KGdlZGdlMS5saW5lWzFdLnJldmVyc2UsaW5zZXQpCiAgZ3MxPWdz
MS5vZmZzZXQoZ2VkZ2UxLmxpbmVbMV0saW5zZXQpCiAgbG5BPXJvb2ZfZW50
aXRpZXMuYWRkX2xpbmUoW2dlMS54LGdlMS55LGdlMS56K0BmYXNjaWFdLFtj
cDEueCxjcDEueSxjcDEueitvcHArQGZhc2NpYS12ZXJ0aV0pCiAgbG5CPXJv
b2ZfZW50aXRpZXMuYWRkX2xpbmUoW2NwMS54LGNwMS55LGNwMS56K29wcCtA
ZmFzY2lhLXZlcnRpXSxbZ3MxLngsZ3MxLnksZ3MxLnorQGZhc2NpYV0pCiAg
bG5DPXJvb2ZfZW50aXRpZXMuYWRkX2xpbmUoW2dzMS54LGdzMS55LGdzMS56
K0BmYXNjaWFdLFtnZTEueCxnZTEueSxnZTEueitAZmFzY2lhXSkKICBnYWIx
PXJvb2ZfZW50aXRpZXMuYWRkX2ZhY2UobG5BLGxuQixsbkMpCiAgZ2FiMS5w
dXNocHVsbCgtQGdhYmxlMSxmYWxzZSkgaWYgZ2FiMQogICMjIwplbHNpZiBA
Z2FibGUxdHlwZT09IlZlcmdlIGJ5IEhlaWdodCwgd2l0aCBCb3gtRWF2ZXMi
CiAgQHZlcmdlMT1AZmFzY2lhIGlmICEgQHZlcmdlMQogIGlmIEB2ZXJnZTE9
PTAKICAgIEB2ZXJnZTE9NC5pbmNoIGlmIEBtb2RlbC5vcHRpb25zWyJVbml0
c09wdGlvbnMiXVsiTGVuZ3RoVW5pdCJdPDIKICAgIEB2ZXJnZTE9MTAwLm1t
IGlmIEBtb2RlbC5vcHRpb25zWyJVbml0c09wdGlvbnMiXVsiTGVuZ3RoVW5p
dCJdPjEKICBlbmQjaWYKICBtYXhodD0ob3BwK0BmYXNjaWEpLnRvX2w7bWF4
aHRfcz1tYXhodC50b19zCiAgcHJvbXB0cz1bIkZpcnN0IEdhYmxlIFZlcmdl
IEhlaWdodCAoI0B1bml0cyk6ICJdCiAgdGl0bGU9IkZpcnN0IEdhYmxlIFZl
cmdlIEhlaWdodDogbWluLiA+IDAsIG1heC4gPCAiK21heGh0X3MrIiNAdW5p
dHMiCiAgdmFsdWVzPVtAdmVyZ2UxXQogIEB2ZXJnZTEsPWlucHV0Ym94KHBy
b21wdHMsdmFsdWVzLFsiIl0sdGl0bGUpCiAgQHZlcmdlMT1AZmFzY2lhIGlm
ICEgQHZlcmdlMQogIHdoaWxlIEB2ZXJnZTE+bWF4aHQgfHwgQHZlcmdlMTw9
MAogICAgQHZlcmdlMT1tYXhodAogICAgQHZlcmdlMSw9aW5wdXRib3gocHJv
bXB0cyxbQHZlcmdlMV0sWyIiXSx0aXRsZSkKICBlbmQjd2hpbGUKICAjIyMg
ZG8gbGluZXMuLi4KICAjIyMgZ2V0IEByaXNlIG9uIGVhdmVzIG92ZXIgc29m
Zml0IGF0IGFuZ2xlCiAgQHJpc2U9TWF0aDo6dGFuKEBwaXRjaF9yKSpAZWF2
ZXMKICBnZTE9Z2UxLm9mZnNldChnZWRnZTEubGluZVsxXS5yZXZlcnNlLEBl
YXZlcykKICBnczE9Z3MxLm9mZnNldChnZWRnZTEubGluZVsxXSxAZWF2ZXMp
CiAgcm9vZl9lbnRpdGllcy5hZGRfbGluZShnZTEsW2dlMS54LGdlMS55LGdl
MS56K0ByaXNlK0BmYXNjaWEtQHZlcmdlMV0pCiAgbG4xPXJvb2ZfZW50aXRp
ZXMuYWRkX2xpbmUoW2dlMS54LGdlMS55LGdlMS56K0ByaXNlK0BmYXNjaWEt
QHZlcmdlMV0sW2NwMS54LGNwMS55LGNwMS56K29wcCtAZmFzY2lhLUB2ZXJn
ZTFdKQogIHJvb2ZfZW50aXRpZXMuYWRkX2xpbmUoW2NwMS54LGNwMS55LGNw
MS56K29wcCtAZmFzY2lhLUB2ZXJnZTFdLFtnczEueCxnczEueSxnczEueitA
cmlzZStAZmFzY2lhLUB2ZXJnZTFdKQogIHJvb2ZfZW50aXRpZXMuYWRkX2xp
bmUoW2dzMS54LGdzMS55LGdzMS56K0ByaXNlK0BmYXNjaWEtQHZlcmdlMV0s
Z3MxKQogIGdhYjE9bmlsOyBsbjEuZmFjZXMuZWFjaHt8ZXwKICAgIGdhYjE9
ZSBpZiBlLmJvdW5kcy5tYXgueiE9cm9vZl9ncm91cC5ib3VuZHMubWF4LnoK
ICB9CiAgZ2FiMS5wdXNocHVsbCgtQGdhYmxlMSxmYWxzZSkgaWYgZ2FiMQog
ICMjIwplbHNpZiBAZ2FibGUxdHlwZT09IlZlcmdlIGJ5IFdpZHRoLCB3aXRo
IEJveC1FYXZlcyIKICBAdmVyZ2Uxdz1AZmFzY2lhIGlmICEgQHZlcmdlMXcK
ICBpZiBAdmVyZ2Uxdz09MAogICAgQHZlcmdlMXc9NC5pbmNoIGlmIEBtb2Rl
bC5vcHRpb25zWyJVbml0c09wdGlvbnMiXVsiTGVuZ3RoVW5pdCJdPDIKICAg
IEB2ZXJnZTF3PTEwMC5tbSBpZiBAbW9kZWwub3B0aW9uc1siVW5pdHNPcHRp
b25zIl1bIkxlbmd0aFVuaXQiXT4xCiAgZW5kI2lmCiAgdmVydD1AdmVyZ2Ux
dy9NYXRoOjpjb3MoQHBpdGNoX3IpCiAgQHJpc2U9TWF0aDo6dGFuKEBwaXRj
aF9yKSpAZWF2ZXMKICBtYXhodD0oKEByaXNlK0BmYXNjaWEpKk1hdGg6OmNv
cyhAcGl0Y2hfcikpLnRvX2w7bWF4aHRfcz1tYXhodC50b19zCiAgcHJvbXB0
cz1bIkZpcnN0IEdhYmxlIFZlcmdlIFBlcnBlbmRpY3VsYXIgV2lkdGggKCNA
dW5pdHMpOiAiXQogIHRpdGxlPSJGaXJzdCBHYWJsZSBWZXJnZTogbWluLiA+
IDAsIG1heC4gPCAiK21heGh0X3MrIiNAdW5pdHMiCiAgdmFsdWVzPVtAdmVy
Z2Uxd10KICBAdmVyZ2Uxdyw9aW5wdXRib3gocHJvbXB0cyx2YWx1ZXMsWyIi
XSx0aXRsZSkKICBAdmVyZ2Uxdz1AZmFzY2lhIGlmICEgQHZlcmdlMXcKICB3
aGlsZSBAdmVyZ2Uxdz5tYXhodCB8fCBAdmVyZ2Uxdzw9MAogICAgQHZlcmdl
MXc9bWF4aHQKICAgIEB2ZXJnZTF3LD1pbnB1dGJveChwcm9tcHRzLFtAdmVy
Z2Uxd10sWyIiXSx0aXRsZSkKICBlbmQjd2hpbGUKICAjIyMgZG8gbGluZXMK
ICBAdmVydD1AdmVyZ2Uxdy9NYXRoOjpjb3MoQHBpdGNoX3IpCiAgZ2UxPWdl
MS5vZmZzZXQoZ2VkZ2UxLmxpbmVbMV0ucmV2ZXJzZSxAZWF2ZXMpCiAgZ3Mx
PWdzMS5vZmZzZXQoZ2VkZ2UxLmxpbmVbMV0sQGVhdmVzKQogIHJvb2ZfZW50
aXRpZXMuYWRkX2xpbmUoZ2UxLFtnZTEueCxnZTEueSxnZTEueitAcmlzZStA
ZmFzY2lhLUB2ZXJ0XSkKICBsbjE9cm9vZl9lbnRpdGllcy5hZGRfbGluZShb
Z2UxLngsZ2UxLnksZ2UxLnorQHJpc2UrQGZhc2NpYS1AdmVydF0sW2NwMS54
LGNwMS55LGNwMS56K29wcCtAZmFzY2lhLUB2ZXJ0XSkKICByb29mX2VudGl0
aWVzLmFkZF9saW5lKFtjcDEueCxjcDEueSxjcDEueitvcHArQGZhc2NpYS1A
dmVydF0sW2dzMS54LGdzMS55LGdzMS56K0ByaXNlK0BmYXNjaWEtQHZlcnRd
KQogIHJvb2ZfZW50aXRpZXMuYWRkX2xpbmUoW2dzMS54LGdzMS55LGdzMS56
K0ByaXNlK0BmYXNjaWEtQHZlcnRdLGdzMSkKICBnYWIxPW5pbDsgbG4xLmZh
Y2VzLmVhY2h7fGV8CiAgICBnYWIxPWUgaWYgZS5ib3VuZHMubWF4LnohPXJv
b2ZfZ3JvdXAuYm91bmRzLm1heC56CiAgfQogIGdhYjEucHVzaHB1bGwoLUBn
YWJsZTEsZmFsc2UpIGlmIGdhYjEKZW5kI2lmCiMjIyMjIyMjIyMjIyMjIE5P
VyBmb3IgZ2FibGUgMiAjIyMjIyMjIyMjIyMjLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLQppZiBAZ2FibGUydHlwZT09IlZlcmdlIGZyb20gRmFzY2lh
IgogIGxuMj1yb29mX2VudGl0aWVzLmFkZF9saW5lKGdlMixbY3AyLngsY3Ay
LnksY3AyLnorb3BwXSkKICByb29mX2VudGl0aWVzLmFkZF9saW5lKFtjcDIu
eCxjcDIueSxjcDIueitvcHBdLGdzMikKICBnYWIyPW5pbDsgbG4yLmZhY2Vz
LmVhY2h7fGV8CiAgICBnYWIyPWUgaWYgZS5ib3VuZHMubWF4LnohPXJvb2Zf
Z3JvdXAuYm91bmRzLm1heC56CiAgfQogIGdhYjIucHVzaHB1bGwoLUBnYWJs
ZTIsZmFsc2UpIGlmIGdhYjIKZWxzaWYgQGdhYmxlMnR5cGU9PSJWZXJnZSBm
cm9tIFNvZmZpdCIKICBAcmlzZT1NYXRoOjp0YW4oQHBpdGNoX3IpKkBlYXZl
cwogIGdlMj1nZTIub2Zmc2V0KGdlZGdlMi5saW5lWzFdLnJldmVyc2UsQGVh
dmVzKQogIGdzMj1nczIub2Zmc2V0KGdlZGdlMi5saW5lWzFdLEBlYXZlcykK
ICBsbjI9cm9vZl9lbnRpdGllcy5hZGRfbGluZShnZTIsW2NwMi54LGNwMi55
LGNwMi56K29wcC1AcmlzZV0pCiAgcm9vZl9lbnRpdGllcy5hZGRfbGluZShb
Y3AyLngsY3AyLnksY3AyLnorb3BwLUByaXNlXSxnczIpCiAgZ2FiMj1uaWw7
IGxuMi5mYWNlcy5lYWNoe3xlfAogICAgZ2FiMj1lIGlmIGUuYm91bmRzLm1h
eC56IT1yb29mX2dyb3VwLmJvdW5kcy5tYXguegogIH0KICBnYWIyLnB1c2hw
dWxsKC1AZ2FibGUyLGZhbHNlKSBpZiBnYWIyCiMjI1ZlcmdlIGJ5IEhlaWdo
dHxWZXJnZSBieSBXaWR0aHxWZXJnZSBieSBIZWlnaHQsIHdpdGggRmFzY2lh
fFZlcmdlIGJ5IFdpZHRoLCB3aXRoIEZhc2NpYXxWZXJnZSBieSBIZWlnaHQs
IHdpdGggQm94LUVhdmVzfFZlcmdlIGJ5IFdpZHRoLCB3aXRoIEJveC1FYXZl
cwplbHNpZiBAZ2FibGUydHlwZT09IlZlcmdlIGJ5IEhlaWdodCIKICBAdmVy
Z2UyPUBmYXNjaWEgaWYgISBAdmVyZ2UyCiAgaWYgQHZlcmdlMj09MAogICAg
QHZlcmdlMj00LmluY2ggaWYgQG1vZGVsLm9wdGlvbnNbIlVuaXRzT3B0aW9u
cyJdWyJMZW5ndGhVbml0Il08MgogICAgQHZlcmdlMj0xMDAubW0gaWYgQG1v
ZGVsLm9wdGlvbnNbIlVuaXRzT3B0aW9ucyJdWyJMZW5ndGhVbml0Il0+MQog
IGVuZCNpZgogIG1heGh0PShvcHArQGZhc2NpYSkudG9fbDttYXhodF9zPW1h
eGh0LnRvX3MKICBwcm9tcHRzPVsiU2Vjb25kIEdhYmxlIFZlcmdlIEhlaWdo
dCAoI0B1bml0cyk6ICJdCiAgdGl0bGU9IlNlY29uZCBHYWJsZSBWZXJnZSBI
ZWlnaHQ6IG1pbi4gPiAwLCBtYXguIDwgIittYXhodF9zKyIjQHVuaXRzIgog
IHZhbHVlcz1bQHZlcmdlMl0KICBAdmVyZ2UyLD1pbnB1dGJveChwcm9tcHRz
LHZhbHVlcyxbIiJdLHRpdGxlKQogIEB2ZXJnZTI9QGZhc2NpYSBpZiAhIEB2
ZXJnZTIKICB3aGlsZSBAdmVyZ2UyPm1heGh0IHx8IEB2ZXJnZTI8PTAKICAg
IEB2ZXJnZTI9bWF4aHQKICAgIEB2ZXJnZTIsPWlucHV0Ym94KHByb21wdHMs
W0B2ZXJnZTJdLFsiIl0sdGl0bGUpCiAgZW5kI3doaWxlCiAgIyMjIGRvIGxp
bmVzCiAgIyMjaWYgQGZhc2NpYSE9MAogICAgaWYgQHZlcmdlMjxAZmFzY2lh
CgkgIGFkZD1AZmFzY2lhLUB2ZXJnZTIKCSAgbG4yPXJvb2ZfZW50aXRpZXMu
YWRkX2xpbmUoW2dlMi54LGdlMi55LGdlMi56K2FkZF0sW2NwMi54LGNwMi55
LGNwMi56K29wcC1AdmVyZ2UyK0BmYXNjaWFdKQogICAgICByb29mX2VudGl0
aWVzLmFkZF9saW5lKFtnczIueCxnczIueSxnczIueithZGRdLFtjcDIueCxj
cDIueSxjcDIueitvcHAtQHZlcmdlMitAZmFzY2lhXSkKCWVsc2UKCSAgZGlm
Zj1AdmVyZ2UyLUBmYXNjaWEKCSAgYWRkPWRpZmYvTWF0aDo6dGFuKEBwaXRj
aF9yKQoJICBnZTI9Z2UyLm9mZnNldChnZWRnZTIubGluZVsxXS5yZXZlcnNl
LGFkZCkKCSAgZ3MyPWdzMi5vZmZzZXQoZ2VkZ2UyLmxpbmVbMV0sYWRkKQoJ
ICBsbjI9cm9vZl9lbnRpdGllcy5hZGRfbGluZShbZ2UyLngsZ2UyLnksZ2Uy
LnpdLFtjcDIueCxjcDIueSxjcDIueitvcHAtQHZlcmdlMitAZmFzY2lhXSkK
ICAgICAgcm9vZl9lbnRpdGllcy5hZGRfbGluZShbZ3MyLngsZ3MyLnksZ3My
LnpdLFtjcDIueCxjcDIueSxjcDIueitvcHAtQHZlcmdlMitAZmFzY2lhXSkK
CWVuZCNpZgogICMjI2VuZCNpZgogIGdhYjI9bmlsOyBsbjIuZmFjZXMuZWFj
aHt8ZXxnYWIyPWUgaWYgZS5ib3VuZHMubWF4LnohPXJvb2ZfZ3JvdXAuYm91
bmRzLm1heC56fQogIGdhYjIucHVzaHB1bGwoLUBnYWJsZTIsZmFsc2UpIGlm
IGdhYjIKICAjIyMKZWxzaWYgQGdhYmxlMnR5cGU9PSJWZXJnZSBieSBXaWR0
aCIKICBAdmVyZ2Uydz1AZmFzY2lhIGlmICEgQHZlcmdlMncKICBpZiBAdmVy
Z2Uydz09MAogICAgQHZlcmdlMnc9NC5pbmNoIGlmIEBtb2RlbC5vcHRpb25z
WyJVbml0c09wdGlvbnMiXVsiTGVuZ3RoVW5pdCJdPDIKICAgIEB2ZXJnZTJ3
PTEwMC5tbSBpZiBAbW9kZWwub3B0aW9uc1siVW5pdHNPcHRpb25zIl1bIkxl
bmd0aFVuaXQiXT4xCiAgZW5kI2lmCiAgdmVydD1AdmVyZ2Uydy9NYXRoOjpj
b3MoQHBpdGNoX3IpCiAgbWF4aHQ9KChvcHArQGZhc2NpYSkqTWF0aDo6Y29z
KEBwaXRjaF9yKSkudG9fbDttYXhodF9zPW1heGh0LnRvX3MKICBwcm9tcHRz
PVsiU2Vjb25kIEdhYmxlIFZlcmdlIFBlcnBlbmRpY3VsYXIgV2lkdGggKCNA
dW5pdHMpOiAiXQogIHRpdGxlPSJTZWNvbmQgR2FibGUgVmVyZ2U6IG1pbi4g
PiAwLCBtYXguIDwgIittYXhodF9zKyIjQHVuaXRzIgogIHZhbHVlcz1bQHZl
cmdlMnddCiAgQHZlcmdlMncsPWlucHV0Ym94KHByb21wdHMsdmFsdWVzLFsi
Il0sdGl0bGUpCiAgQHZlcmdlMnc9QGZhc2NpYSBpZiAhIEB2ZXJnZTJ3CiAg
d2hpbGUgQHZlcmdlMnc+bWF4aHQgfHwgQHZlcmdlMnc8PTAKICAgIEB2ZXJn
ZTJ3PW1heGh0CiAgICBAdmVyZ2Uydyw9aW5wdXRib3gocHJvbXB0cyxbQHZl
cmdlMnddLFsiIl0sdGl0bGUpCiAgZW5kI3doaWxlCiAgIyMjIGRvIGxpbmVz
CiAgQHZlcnQ9QHZlcmdlMncvTWF0aDo6Y29zKEBwaXRjaF9yKQogICMjI2lm
IEBmYXNjaWEhPTAKICAgIGlmIEB2ZXJ0PEBmYXNjaWEKCSAgYWRkPUBmYXNj
aWEtQHZlcnQKCSAgbG4xPXJvb2ZfZW50aXRpZXMuYWRkX2xpbmUoW2dlMi54
LGdlMi55LGdlMi56K2FkZF0sW2NwMi54LGNwMi55LGNwMi56K29wcC1AdmVy
dCtAZmFzY2lhXSkKICAgICAgcm9vZl9lbnRpdGllcy5hZGRfbGluZShbZ3My
LngsZ3MyLnksZ3MyLnorYWRkXSxbY3AyLngsY3AyLnksY3AyLnorb3BwLUB2
ZXJ0K0BmYXNjaWFdKQoJZWxzZQoJICBkaWZmPUB2ZXJ0LUBmYXNjaWEKCSAg
YWRkPWRpZmYvTWF0aDo6dGFuKEBwaXRjaF9yKQoJICBnZTI9Z2UyLm9mZnNl
dChnZWRnZTIubGluZVsxXS5yZXZlcnNlLGFkZCkKCSAgZ3MyPWdzMi5vZmZz
ZXQoZ2VkZ2UyLmxpbmVbMV0sYWRkKQoJICBsbjI9cm9vZl9lbnRpdGllcy5h
ZGRfbGluZShbZ2UyLngsZ2UyLnksZ2UyLnpdLFtjcDIueCxjcDIueSxjcDIu
eitvcHAtQHZlcnQrQGZhc2NpYV0pCiAgICAgIHJvb2ZfZW50aXRpZXMuYWRk
X2xpbmUoW2dzMi54LGdzMi55LGdzMi56XSxbY3AyLngsY3AyLnksY3AyLnor
b3BwLUB2ZXJ0K0BmYXNjaWFdKQoJZW5kI2lmCiAgIyMjZW5kI2lmCiAgZ2Fi
Mj1uaWw7IGxuMi5mYWNlcy5lYWNoe3xlfGdhYjI9ZSBpZiBlLmJvdW5kcy5t
YXgueiE9cm9vZl9ncm91cC5ib3VuZHMubWF4Lnp9CiAgZ2FiMi5wdXNocHVs
bCgtQGdhYmxlMixmYWxzZSkgaWYgZ2FiMgogICMjIwplbHNpZiBAZ2FibGUy
dHlwZT09IlZlcmdlIGJ5IEhlaWdodCwgd2l0aCBGYXNjaWEiCiAgQHZlcmdl
Mj1AZmFzY2lhIGlmICEgQHZlcmdlMgogIGlmIEB2ZXJnZTI9PTAKICAgIEB2
ZXJnZTI9NC5pbmNoIGlmIEBtb2RlbC5vcHRpb25zWyJVbml0c09wdGlvbnMi
XVsiTGVuZ3RoVW5pdCJdPDIKICAgIEB2ZXJnZTIxPTEwMC5tbSBpZiBAbW9k
ZWwub3B0aW9uc1siVW5pdHNPcHRpb25zIl1bIkxlbmd0aFVuaXQiXT4xCiAg
ZW5kI2lmCiAgbWF4aHQ9KG9wcCtAZmFzY2lhKS50b19sO21heGh0X3M9bWF4
aHQudG9fcwogIHByb21wdHM9WyJTZWNvbmQgR2FibGUgVmVyZ2UgSGVpZ2h0
ICgjQHVuaXRzKTogIl0KICB0aXRsZT0iU2Vjb25kIEdhYmxlIFZlcmdlIEhl
aWdodDogbWluLiA+IDAsIG1heC4gPCAiK21heGh0X3MrIiNAdW5pdHMiCiAg
dmFsdWVzPVtAdmVyZ2UyXQogIEB2ZXJnZTIsPWlucHV0Ym94KHByb21wdHMs
dmFsdWVzLFsiIl0sdGl0bGUpCiAgQHZlcmdlMj1AZmFzY2lhIGlmICEgQHZl
cmdlMgogIHdoaWxlIEB2ZXJnZTI+bWF4aHQgfHwgQHZlcmdlMjw9MAogICAg
QHZlcmdlMj1tYXhodAogICAgQHZlcmdlMiw9aW5wdXRib3gocHJvbXB0cyxb
QHZlcmdlMV0sWyIiXSx0aXRsZSkKICBlbmQjd2hpbGUKICAjIyMgZG8gbGlu
ZXMuLi4KICAjIyMgZ2V0IEByaXNlIG9uIGVhdmVzIG92ZXIgc29mZml0IGF0
IGFuZ2xlCiAgQGluc2V0PUB2ZXJnZTIvTWF0aDo6dGFuKEBwaXRjaF9yKQog
IGdlMj1nZTIub2Zmc2V0KGdlZGdlMi5saW5lWzFdLnJldmVyc2UsQGluc2V0
KQogIGdzMj1nczIub2Zmc2V0KGdlZGdlMi5saW5lWzFdLEBpbnNldCkKICBs
bkE9cm9vZl9lbnRpdGllcy5hZGRfbGluZShbZ2UyLngsZ2UyLnksZ2UyLnor
QGZhc2NpYV0sW2NwMi54LGNwMi55LGNwMi56K29wcCtAZmFzY2lhLUB2ZXJn
ZTJdKQogIGxuQj1yb29mX2VudGl0aWVzLmFkZF9saW5lKFtjcDIueCxjcDIu
eSxjcDIueitvcHArQGZhc2NpYS1AdmVyZ2UyXSxbZ3MyLngsZ3MyLnksZ3My
LnorQGZhc2NpYV0pCiAgbG5DPXJvb2ZfZW50aXRpZXMuYWRkX2xpbmUoW2dz
Mi54LGdzMi55LGdzMi56K0BmYXNjaWFdLFtnZTIueCxnZTIueSxnZTIueitA
ZmFzY2lhXSkKICBnYWIyPXJvb2ZfZW50aXRpZXMuYWRkX2ZhY2UobG5BLGxu
QixsbkMpCiAgZ2FiMi5wdXNocHVsbCgtQGdhYmxlMixmYWxzZSkgaWYgZ2Fi
MgogICMjIwplbHNpZiBAZ2FibGUydHlwZT09IlZlcmdlIGJ5IFdpZHRoLCB3
aXRoIEZhc2NpYSIKICBAdmVyZ2Uydz1AZmFzY2lhIGlmICEgQHZlcmdlMncK
ICBpZiBAdmVyZ2Uydz09MAogICAgQHZlcmdlMnc9NC5pbmNoIGlmIEBtb2Rl
bC5vcHRpb25zWyJVbml0c09wdGlvbnMiXVsiTGVuZ3RoVW5pdCJdPDIKICAg
IEB2ZXJnZTJ3PTEwMC5tbSBpZiBAbW9kZWwub3B0aW9uc1siVW5pdHNPcHRp
b25zIl1bIkxlbmd0aFVuaXQiXT4xCiAgZW5kI2lmCiAgdmVydD1AdmVyZ2Uy
dy9NYXRoOjpjb3MoQHBpdGNoX3IpCiAgQHJpc2U9TWF0aDo6dGFuKEBwaXRj
aF9yKSpAZWF2ZXMKICBtYXhodD0oKEByaXNlK0BmYXNjaWEpKk1hdGg6OmNv
cyhAcGl0Y2hfcikpLnRvX2w7bWF4aHRfcz1tYXhodC50b19zCiAgcHJvbXB0
cz1bIlNlY29uZCBHYWJsZSBWZXJnZSBQZXJwZW5kaWN1bGFyIFdpZHRoICgj
QHVuaXRzKTogIl0KICB0aXRsZT0iU2Vjb25kIEdhYmxlIFZlcmdlOiBtaW4u
ID4gMCwgbWF4LiA8ICIrbWF4aHRfcysiI0B1bml0cyIKICB2YWx1ZXM9W0B2
ZXJnZTJ3XQogIEB2ZXJnZTJ3LD1pbnB1dGJveChwcm9tcHRzLHZhbHVlcyxb
IiJdLHRpdGxlKQogIEB2ZXJnZTJ3PUBmYXNjaWEgaWYgISBAdmVyZ2Uydwog
IHdoaWxlIEB2ZXJnZTJ3Pm1heGh0IHx8IEB2ZXJnZTJ3PD0wCiAgICBAdmVy
Z2Uydz1tYXhodAogICAgQHZlcmdlMncsPWlucHV0Ym94KHByb21wdHMsW0B2
ZXJnZTJ3XSxbIiJdLHRpdGxlKQogIGVuZCN3aGlsZQogICMjIyBkbyBsaW5l
cwogIEB2ZXJ0PUB2ZXJnZTJ3L01hdGg6OmNvcyhAcGl0Y2hfcikKICBAaW5z
ZXQ9QHZlcmdlMncvTWF0aDo6c2luKEBwaXRjaF9yKQogIGdlMj1nZTIub2Zm
c2V0KGdlZGdlMi5saW5lWzFdLnJldmVyc2UsQGluc2V0KQogIGdzMj1nczIu
b2Zmc2V0KGdlZGdlMi5saW5lWzFdLEBpbnNldCkKICBsbkE9cm9vZl9lbnRp
dGllcy5hZGRfbGluZShbZ2UyLngsZ2UyLnksZ2UyLnorQGZhc2NpYV0sW2Nw
Mi54LGNwMi55LGNwMi56K29wcCtAZmFzY2lhLUB2ZXJ0XSkKICBsbkI9cm9v
Zl9lbnRpdGllcy5hZGRfbGluZShbY3AyLngsY3AyLnksY3AyLnorb3BwK0Bm
YXNjaWEtQHZlcnRdLFtnczIueCxnczIueSxnczIueitAZmFzY2lhXSkKICBs
bkM9cm9vZl9lbnRpdGllcy5hZGRfbGluZShbZ3MyLngsZ3MyLnksZ3MyLnor
QGZhc2NpYV0sW2dlMi54LGdlMi55LGdlMi56K0BmYXNjaWFdKQogIGdhYjI9
cm9vZl9lbnRpdGllcy5hZGRfZmFjZShsbkEsbG5CLGxuQykKICBnYWIyLnB1
c2hwdWxsKC1AZ2FibGUyLGZhbHNlKSBpZiBnYWIyCiAgIyMjCmVsc2lmIEBn
YWJsZTJ0eXBlPT0iVmVyZ2Ugd2l0aCBGYXNjaWEgW0FsbCBFcXVhbF0iIyMj
fHx8fHx8fHx8fHx8fHx8fHx8fHx8fHx8fAogIHZlcnRpPUBmYXNjaWEvTWF0
aDo6Y29zKEBwaXRjaF9yKQogIGluc2V0PXZlcnRpL01hdGg6OnRhbihAcGl0
Y2hfcikKICBnZTI9Z2UyLm9mZnNldChnZWRnZTIubGluZVsxXS5yZXZlcnNl
LGluc2V0KQogIGdzMj1nczIub2Zmc2V0KGdlZGdlMi5saW5lWzFdLGluc2V0
KQogIGxuQT1yb29mX2VudGl0aWVzLmFkZF9saW5lKFtnZTIueCxnZTIueSxn
ZTIueitAZmFzY2lhXSxbY3AyLngsY3AyLnksY3AyLnorb3BwK0BmYXNjaWEt
dmVydGldKQogIGxuQj1yb29mX2VudGl0aWVzLmFkZF9saW5lKFtjcDIueCxj
cDIueSxjcDIueitvcHArQGZhc2NpYS12ZXJ0aV0sW2dzMi54LGdzMi55LGdz
Mi56K0BmYXNjaWFdKQogIGxuQz1yb29mX2VudGl0aWVzLmFkZF9saW5lKFtn
czIueCxnczIueSxnczIueitAZmFzY2lhXSxbZ2UyLngsZ2UyLnksZ2UyLnor
QGZhc2NpYV0pCiAgZ2FiMj1yb29mX2VudGl0aWVzLmFkZF9mYWNlKGxuQSxs
bkIsbG5DKQogIGdhYjIucHVzaHB1bGwoLUBnYWJsZTIsZmFsc2UpIGlmIGdh
YjIKICAjIyMKZWxzaWYgQGdhYmxlMnR5cGU9PSJWZXJnZSBieSBIZWlnaHQs
IHdpdGggQm94LUVhdmVzIgogIEB2ZXJnZTI9QGZhc2NpYSBpZiAhIEB2ZXJn
ZTIKICBpZiBAdmVyZ2UyPT0wCiAgICBAdmVyZ2UyPTQuaW5jaCBpZiBAbW9k
ZWwub3B0aW9uc1siVW5pdHNPcHRpb25zIl1bIkxlbmd0aFVuaXQiXTwyCiAg
ICBAdmVyZ2UyPTEwMC5tbSBpZiBAbW9kZWwub3B0aW9uc1siVW5pdHNPcHRp
b25zIl1bIkxlbmd0aFVuaXQiXT4xCiAgZW5kI2lmCiAgbWF4aHQ9KG9wcCtA
ZmFzY2lhKS50b19sO21heGh0X3M9bWF4aHQudG9fcwogIHByb21wdHM9WyJT
ZWNvbmQgR2FibGUgVmVyZ2UgSGVpZ2h0ICgjQHVuaXRzKTogIl0KICB0aXRs
ZT0iU2Vjb25kIEdhYmxlIFZlcmdlIEhlaWdodDogbWluLiA+IDAsIG1heC4g
PCAiK21heGh0X3MrIiNAdW5pdHMiCiAgdmFsdWVzPVtAdmVyZ2UyXQogIEB2
ZXJnZTIsPWlucHV0Ym94KHByb21wdHMsdmFsdWVzLFsiIl0sdGl0bGUpCiAg
QHZlcmdlMj1AZmFzY2lhIGlmICEgQHZlcmdlMgogIHdoaWxlIEB2ZXJnZTI+
bWF4aHQgfHwgQHZlcmdlMjw9MAogICAgQHZlcmdlMj1tYXhodAogICAgQHZl
cmdlMiw9aW5wdXRib3gocHJvbXB0cyxbQHZlcmdlMl0sWyIiXSx0aXRsZSkK
ICBlbmQjd2hpbGUKICAjIyMgZG8gbGluZXMuLi4KICAjIyMgZ2V0IEByaXNl
IG9uIGVhdmVzIG92ZXIgc29mZml0IGF0IGFuZ2xlCiAgQHJpc2U9TWF0aDo6
dGFuKEBwaXRjaF9yKSpAZWF2ZXMKICBnZTI9Z2UyLm9mZnNldChnZWRnZTIu
bGluZVsxXS5yZXZlcnNlLEBlYXZlcykKICBnczI9Z3MyLm9mZnNldChnZWRn
ZTIubGluZVsxXSxAZWF2ZXMpCiAgcm9vZl9lbnRpdGllcy5hZGRfbGluZShn
ZTIsW2dlMi54LGdlMi55LGdlMi56K0ByaXNlK0BmYXNjaWEtQHZlcmdlMl0p
CiAgbG4yPXJvb2ZfZW50aXRpZXMuYWRkX2xpbmUoW2dlMi54LGdlMi55LGdl
Mi56K0ByaXNlK0BmYXNjaWEtQHZlcmdlMl0sW2NwMi54LGNwMi55LGNwMi56
K29wcCtAZmFzY2lhLUB2ZXJnZTJdKQogIHJvb2ZfZW50aXRpZXMuYWRkX2xp
bmUoW2NwMi54LGNwMi55LGNwMi56K29wcCtAZmFzY2lhLUB2ZXJnZTJdLFtn
czIueCxnczIueSxnczIueitAcmlzZStAZmFzY2lhLUB2ZXJnZTJdKQogIHJv
b2ZfZW50aXRpZXMuYWRkX2xpbmUoW2dzMi54LGdzMi55LGdzMi56K0ByaXNl
K0BmYXNjaWEtQHZlcmdlMl0sZ3MyKQogIGdhYjI9bmlsOyBsbjIuZmFjZXMu
ZWFjaHt8ZXwKICAgIGdhYjI9ZSBpZiBlLmJvdW5kcy5tYXgueiE9cm9vZl9n
cm91cC5ib3VuZHMubWF4LnoKICB9CiAgZ2FiMi5wdXNocHVsbCgtQGdhYmxl
MixmYWxzZSkgaWYgZ2FiMgogICMjIwplbHNpZiBAZ2FibGUydHlwZT09IlZl
cmdlIGJ5IFdpZHRoLCB3aXRoIEJveC1FYXZlcyIKICBAdmVyZ2Uydz1AZmFz
Y2lhIGlmICEgQHZlcmdlMncKICBpZiBAdmVyZ2Uydz09MAogICAgQHZlcmdl
Mnc9NC5pbmNoIGlmIEBtb2RlbC5vcHRpb25zWyJVbml0c09wdGlvbnMiXVsi
TGVuZ3RoVW5pdCJdPDIKICAgIEB2ZXJnZTJ3PTEwMC5tbSBpZiBAbW9kZWwu
b3B0aW9uc1siVW5pdHNPcHRpb25zIl1bIkxlbmd0aFVuaXQiXT4xCiAgZW5k
I2lmCiAgdmVydD1AdmVyZ2Uydy9NYXRoOjpjb3MoQHBpdGNoX3IpCiAgQHJp
c2U9TWF0aDo6dGFuKEBwaXRjaF9yKSpAZWF2ZXMKICBtYXhodD0oKEByaXNl
K0BmYXNjaWEpKk1hdGg6OmNvcyhAcGl0Y2hfcikpLnRvX2w7bWF4aHRfcz1t
YXhodC50b19zCiAgcHJvbXB0cz1bIlNlY29uZCBHYWJsZSBWZXJnZSBQZXJw
ZW5kaWN1bGFyIFdpZHRoICgjQHVuaXRzKTogIl0KICB0aXRsZT0iU2Vjb25k
IEdhYmxlIFZlcmdlOiBtaW4uID4gMCwgbWF4LiA8ICIrbWF4aHRfcysiI0B1
bml0cyIKICB2YWx1ZXM9W0B2ZXJnZTJ3XQogIEB2ZXJnZTJ3LD1pbnB1dGJv
eChwcm9tcHRzLHZhbHVlcyxbIiJdLHRpdGxlKQogIEB2ZXJnZTJ3PUBmYXNj
aWEgaWYgISBAdmVyZ2UydwogIHdoaWxlIEB2ZXJnZTJ3Pm1heGh0IHx8IEB2
ZXJnZTJ3PD0wCiAgICBAdmVyZ2Uydz1tYXhodAogICAgQHZlcmdlMncsPWlu
cHV0Ym94KHByb21wdHMsW0B2ZXJnZTJ3XSxbIiJdLHRpdGxlKQogIGVuZCN3
aGlsZQogICMjIyBkbyBsaW5lcwogIEB2ZXJ0PUB2ZXJnZTJ3L01hdGg6OmNv
cyhAcGl0Y2hfcikKICBnZTI9Z2UyLm9mZnNldChnZWRnZTIubGluZVsxXS5y
ZXZlcnNlLEBlYXZlcykKICBnczI9Z3MyLm9mZnNldChnZWRnZTIubGluZVsx
XSxAZWF2ZXMpCiAgcm9vZl9lbnRpdGllcy5hZGRfbGluZShnZTIsW2dlMi54
LGdlMi55LGdlMi56K0ByaXNlK0BmYXNjaWEtQHZlcnRdKQogIGxuMj1yb29m
X2VudGl0aWVzLmFkZF9saW5lKFtnZTIueCxnZTIueSxnZTIueitAcmlzZStA
ZmFzY2lhLUB2ZXJ0XSxbY3AyLngsY3AyLnksY3AyLnorb3BwK0BmYXNjaWEt
QHZlcnRdKQogIHJvb2ZfZW50aXRpZXMuYWRkX2xpbmUoW2NwMi54LGNwMi55
LGNwMi56K29wcCtAZmFzY2lhLUB2ZXJ0XSxbZ3MyLngsZ3MyLnksZ3MyLnor
QHJpc2UrQGZhc2NpYS1AdmVydF0pCiAgcm9vZl9lbnRpdGllcy5hZGRfbGlu
ZShbZ3MyLngsZ3MyLnksZ3MyLnorQHJpc2UrQGZhc2NpYS1AdmVydF0sZ3My
KQogIGdhYjI9bmlsOyBsbjIuZmFjZXMuZWFjaHt8ZXwKICAgIGdhYjI9ZSBp
ZiBlLmJvdW5kcy5tYXgueiE9cm9vZl9ncm91cC5ib3VuZHMubWF4LnoKICB9
CiAgZ2FiMi5wdXNocHVsbCgtQGdhYmxlMixmYWxzZSkgaWYgZ2FiMgogICMj
IwplbmQjaWYKIyMjIGVuZCBtYWtpbmcgdmVyZ2VzLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tCiMjIyBtYWtl
IGhvbGUgaW4gYmFzZS4uLgppZmFjZT1yb29mX2VudGl0aWVzLmFkZF9mYWNl
KG9wb2ludHMpCmlmYWNlLmVyYXNlISBpZiBpZmFjZS52YWxpZD8KIyMjCiMj
IyBOT1cgc29ydCBvdXQgZmFjZSBiaXRzIGZvciB0aGVpciBtYXRlcmlhbHMt
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLQpzb2ZmaXRzPVtdO3Nsb3Blcz1b
XTt2ZXJ0aWNhbHM9W10Kcm9vZl9lbnRpdGllcy5lYWNoe3xlfAogIGlmIGUu
dHlwZW5hbWU9PSJGYWNlIgogICAgc29mZml0cy5wdXNoKGUpIGlmIGUubm9y
bWFsLm5vcm1hbGl6ZS56IDwgMAoJICMjIyBkb3dud2FyZHMgc29mZml0cwog
ICAgc2xvcGVzLnB1c2goZSkgaWYgZS5ub3JtYWwubm9ybWFsaXplLnogPiAw
CgkgIyMjIHVwd2FyZHMgYnV0IG5vdCBsaWQKICAgIHZlcnRpY2Fscy5wdXNo
KGUpIGlmIGUubm9ybWFsLm5vcm1hbGl6ZS56IDwgMS4wZTAwNiAmJiBlLm5v
cm1hbC5ub3JtYWxpemUueiA+IC0xLjBlMDA2CgkgIyMjIGdhYmxlcyAqIGZh
c2NpYXMgLSBkdXBsaWNhdGVkIGluIG90aGVycyBbXSBidXQgcHJvY2Vzc2Vk
IGxhc3QuLi4KICBlbmQjaWYKfQpnYWJsZXM9W10KdmVydGljYWxzLmVhY2h7
fGV8CiAgZ2FibGVzLnB1c2goZSkgaWYgZS5lZGdlcy5sZW5ndGg9PTMgfHwg
KGUuZWRnZXMubGVuZ3RoPT01ICYmIGUuYm91bmRzLm1heC56LWUuYm91bmRz
Lm1pbi56IT1AZmFzY2lhKQogIGlubGluZTM9MAogIGUuZWRnZXMuZWFjaHt8
ZWV8CiAgICBpZiBlZS5zdGFydC5wb3NpdGlvbi56PT1lZS5lbmQucG9zaXRp
b24uegoJICBpbmxpbmUzPWlubGluZTMrMQoJZW5kI2lmCiAgfQogIGdhYmxl
cy5wdXNoKGUpIGlmIGUuZWRnZXMubGVuZ3RoPT03ICYmIChpbmxpbmUzPT0z
ICYmIGUuYm91bmRzLm1pbi56PT1yb29mX2dyb3VwLmJvdW5kcy5taW4ueikK
fQpnYWIxPWdhYmxlc1swXSMjIyMKZ2FiMj1nYWJsZXNbMV0jIyMjCiMjIwpm
YXNjaWFzPXZlcnRpY2Fscy1nYWJsZXMKIyMjIHNvcnQgYW55IGJveCB2ZXJn
ZSBiaXRzIG9mIGZhc2NpcyB0aGF0IHNob3VsZCBiZSBzb2ZmaXQuLi4KZmFz
Y2lhcy5lYWNoe3xmfAogIGlmIGYuZWRnZXMubGVuZ3RoPT00ICMjIyA9aG9y
aXogYml0OiBnZXQgaG9yaXogZWRnZXMgdGhhdCdzIHRvcCBvbmUuLi4KICAg
IHRvcGVkZ2U9bmlsCiAgICBmLmVkZ2VzLmVhY2h7fGV8CiAgICAgIHRvcGVk
Z2U9ZSBpZiBlLmJvdW5kcy5tYXguej09ZS5ib3VuZHMubWluLnogJiYgZS5i
b3VuZHMubWF4Lno9PWYuYm91bmRzLm1heC56CiAgICB9CiAgICBib3g9ZmFs
c2U7IHRvcGVkZ2UuZmFjZXMuZWFjaHt8ZXxib3g9dHJ1ZSBpZiBlLm5vcm1h
bC5ub3JtYWxpemUuejwwfQogICAgaWYgYm94CiAgICAgIGZhc2NpYXMtW2Zd
CgkgIHNvZmZpdHMucHVzaChmKSBpZiBub3QgKGYubm9ybWFsLm5vcm1hbGl6
ZS56ID4gMC45OTk5OSkKICAgIGVuZCNpZgogIGVuZCNpZgp9CiMjIyBtb3Zl
IGxpZHMgZnJvbSBzbG9wZXMKc2xvcGVzLmVhY2h7fGV8CiAgaWYgZS5ub3Jt
YWwubm9ybWFsaXplLnogPiAwLjk5OTk5CglzbG9wZXMtW2VdCglmYXNjaWFz
LnB1c2goZSkKICBlbmQjaWYKfQojIyMgc29ydCBvdXQgbGF5ZXIsIG1hdGVy
aWFscyBldGMgIyMjLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0KZGVmIGRpYWxvZ19tYXRzICgpCiMjIyBtYXRlcmlhbHMgZGlhbG9nICMj
Iy0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLQogIG1vZGVsPVNrZXRjaHVwLmFjdGl2ZV9tb2RlbAogICMjIyBsYXll
cnMuLi4KICBtbGF5ZXJzPW1vZGVsLmxheWVycwogIGFsYXllcj1tb2RlbC5h
Y3RpdmVfbGF5ZXIKICBtb2RlbC5hY3RpdmVfbGF5ZXI9bmlsCiAgZGVmbGF5
ZXI9bW9kZWwuYWN0aXZlX2xheWVyLm5hbWUKICBtb2RlbC5hY3RpdmVfbGF5
ZXI9YWxheWVyCiAgcmxheWVyPSItUk9PRiIjIyMgZWRpdCB0aGlzIHRvIHN1
aXQgeW91ciBkZXNpcmVkIGRlZmF1bHQgcm9vZiBsYXllci4KICBsYXllcnM9
W10KICBtbGF5ZXJzLmVhY2h7fGxheWVyfGxheWVycy5wdXNoKGxheWVyLm5h
bWUpaWYgbGF5ZXIubmFtZSE9ZGVmbGF5ZXJ9CiAgbGF5ZXJzPVtybGF5ZXIs
ZGVmbGF5ZXJdK2xheWVycy5zb3J0IQogIGxheWVycz1sYXllcnMudW5pcS5q
b2luKCd8JykKICAjIyMgbWF0ZXJpYWxzLi4uCiAgbWF0X3Jvb2Y9IlJvb2Yg
U3VyZmFjZSIKICBtYXRfZmFzY2lhPSJSb29mIEZhc2NpYSIKICBtYXRfc29m
Zml0PSJSb29mIFNvZmZpdCIKICBtYXRfZ2FibGUxPSI8RGVmYXVsdD4iCiAg
bWF0X2dhYmxlMj0iPERlZmF1bHQ+IgogIG1hdGVyaWFscz1tb2RlbC5tYXRl
cmlhbHMKICBtYXRzPVtdCiAgbWF0ZXJpYWxzLmVhY2h7fG1hdHxtYXRzLnB1
c2gobWF0Lm5hbWUpfQogIG1hdHMuc29ydCEKICBsaXN0X21hdF9yb29mPSgo
WyI8RGVmYXVsdD4iXStbbWF0X3Jvb2ZdK21hdHMpLnVuaXEpLmpvaW4oInwi
KQogIGxpc3RfbWF0X2Zhc2NpYT0oKFsiPERlZmF1bHQ+Il0rW21hdF9mYXNj
aWFdK21hdHMpLnVuaXEpLmpvaW4oInwiKQogIGxpc3RfbWF0X3NvZmZpdD0o
KFsiPERlZmF1bHQ+Il0rW21hdF9zb2ZmaXRdK21hdHMpLnVuaXEpLmpvaW4o
InwiKQogIGxpc3RfbWF0X2dhYmxlMT0oKFsiPERlZmF1bHQ+Il0rWyJSb29m
IEdhYmxlIDEiXStbIlJvb2YgR2FibGUgMiJdK1ttYXRfcm9vZl0rbWF0cyku
dW5pcSkuam9pbigifCIpCiAgbGlzdF9tYXRfZ2FibGUyPSgoWyI8RGVmYXVs
dD4iXStbIlJvb2YgR2FibGUgMSJdK1siUm9vZiBHYWJsZSAyIl0rW21hdF9y
b29mXSttYXRzKS51bmlxKS5qb2luKCJ8IikKICAjIyMgc2V0IHVwIHZhcmlh
Ymxlcy4uLgogIEBsYXllcj1ybGF5ZXIgaWYgISBAbGF5ZXIKICBAbWF0X3Jv
b2Y9bWF0X3Jvb2YgaWYgISBAbWF0X3Jvb2YKICBAbWF0X2Zhc2NpYT1tYXRf
ZmFzY2lhIGlmICEgQG1hdF9mYXNjaWEKICBAbWF0X3NvZmZpdD1tYXRfc29m
Zml0IGlmICEgQG1hdF9zb2ZmaXQKICBAbWF0X2dhYmxlMT1tYXRfZ2FibGUx
IGlmICEgQG1hdF9nYWJsZTEKICBAbWF0X2dhYmxlMj1tYXRfZ2FibGUyIGlm
ICEgQG1hdF9nYWJsZTIKICBlbnVtcz1bbGF5ZXJzLGxpc3RfbWF0X3Jvb2Ys
bGlzdF9tYXRfZmFzY2lhLGxpc3RfbWF0X3NvZmZpdCxsaXN0X21hdF9nYWJs
ZTEsbGlzdF9tYXRfZ2FibGUyXQogIHByb21wdHM9WyJSb29mIExheWVyOiAg
IiwiUm9vZiBTdXJmYWNlOiAgIiwiUm9vZiBGYXNjaWE6ICAiLCJSb29mIFNv
ZmZpdDogIiwiRmlyc3QgUm9vZiBHYWJsZTogIiwiU2Vjb25kIFJvb2YgR2Fi
bGU6ICJdCiAgdmFsdWVzPVtAbGF5ZXIsQG1hdF9yb29mLEBtYXRfZmFzY2lh
LEBtYXRfc29mZml0LEBtYXRfZ2FibGUxLEBtYXRfZ2FibGUyXQogIEBvdGhl
cl9yZXN1bHRzPShpbnB1dGJveCBwcm9tcHRzLHZhbHVlcyxlbnVtcywiUm9v
ZiBMYXllciBhbmQgTWF0ZXJpYWxzIikKICBAbGF5ZXIsQG1hdF9yb29mLEBt
YXRfZmFzY2lhLEBtYXRfc29mZml0LEBtYXRfZ2FibGUxLEBtYXRfZ2FibGUy
PUBvdGhlcl9yZXN1bHRzIGlmIEBvdGhlcl9yZXN1bHRzCiAgQG90aGVyPSJO
byIgaWYgISBAb3RoZXJfcmVzdWx0cwogICMjIwplbmQjZGVmCiMjIyBydW4g
bWF0ZXJpYWwgZGlhbG9nCiAgZGlhbG9nX21hdHMoKSBpZiBAb3RoZXI9PSJZ
ZXMiCiMjIy0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLQogICNtYXRfcm9vZj0i
Um9vZiBTdXJmYWNlIgogICNtYXRfZmFzY2lhPSJSb29mIEZhc2NpYSIKICAj
bWF0X3NvZmZpdD0iUm9vZiBTb2ZmaXQiCiAgI21hdF9nYWJsZTE9IjxEZWZh
dWx0PiIKICAjbWF0X2dhYmxlMj0iPERlZmF1bHQ+IgppZiBAb3RoZXI9PSJZ
ZXMiCiAjIyMuLi4uLi4uLi4uLi4uLi4uLi4uLi4uLi4uLi4uLi4uLi4uLi4u
Li4uLi4uLi4uLi4uLi4uLi4uLi4uLi4uLi4uLi4uLi4KICMjc29ydCBmb3Ig
bGlkcwogbGlkcz1mYWxzZTsgZmFzY2lhcy5lYWNoe3xlfGxpZHM9dHJ1ZSBp
ZiBlLm5vcm1hbC5ub3JtYWxpemUuej09MX0KIGlmIGxpZHMgCiAgICMjIyBW
Q0IgYW5kIHN0YXR1cyBpbmZvCiAgIFNrZXRjaHVwOjpzZXRfc3RhdHVzX3Rl
eHQoKCInTGlkJyBNYXRlcmlhbC4uLiIgKSwgU0JfUFJPTVBUKQogICBTa2V0
Y2h1cDo6c2V0X3N0YXR1c190ZXh0KCIiLCBTQl9WQ0JfTEFCRUwpCiAgIFNr
ZXRjaHVwOjpzZXRfc3RhdHVzX3RleHQoIiIsIFNCX1ZDQl9WQUxVRSkKICAg
aWYgVUkubWVzc2FnZWJveCgiQXJlIHRoZSBHYWJsZSBGYXNjaWEgJ0xpZHMn
XG50byBiZSBpbiB0aGUgRmFzY2lhIE1hdGVyaWFsID8gIixNQl9ZRVNOTywi
J0xpZCcgTWF0ZXJpYWwiKT09NyAjIyMgNj1ZRVMgNz1OTwogICAgIGZhc2Np
YXMuZWFjaHt8ZXwKICAgICAgIGlmIGUubm9ybWFsLm5vcm1hbGl6ZS56PT0x
CgkgICAgIGZhc2NpYXMtW2VdCgkgICAgIHNvZmZpdHMucHVzaChlKQoJICAg
ZW5kI2lmCiAgICAgfQogIGVuZCNpZgogZW5kI2lmCiAgIyMjIG5vdGUgdGhh
dCBsYXllciBpcyBzZXQgYWZ0ZXIgZ3JvdXBzIGNvbWJpbmVkLi4uCiAgZXh0
Zz1uaWw7QG1vZGVsLmxheWVycy5lYWNoe3xseXJ8ZXh0Zz1seXIgaWYgbHly
Lm5hbWU9PUBsYXllcn0KICBpZiBAbGF5ZXI9PSI8RGVmYXVsdD4iCiAgICBs
YXlyPW5pbAogIGVsc2UKICAgIGlmIGV4dGcKICAgICAgbGF5cj1leHRnCiAg
ICBlbHNlCiAgICAgIGxheXI9QG1vZGVsLmxheWVycy5hZGQoQGxheWVyKQog
ICAgZW5kI2lmCiAgZW5kI2lmCiAgIyMjIG1hdGVyaWFscy4uLgogICMjIyBy
b29mCiAgZXh0Zz1uaWw7QG1vZGVsLm1hdGVyaWFscy5lYWNoe3xtYXR8ZXh0
Zz1tYXQgaWYgbWF0Lm5hbWU9PUBtYXRfcm9vZn0KICBpZiBAbWF0X3Jvb2Y9
PSI8RGVmYXVsdD4iCiAgICBtYXRfcj1uaWwKICBlbHNlCiAgICBpZiBleHRn
CiAgICAgIG1hdF9yPWV4dGcKICAgIGVsc2UKICAgICAgbWF0X3I9QG1vZGVs
Lm1hdGVyaWFscy5hZGQoQG1hdF9yb29mKQogICAgICBtYXRfci5jb2xvcj1b
MTExLDExMSwxMTFdIyMjIGFkanVzdCBkZWZhdWx0IGNvbG91cnMgaGVyZS4K
ICAgIGVuZCNpZgogIGVuZCNpZgogIHNsb3Blcy5lYWNoe3xlfGUubWF0ZXJp
YWw9bWF0X3J9CiAgIyMjIGZhc2NpYQogIGV4dGc9bmlsO0Btb2RlbC5tYXRl
cmlhbHMuZWFjaHt8bWF0fGV4dGc9bWF0IGlmIG1hdC5uYW1lPT1AbWF0X2Zh
c2NpYX0KICBpZiBAbWF0X2Zhc2NpYT09IjxEZWZhdWx0PiIKICAgIG1hdF9m
PW5pbAogIGVsc2UKICAgIGlmIGV4dGcKICAgICAgbWF0X2Y9ZXh0ZwogICAg
ZWxzZQogICAgICBtYXRfZj1AbW9kZWwubWF0ZXJpYWxzLmFkZChAbWF0X2Zh
c2NpYSkKICAgICAgbWF0X2YuY29sb3I9WzY2LDY2LDY2XSMjIyBhZGp1c3Qg
ZGVmYXVsdCBjb2xvdXJzIGhlcmUuCiAgICBlbmQjaWYKICBlbmQjaWYKICBm
YXNjaWFzLmVhY2h7fGV8ZS5tYXRlcmlhbD1tYXRfZn0KICAjIyMgc29mZml0
CiAgZXh0Zz1uaWw7QG1vZGVsLm1hdGVyaWFscy5lYWNoe3xtYXR8ZXh0Zz1t
YXQgaWYgbWF0Lm5hbWU9PUBtYXRfc29mZml0fQogIGlmIEBtYXRfc29mZml0
PT0iPERlZmF1bHQ+IgogICAgbWF0X3M9bmlsCiAgZWxzZQogICAgaWYgZXh0
ZwogICAgICBtYXRfcz1leHRnCiAgICBlbHNlCiAgICAgIG1hdF9zPUBtb2Rl
bC5tYXRlcmlhbHMuYWRkKEBtYXRfc29mZml0KQogICAgICBtYXRfcy5jb2xv
cj1bMjIyLDIyMiwyMjJdIyMjIGFkanVzdCBkZWZhdWx0IGNvbG91cnMgaGVy
ZS4KICAgIGVuZCNpZgogIGVuZCNpZgogIHNvZmZpdHMuZWFjaHt8ZXxlLm1h
dGVyaWFsPW1hdF9zfQogICMjIyBnYWJsZQogIGV4dGc9bmlsO0Btb2RlbC5t
YXRlcmlhbHMuZWFjaHt8bWF0fGV4dGc9bWF0IGlmIG1hdC5uYW1lPT1AbWF0
X2dhYmxlMX0KICBpZiBAbWF0X2dhYmxlMT09IjxEZWZhdWx0PiIKICAgIG1h
dF9nMT1uaWwKICBlbHNlCiAgICBpZiBleHRnCiAgICAgIG1hdF9nMT1leHRn
CiAgICBlbHNlCiAgICAgIG1hdF9nMT1AbW9kZWwubWF0ZXJpYWxzLmFkZChA
bWF0X2dhYmxlMSkKICAgICAgIyMjIGFkanVzdCBkZWZhdWx0IGNvbG91cnMg
aGVyZS4KCSAgbWF0X2cxLmNvbG9yPVsyMzQsMjM0LDIzNF0gaWYgQG1hdF9n
YWJsZTE9PSJSb29mIFN1cmZhY2UiCiAgICAgIG1hdF9nMS5jb2xvcj1bMjU1
LDI1NSwyNTVdIGlmIEBtYXRfZ2FibGUxPT0iUm9vZiBHYWJsZSAxIiN3aGl0
ZQogICAgICBtYXRfZzEuY29sb3I9WzQ0LDQ0LDQ0XSBpZiBAbWF0X2dhYmxl
MT09IlJvb2YgR2FibGUgMiIjZGFyawogICAgZW5kI2lmCiAgZW5kI2lmCiAg
Z2FiMS5tYXRlcmlhbD1tYXRfZzEgaWYgZ2FiMQogIGV4dGc9bmlsO0Btb2Rl
bC5tYXRlcmlhbHMuZWFjaHt8bWF0fGV4dGc9bWF0IGlmIG1hdC5uYW1lPT1A
bWF0X2dhYmxlMn0KICBpZiBAbWF0X2dhYmxlMj09IjxEZWZhdWx0PiIKICAg
IG1hdF9nMj1uaWwKICBlbHNlCiAgICBpZiBleHRnCiAgICAgIG1hdF9nMj1l
eHRnCiAgICBlbHNlCiAgICAgIG1hdF9nMj1AbW9kZWwubWF0ZXJpYWxzLmFk
ZChAbWF0X2dhYmxlMikKICAgICAgIyMjIGFkanVzdCBkZWZhdWx0IGNvbG91
cnMgaGVyZS4KCSAgbWF0X2cyLmNvbG9yPVsyMzQsMjM0LDIzNF0gaWYgQG1h
dF9nYWJsZTI9PSJSb29mIFN1cmZhY2UiCiAgICAgIG1hdF9nMi5jb2xvcj1b
MjU1LDI1NSwyNTVdIGlmIEBtYXRfZ2FibGUyPT0iUm9vZiBHYWJsZSAxIiN3
aGl0ZQogICAgICBtYXRfZzIuY29sb3I9WzQ0LDQ0LDQ0XSBpZiBAbWF0X2dh
YmxlMj09IlJvb2YgR2FibGUgMiIjZGFyawogICAgZW5kI2lmCiAgZW5kI2lm
CiAgICBnYWIyLm1hdGVyaWFsPW1hdF9nMiBpZiBnYWIyCmVuZCNpZgojIyMg
Zml4IGZvciBmYXNjaWEgbGlkIGV0IGFsICMjIyMjIyMjIyMjIyMjIyMjIyMj
IyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMKc2xvcGVzLmVhY2h7fGV8ZS5tYXRl
cmlhbD1tYXRfciBpZiBub3QgZS5ub3JtYWwubm9ybWFsaXplLno9PTF9CiMj
IyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMj
IyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIwojIyMgbW92ZSBvcmlnaW4gYmFz
ZWQgZmFjZXMgZXRjIGJhY2sgaW50byBwbGFjZSB0byBhdm9pZCBidWdzcGxh
dHMgIyMjLS0KaWYgb3JpZ2luCiAgdHI9R2VvbTo6VHJhbnNmb3JtYXRpb24u
bmV3KG9ycHQpCiAgdHJ6PUdlb206OlRyYW5zZm9ybWF0aW9uLm5ldyhbMCww
LDBdKQogIHJvb2ZfZ3JvdXAubW92ZSEodHJ6KQogICMjIyBjb3JyZWN0IGZv
ciBmYXNjaWEgPwogIHJvb2ZfZ3JvdXAubW92ZSEoR2VvbTo6VHJhbnNmb3Jt
YXRpb24ubmV3KFswLDAsQGZhc2NpYV9dKSlpZiBAZmFzY2lhXz4wCmVuZCNp
ZgojIyMgdGlkeSB1cCBhdCBlbmQgIyMjLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0KQG1vZGVsLnNlbGVjdGlv
bi5jbGVhcgpAbW9kZWwuc2VsZWN0aW9uLmFkZChvZmFjZSxAb2VkZ2UpCiMj
IyBlbmQgd2l0aCBvcmlnaW5hbCBmYWNlL2VkZ2UgcmUtc2VsZWN0ZWQKQG1v
ZGVsLmFjdGl2ZV92aWV3LmludmFsaWRhdGUKQG1vZGVsLmNvbW1pdF9vcGVy
YXRpb24KU2tldGNodXAuc2VuZF9hY3Rpb24ic2VsZWN0U2VsZWN0aW9uVG9v
bDoiCiMjIwplbmQjZGVmIGdhYmxlCiMjIy0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLQoKCgoKCmRlZiBSb29mOjpweXJhbWlkKCkKICAjIyMgY2hlY2sgZmFj
ZSAtLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tCiAgQG1vZGVsPVNrZXRjaHVwLmFjdGl2ZV9tb2RlbAog
IHNzPUBtb2RlbC5zZWxlY3Rpb24KICBmYWNlcz1bXTtlZGdlcz1bXQogIHNz
LmVhY2h7fGV8CiAgICBmYWNlcy5wdXNoKGUpaWYgZS50eXBlbmFtZT09IkZh
Y2UiCiAgICBlZGdlcy5wdXNoKGUpaWYgZS50eXBlbmFtZT09IkVkZ2UiCiAg
fQogIGlmIHNzLmVtcHR5PyB8fCBmYWNlcy5lbXB0eT8KICAgIFVJLm1lc3Nh
Z2Vib3goIlB5cmFtaWQgUm9vZjpcblxuWW91IG11c3Qgc2VsZWN0IG9uZSBo
b3Jpem9udGFsIHJlY3Rhbmd1bGFyIEZBQ0UsIGFuZCBvbmUgZWRnZSAodGhh
dCdzIGF0IHRoZSAncGl0Y2ggc2lkZScpICEiKQogICAgcmV0dXJuIG5pbAog
IGVuZCNpZgogIGlmIGZhY2VzWzFdCiAgICBVSS5tZXNzYWdlYm94KCJQeXJh
bWlkIFJvb2Y6XG5cbllvdSBtdXN0IHNlbGVjdCBPTkUgaG9yaXpvbnRhbCBy
ZWN0YW5ndWxhciBmYWNlLCBhbmQgb25lIGVkZ2UgKHRoYXQncyBhdCB0aGUg
J3BpdGNoIHNpZGUnKSAhIikKICAgIHJldHVybiBuaWwKICBlbmQjaWYKICBv
ZmFjZT1mYWNlc1swXSMjIyBzdGFydGluZyBmYWNlCiAgaWYgb2ZhY2Uubm9y
bWFsLm5vcm1hbGl6ZSEuei5hYnMgIT0gMQogICAgVUkubWVzc2FnZWJveCgi
UHlyYW1pZCBSb29mOlxuXG5Zb3UgbXVzdCBzZWxlY3Qgb25lIEhPUklaT05U
QUwgcmVjdGFuZ3VsYXIgZmFjZSwgYW5kIG9uZSBlZGdlICh0aGF0J3MgYXQg
dGhlICdwaXRjaCBzaWRlJykgISIpCiAgICByZXR1cm4gbmlsCiAgZW5kI2lm
CiAgIyMjIGNoZWNrIHNpZGVzIGFyZSBwYXJhbGxlbCBhbmQgYXQgOTAgZGVn
cmVlcwogIG9wb2ludHM9Um9vZi5vcmRlcmVkX2VkZ2VfcG9pbnRzKG9mYWNl
KQogICMjIwogIGlmIG9wb2ludHMubGVuZ3RoICE9IDQKICAgIFVJLm1lc3Nh
Z2Vib3goIlB5cmFtaWQgUm9vZjpcblxuWW91IG11c3Qgc2VsZWN0IG9uZSBo
b3Jpem9udGFsIFJFQ1RBTkdVTEFSIFs9IDQgc2lkZXNdIGZhY2UsIGFuZCBv
bmUgZWRnZSAodGhhdCdzIGF0IHRoZSAncGl0Y2ggc2lkZScpICEiKQogICAg
cmV0dXJuIG5pbAogIGVuZCNpZgogIHB0MD1vcG9pbnRzWzBdOyBwdDE9b3Bv
aW50c1sxXTsgcHQyPW9wb2ludHNbMl07IHB0Mz1vcG9pbnRzWzNdCiAgcHQw
PUdlb206OlBvaW50M2QubmV3KHB0MFswXSxwdDBbMV0scHQwWzJdKSAKICBw
dDE9R2VvbTo6UG9pbnQzZC5uZXcocHQxWzBdLHB0MVsxXSxwdDFbMl0pIAog
IHB0Mj1HZW9tOjpQb2ludDNkLm5ldyhwdDJbMF0scHQyWzFdLHB0MlsyXSkg
CiAgcHQzPUdlb206OlBvaW50M2QubmV3KHB0M1swXSxwdDNbMV0scHQzWzJd
KSAKICB2ZWMwPXB0MC52ZWN0b3JfdG8ocHQxKQogIHZlYzE9cHQxLnZlY3Rv
cl90byhwdDIpCiAgdmVjMj1wdDIudmVjdG9yX3RvKHB0MykKICB2ZWMzPXB0
My52ZWN0b3JfdG8ocHQwKQogIHJlY3RhbmdsZT10cnVlCiAgcmVjdGFuZ2xl
PWZhbHNlIGlmICEgdmVjMC5wYXJhbGxlbD8odmVjMi5yZXZlcnNlKQogIHJl
Y3RhbmdsZT1mYWxzZSBpZiAhIHZlYzEucGFyYWxsZWw/KHZlYzMucmV2ZXJz
ZSkKICByZWN0YW5nbGU9ZmFsc2UgaWYgKHZlYzAudG9fZmxhdF9hbmdsZS12
ZWMxLnRvX2ZsYXRfYW5nbGUpLmFicy50b19zICE9IDkwLmRlZ3JlZXMudG9f
cwogIHJlY3RhbmdsZT1mYWxzZSBpZiAodmVjMi50b19mbGF0X2FuZ2xlLXZl
YzMudG9fZmxhdF9hbmdsZSkuYWJzLnRvX3MgIT0gOTAuZGVncmVlcy50b19z
CiAgaWYgbm90IHJlY3RhbmdsZQogICAgVUkubWVzc2FnZWJveCgiUHlyYW1p
ZCBSb29mOlxuXG5Zb3UgbXVzdCBzZWxlY3Qgb25lIGhvcml6b250YWwgUkVD
VEFOR1VMQVIgWz0gcmlnaHQtYW5nbGVkXSBmYWNlLCBhbmQgb25lIGVkZ2Ug
KHRoYXQncyBhdCB0aGUgJ3BpdGNoIHNpZGUnKSAhIikKICAgIHJldHVybiBu
aWwKICBlbmQjaWYKICBpZiBlZGdlc1sxXSB8fCAhIGVkZ2VzWzBdCiAgICBV
SS5tZXNzYWdlYm94KCJQeXJhbWlkIFJvb2Y6XG5cbllvdSBtdXN0IHNlbGVj
dCBvbmx5IG9uZSBmYWNlIEFORCBPTkUgZWRnZSAodGhhdCdzIGF0IHRoZSAn
cGl0Y2ggc2lkZScpICEiKQogICAgcmV0dXJuIG5pbAogIGVuZCNpZgogIGlm
ICEgZmFjZXNbMF0uZWRnZXMuaW5jbHVkZT8oZWRnZXNbMF0pCiAgICBVSS5t
ZXNzYWdlYm94KCJQeXJhbWlkIFJvb2Y6XG5cbllvdSBtdXN0IHNlbGVjdCBv
bmx5IG9uZSBmYWNlIGFuZCBvbmUgZWRnZSAodGhhdCdzIGF0IHRoZSAncGl0
Y2ggc2lkZScpLlxuQlVUIHRoYXQgZWRnZSBtdXN0IGJlbG9uZyB0byB0aGUg
ZmFjZSAhIikKICAgIHJldHVybiBuaWwKICBlbmQjaWYKICBAb2VkZ2U9ZWRn
ZXNbMF0jIyMgdXNlIHRoaXMgaW5mbyBsYXRlci4uLgogIG9wdDA9QG9lZGdl
LnN0YXJ0LnBvc2l0aW9uCiAgb3B0MT1Ab2VkZ2UuZW5kLnBvc2l0aW9uCiMj
IyBkbyBnYWJsZSBkaWFsb2cuLi4KZGVmIGRpYWxvZ19weXJhbWlkICgpCiMj
IyBkaWFsb2cgIyMjLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLQpAcGl0Y2hHPSIxOjIiIGlmICEg
QHBpdGNoRyAmJiBAbW9kZWwub3B0aW9uc1siVW5pdHNPcHRpb25zIl1bIkxl
bmd0aFVuaXQiXTwyCkBwaXRjaEc9IjMwIiBpZiAhIEBwaXRjaEcgJiYgQG1v
ZGVsLm9wdGlvbnNbIlVuaXRzT3B0aW9ucyJdWyJMZW5ndGhVbml0Il0+MQpA
ZmFzY2lhPTguaW5jaCBpZiAhIEBmYXNjaWEgJiYgQG1vZGVsLm9wdGlvbnNb
IlVuaXRzT3B0aW9ucyJdWyJMZW5ndGhVbml0Il08MgpAZmFzY2lhPTIwMC5t
bSBpZiAhIEBmYXNjaWEgJiYgQG1vZGVsLm9wdGlvbnNbIlVuaXRzT3B0aW9u
cyJdWyJMZW5ndGhVbml0Il0+MQpAZWF2ZXM9MTYuaW5jaCBpZiAhIEBlYXZl
cyAmJiBAbW9kZWwub3B0aW9uc1siVW5pdHNPcHRpb25zIl1bIkxlbmd0aFVu
aXQiXTwyCkBlYXZlcz00MDAubW0gaWYgISBAZWF2ZXMgJiYgQG1vZGVsLm9w
dGlvbnNbIlVuaXRzT3B0aW9ucyJdWyJMZW5ndGhVbml0Il0+MQpAb3RoZXI9
Ik5vIiBpZiAhIEBvdGhlcgpAdW5pdHM9ImluY2hlcyIgaWYgQG1vZGVsLm9w
dGlvbnNbIlVuaXRzT3B0aW9ucyJdWyJMZW5ndGhVbml0Il09PTAKQHVuaXRz
PSJmZWV0IiBpZiBAbW9kZWwub3B0aW9uc1siVW5pdHNPcHRpb25zIl1bIkxl
bmd0aFVuaXQiXT09MQpAdW5pdHM9Im1tIiBpZiBAbW9kZWwub3B0aW9uc1si
VW5pdHNPcHRpb25zIl1bIkxlbmd0aFVuaXQiXT09MgpAdW5pdHM9ImNtIiBp
ZiBAbW9kZWwub3B0aW9uc1siVW5pdHNPcHRpb25zIl1bIkxlbmd0aFVuaXQi
XT09MwpAdW5pdHM9Im0iIGlmIEBtb2RlbC5vcHRpb25zWyJVbml0c09wdGlv
bnMiXVsiTGVuZ3RoVW5pdCJdPT00CmVudW1zPVsiIiwiIiwiIiwiWWVzfE5v
Il0KcHJvbXB0cz1bIlJvb2YgJ1Nsb3BlJyAoaW4gRGVncmVlcyBvciBBOkIg
b3IgXkhlaWdodCgje0B1bml0c30pKTogICIsIk92ZXJhbGwgRWF2ZXMgRmFz
Y2lhIEhlaWdodCAoI3tAdW5pdHN9KTogICIsIk92ZXJhbGwgRWF2ZXMgU29m
Zml0IE92ZXJoYW5nICgje0B1bml0c30pOiAgIiwiU2V0IExheWVyIGFuZCBN
YXRlcmlhbHMgPyA6Il0KdmFsdWVzPVtAcGl0Y2hHLEBmYXNjaWEsQGVhdmVz
LEBvdGhlcl0KQHJlc3VsdHM9KGlucHV0Ym94IHByb21wdHMsdmFsdWVzLGVu
dW1zLCJQeXJhbWlkIFJvb2YgU2V0dGluZ3MiKQpyZXR1cm4gbmlsIGlmICEg
QHJlc3VsdHMKKEBwaXRjaF9zLEBmYXNjaWFfLEBlYXZlc18sQG90aGVyXyk9
QHJlc3VsdHMKQHBpdGNoRz1AcGl0Y2hfcztAZmFzY2lhPUBmYXNjaWFfO0Bl
YXZlcz1AZWF2ZXNfO0BvdGhlcj1Ab3RoZXJfCiMjIyBzb3J0IGlmIF5oZWln
aHQgb3Igc2xvcGUuLi4KQGhpPWZhbHNlCmlmIEBwaXRjaF9zLnNwbGl0KCIi
KVswXT09Il4iCiAgQHBodD1AcGl0Y2hfc1sxLi4tMV0udG9fZgogIEBwaHQ9
QHBodC50b19sIGlmIEB1bml0cz09ImluY2hlcyIKICBAcGh0PUBwaHQuZmVl
dCBpZiBAdW5pdHM9PSJmZWV0IgogIEBwaHQ9QHBodC5tbSBpZiBAdW5pdHM9
PSJtbSIKICBAcGh0PUBwaHQuY20gaWYgQHVuaXRzPT0iY20iCiAgQHBodD1A
cGh0Lm0gaWYgQHVuaXRzPT0ibSIKICBAaGk9dHJ1ZQogIEBwaXRjaF9kPTIK
ICBAcGl0Y2hfZD0wIGlmIEBwaHQgPDEubW0KZWxzZSNpdCdzIGFuIGFuZ2xl
CiAgIyMjIGdldCBhbmdsZSBvZiByb29mIGluIHJhZGlhbnMKICByYXRpbz1A
cGl0Y2hfcy5zcGxpdCgiOiIpLnRvX2YKICBpZiByYXRpb1sxXQogICAgdGFu
PXJhdGlvWzBdL3JhdGlvWzFdCiAgICBAcGl0Y2hfZD0oTWF0aDo6YXRhbih0
YW4pKS5yYWRpYW5zCiAgZWxzZQogICAgQHBpdGNoX2Q9cmF0aW9bMF0KICBl
bmQjaWYKZW5kI2lmCkBwaXRjaF9yPUBwaXRjaF9kLmRlZ3JlZXMgICMjIyB0
byByYWRpYW5zICMjIy0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLQppZiBAcGl0
Y2hfZDwxCiAgVUkubWVzc2FnZWJveCgiUHlyYW1pZCBSb29mOlxuXFBpdGNo
IGNhbid0IGJlIGxlc3MgdGhhbiAxIGRlZ3JlZS4iKQogIEBwaXRjaEc9IjEi
O0BwaXRjaF9zPSIxIjtAcGl0Y2hfZD0xO0BwaXRjaF9yPTEuZGVncmVlcwog
IGRpYWxvZ19weXJhbWlkCiAgcmV0dXJuIG5pbAplbmQjaWYKaWYgQHBpdGNo
X2Q+ODkgCiAgVUkubWVzc2FnZWJveCgiUHlyYW1pZCBSb29mOlxuXG5QaXRj
aCBjYW4ndCBiZSBtb3JlIHRoYW4gODkgZGVncmVlcy4iKQogIEBwaXRjaEc9
Ijg5IjtAcGl0Y2hfcz0iODkiO0BwaXRjaF9kPTg5O0BwaXRjaF9yPTg5LmRl
Z3JlZXMKICBkaWFsb2dfcHlyYW1pZAogIHJldHVybiBuaWwKZW5kI2lmCmlm
IEBmYXNjaWFfIDwwCiAgVUkubWVzc2FnZWJveCgiUHlyYW1pZCBSb29mOlxu
XG5GYXNjaWEgY2FuJ3QgYmUgTEVTUyBUSEFOIFpFUk8uXG5SZXNldHRpbmcg
aXQgdG8gWkVSTy4uLiIpCiAgQGZhc2NpYT0wLnRvX2w7QGZhc2NpYV89MC50
b19sCiAgZGlhbG9nX2dhYmxlCiAgcmV0dXJuIG5pbAplbmQjaWYKaWYgQGVh
dmVzXyA8MAogIFVJLm1lc3NhZ2Vib3goIlB5cmFtaWQgUm9vZjpcblxuRWF2
ZXMgY2FuJ3QgYmUgTEVTUyBUSEFOIFpFUk8uXG5SZXNldHRpbmcgaXQgdG8g
WkVSTy4uLlxuXG5Gb3IgYSAncGFyYXBldC1lYXZlcycgZmlyc3QgdXNlICdP
ZmZzZXQnIG9uIHRoZSBmYWNlIHRvIGluc2V0IGl0cyBlZGdlcyAuLi4iKQog
IEBlYXZlcz0wLnRvX2w7QGVhdmVzXz0wLnRvX2wKICBkaWFsb2dfZ2FibGUK
ICByZXR1cm4gbmlsCmVuZCNpZgojIyMKaWYgQGZhc2NpYV89PTAgJiYgKEBn
YWJsZTF0eXBlXz09IlZlcmdlIGZyb20gRmFzY2lhInx8QGdhYmxlMXR5cGVf
PT0iVmVyZ2Ugd2l0aCBGYXNjaWEgW0FsbCBFcXVhbF0iKQogIFVJLm1lc3Nh
Z2Vib3goIlB5cmFtaWQgUm9vZjpcblxuRmFzY2lhIGlzIFpFUk8uXG5UaGVy
ZWZvcmUgY2Fubm90IG1ha2UgJ1ZlcmdlIGZyb20gRmFzY2lhJyAuLi4iKQog
IEBnYWJsZTF0eXBlXz0iQmxhbmsiO0BnYWJsZTF0eXBlPSJCbGFuayIKICBk
aWFsb2dfZ2FibGUKICByZXR1cm4gbmlsCmVuZCNpZgppZiBAZmFzY2lhXz09
MCAmJiAoQGdhYmxlMnR5cGVfPT0iVmVyZ2UgZnJvbSBGYXNjaWEifHxAZ2Fi
bGUydHlwZV89PSJWZXJnZSB3aXRoIEZhc2NpYSBbQWxsIEVxdWFsXSIpCiAg
VUkubWVzc2FnZWJveCgiUHlyYW1pZCBSb29mOlxuXG5GYXNjaWEgaXMgWkVS
Ty5cblRoZXJlZm9yZSBjYW5ub3QgbWFrZSAnVmVyZ2UgZnJvbSBGYXNjaWEn
IC4uLiIpCiAgQGdhYmxlMnR5cGVfPSJCbGFuayI7QGdhYmxlMnR5cGU9IkJs
YW5rIgogIGRpYWxvZ19nYWJsZQogIHJldHVybiBuaWwKZW5kI2lmCmlmIEBl
YXZlc189PTAgJiYgQGdhYmxlMXR5cGVfPT0iVmVyZ2UgZnJvbSBTb2ZmaXQi
CiAgVUkubWVzc2FnZWJveCgiUHlyYW1pZCBSb29mOlxuXFNvZmZpdCBpcyBa
RVJPLlxuVGhlcmVmb3JlIGNhbm5vdCBtYWtlICdWZXJnZSBmcm9tIFNvZmZp
dCcgLi4uIikKICBAZ2FibGUxdHlwZV89IkJsYW5rIjtAZ2FibGUxdHlwZT0i
QmxhbmsiCiAgZGlhbG9nX2dhYmxlCiAgcmV0dXJuIG5pbAplbmQjaWYKaWYg
QGVhdmVzXz09MCAmJiBAZ2FibGUydHlwZV89PSJWZXJnZSBmcm9tIFNvZmZp
dCIKICBVSS5tZXNzYWdlYm94KCJQeXJhbWlkIFJvb2Y6XG5cU29mZml0IGlz
IFpFUk8uXG5UaGVyZWZvcmUgY2Fubm90IG1ha2UgJ1ZlcmdlIGZyb20gU29m
Zml0JyAuLi4iKQogIEBnYWJsZTJ0eXBlXz0iQmxhbmsiO0BnYWJsZTJ0eXBl
PSJCbGFuayIKICBkaWFsb2dfZ2FibGUKICByZXR1cm4gbmlsCmVuZCNpZgpp
ZiBAZmFzY2lhXz09MCAmJiBAZ2FibGUxdHlwZT09IlZlcmdlIGJ5IEhlaWdo
dCwgd2l0aCBGYXNjaWEiCiAgVUkubWVzc2FnZWJveCgiUHlyYW1pZCBSb29m
OlxuXG5GYXNjaWEgaXMgWkVSTy5cblRoZXJlZm9yZSBjYW5ub3QgbWFrZSAn
VmVyZ2UgYnkgSGVpZ2h0LCB3aXRoIEZhc2NpYScgLi4uIikKICBAZ2FibGUx
dHlwZV89IkJsYW5rIjtAZ2FibGUxdHlwZT0iQmxhbmsiCiAgZGlhbG9nX2dh
YmxlCiAgcmV0dXJuIG5pbAplbmQjaWYKaWYgQGZhc2NpYV89PTAgJiYgQGdh
YmxlMnR5cGU9PSJWZXJnZSBieSBIZWlnaHQsIHdpdGggRmFzY2lhIgogIFVJ
Lm1lc3NhZ2Vib3goIlB5cmFtaWQgUm9vZjpcblxuRmFzY2lhIGlzIFpFUk8u
XG5UaGVyZWZvcmUgY2Fubm90IG1ha2UgJ1ZlcmdlIGJ5IEhlaWdodCwgd2l0
aCBGYXNjaWEnIC4uLiIpCiAgQGdhYmxlMnR5cGVfPSJCbGFuayI7QGdhYmxl
MnR5cGU9IkJsYW5rIgogIGRpYWxvZ19nYWJsZQogIHJldHVybiBuaWwKZW5k
I2lmCmlmIEBmYXNjaWFfPT0wICYmIEBnYWJsZTF0eXBlPT0iQmxhbmsgd2l0
aCBGYXNjaWEiCiAgVUkubWVzc2FnZWJveCgiUHlyYW1pZCBSb29mOlxuXG5G
YXNjaWEgaXMgWkVSTy5cblRoZXJlZm9yZSBjYW5ub3QgbWFrZSAnQmxhbmsg
d2l0aCBGYXNjaWEnIC4uLiIpCiAgQGdhYmxlMXR5cGVfPSJCbGFuayI7QGdh
YmxlMXR5cGU9IkJsYW5rIgogIGRpYWxvZ19nYWJsZQogIHJldHVybiBuaWwK
ZW5kI2lmCmlmIEBmYXNjaWFfPT0wICYmIEBnYWJsZTJ0eXBlPT0iQmxhbmsg
d2l0aCBGYXNjaWEiCiAgVUkubWVzc2FnZWJveCgiUHlyYW1pZCBSb29mOlxu
XG5GYXNjaWEgaXMgWkVSTy5cblRoZXJlZm9yZSBjYW5ub3QgbWFrZSAnQmxh
bmsgd2l0aCBGYXNjaWEnIC4uLiIpCiAgQGdhYmxlMnR5cGVfPSJCbGFuayI7
QGdhYmxlMnR5cGU9IkJsYW5rIgogIGRpYWxvZ19nYWJsZQogIHJldHVybiBu
aWwKZW5kI2lmCmlmIChAZmFzY2lhXz09MCAmJiBAZWF2ZXM9PTApICYmIChA
Z2FibGUxdHlwZT09IlZlcmdlIGJ5IEhlaWdodCwgd2l0aCBCb3gtRWF2ZXMi
fHxAZ2FibGUxdHlwZT09IlZlcmdlIGJ5IFdpZHRoLCB3aXRoIEJveC1FYXZl
cyIpCiAgVUkubWVzc2FnZWJveCgiUHlyYW1pZCBSb29mOlxuXG5GYXNjaWEg
QU5EIFNvZmZpdCBhcmUgWkVSTy5cblRoZXJlZm9yZSBjYW5ub3QgbWFrZSBh
ICdCb3ggRWF2ZXMnIC4uLiIpCiAgQGdhYmxlMXR5cGVfPSJCbGFuayI7QGdh
YmxlMXR5cGU9IkJsYW5rIgogIGRpYWxvZ19nYWJsZQogIHJldHVybiBuaWwK
ZW5kI2lmCmlmIChAZmFzY2lhXz09MCAmJiBAZWF2ZXM9PTApICYmIChAZ2Fi
bGUydHlwZT09IlZlcmdlIGJ5IEhlaWdodCwgd2l0aCBCb3gtRWF2ZXMifHxA
Z2FibGUydHlwZT09IlZlcmdlIGJ5IFdpZHRoLCB3aXRoIEJveC1FYXZlcyIp
CiAgVUkubWVzc2FnZWJveCgiUHlyYW1pZCBSb29mOlxuXG5GYXNjaWEgQU5E
IFNvZmZpdCBhcmUgWkVSTy5cblRoZXJlZm9yZSBjYW5ub3QgbWFrZSBhICdC
b3ggRWF2ZXMnIC4uLiIpCiAgQGdhYmxlMnR5cGVfPSJCbGFuayI7QGdhYmxl
MnR5cGU9IkJsYW5rIgogIGRpYWxvZ19nYWJsZQogIHJldHVybiBuaWwKZW5k
I2lmCiMjIwplbmQjZGVmIGRpYWxvZwojIyMgcnVuIGRpYWxvZwogIGRpYWxv
Z19weXJhbWlkKCkKICByZXR1cm4gbmlsIGlmICEgQHJlc3VsdHMKIyMjCiMj
Iy0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLQojIyMgZG8gUHlyYW1pZCByb29m
Li4uCkBtb2RlbC5zdGFydF9vcGVyYXRpb24oIlB5cmFtaWQgUm9vZiIpCmVu
dGl0aWVzPUBtb2RlbC5hY3RpdmVfZW50aXRpZXMKIyMjIEBvZWRnZSBpcyBz
ZWxlY3RlZCBQeXJhbWlkIGFuZ2xlIGVkZ2UsIG9mYWNlIHRoZSBzZWxlY3Rl
ZCBmYWNlCm9lcHM9W0BvZWRnZS5zdGFydC5wb3NpdGlvbixAb2VkZ2UuZW5k
LnBvc2l0aW9uXSMjI3VzZSBhdCBlbmQKb2VkZ2VzPW9mYWNlLm91dGVyX2xv
b3AuZWRnZXMKb3ZlcnRzPW9mYWNlLm91dGVyX2xvb3AudmVydGljZXMKb3Bv
aW50cz1bXTtvdmVydHMuZWFjaHt8ZXxvcG9pbnRzLnB1c2goZS5wb3NpdGlv
bi50b19hKX0KIyMjIHNldCB1cCByb29mIGdyb3VwIGV0YyAjIyMtLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tCnJvb2ZfZ3Jv
dXA9ZW50aXRpZXMuYWRkX2dyb3VwCnJvb2ZfZW50aXRpZXM9cm9vZl9ncm91
cC5lbnRpdGllcwppZmFjZT1yb29mX2VudGl0aWVzLmFkZF9mYWNlKG9wb2lu
dHMpCmlmIEBlYXZlcz09MAogIGZhY2U9aWZhY2UKZWxzZQogIGZhY2U9aWZh
Y2Uub2Zmc2V0X2VhdmVzKEBlYXZlcykKICBpZiBub3QgZmFjZQogICAgZmFj
ZT1pZmFjZQogIGVsc2UKICAgIGlmYWNlLmVkZ2VzLmVhY2h7fGV8ZS5lcmFz
ZSEgaWYgZS52YWxpZD99CiAgZW5kI2lmCmVuZCNpZgplcG9pbnRzPVJvb2Yu
b3JkZXJlZF9lZGdlX3BvaW50cyhmYWNlKQpyb29mX2VudGl0aWVzLmVhY2h7
fGV8ZS5lcmFzZSEgaWYgZS52YWxpZD8gJiYgZS50eXBlbmFtZT09IkZhY2Ui
fQplZnBvaW50cz1lcG9pbnRzOyBlZnBvaW50cz1lZnBvaW50cy5wdXNoKGVm
cG9pbnRzWzBdKQplZWRnZXM9cm9vZl9lbnRpdGllcy5hZGRfZWRnZXMoZWZw
b2ludHMpCiMjIyBhbGxvdyBmb3IgZmFzY2lhLi4uCmZwb2ludHM9W107ZWZw
b2ludHMuZWFjaHt8ZXxmcG9pbnRzLnB1c2goW2UueCxlLnksZS56K0BmYXNj
aWFdKX0KZmVlZGdlcz1yb29mX2VudGl0aWVzLmFkZF9lZGdlcyhmcG9pbnRz
KQojIyMgLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0KIyMjIEBwaXRjaF9kID0g
YW5nbGUgb2Ygcm9vZiBhdCBzZWxlY3RlZCBzaWRlID0gQG9lZGdlCmN0cj1H
ZW9tOjpQb2ludDNkLmxpbmVhcl9jb21iaW5hdGlvbigwLjUsQG9lZGdlLnN0
YXJ0LnBvc2l0aW9uLDAuNSxAb2VkZ2UuZW5kLnBvc2l0aW9uKQphcHg9R2Vv
bTo6UG9pbnQzZC5saW5lYXJfY29tYmluYXRpb24oMC41LGVwb2ludHNbMF0s
MC41LGVwb2ludHNbMl0pCmFkaj1jdHIuZGlzdGFuY2UoYXB4KStAZWF2ZXMK
aWYgQGhpICMjI15ubm4gaGVpZ2h0IGFkZGVkCiAgb3BwPUBwaHQKZWxzZQog
IG9wcD1NYXRoOjp0YW4oQHBpdGNoX3IpKmFkagplbmQjaWYKYXBleD1bYXB4
LngsYXB4LnksYXB4Lnorb3BwK0BmYXNjaWFdCiMjIyBtYWtlIHJpZGdlcy4u
LgpyaWRnZXM9W107ZnBvaW50cy5lYWNoe3xlfHJpZGdlcy5wdXNoKHJvb2Zf
ZW50aXRpZXMuYWRkX2xpbmUoZSxhcGV4KSl9CiMjIyBhZGQgZmFjZXMgdG8g
cm9vZgpmZWVkZ2VzLmVhY2h7fGV8cm9vZl9lbnRpdGllcy5hZGRfZmFjZShl
LnN0YXJ0LnBvc2l0aW9uLGUuZW5kLnBvc2l0aW9uLGFwZXgpfQojIyMgYWRk
IGluIHNvZmZpdApyb29mX2VudGl0aWVzLmFkZF9mYWNlKGVlZGdlcykKIyMj
IGFkZCBmYXNjaWEgaWYgYW55CmlmIEBmYXNjaWEgPjAKICBmb3IgaSBpbiAw
Li4uZWZwb2ludHMubGVuZ3RoLTEjIyMKICAgIHJvb2ZfZW50aXRpZXMuYWRk
X2ZhY2UoZWZwb2ludHNbaV0sZnBvaW50c1tpXSxmcG9pbnRzW2krMV0sZWZw
b2ludHNbaSsxXSkKICBlbmQjZm9yCmVuZCNpZgpzb2ZmaXQ9bmlsO3ZlcnRp
Y2Fscz1bXQpyb29mX2VudGl0aWVzLmVhY2h7fGV8CiAgaWYgZS50eXBlbmFt
ZT09IkZhY2UiCiAgICBlLnJldmVyc2UhIGlmIGUubm9ybWFsLm5vcm1hbGl6
ZS56PT0tMSMjI3NvZmZpdAogICAgc29mZml0PWUgaWYgZS5ub3JtYWwubm9y
bWFsaXplLnouYWJzPT0xCiAgICB2ZXJ0aWNhbHMucHVzaChlKSBpZiBlLm5v
cm1hbC5ub3JtYWxpemUuei5hYnM8MS4wZS0wMDYjIyMgfiA9PTAKICBlbmQj
aWYKfQpzb2ZmaXQucmV2ZXJzZSEKIyMjIG1ha2UgaG9sZSBpbiBiYXNlLi4u
CmlmYWNlPXJvb2ZfZW50aXRpZXMuYWRkX2ZhY2Uob3BvaW50cykKaWZhY2Uu
ZXJhc2UhIGlmIGlmYWNlLnZhbGlkPwojIyMKIyMjIE5PVyB3ZSBleHBsb2Rl
IGFuZCByZWdyb3VwIHRvIGZpeCBjb2luY2lkZW50IGVkZ2UgcHJvYmxlbXMg
ISEhCm9sZF9yb29mX2VudGl0aWVzPXJvb2ZfZW50aXRpZXMudG9fYQpyb29m
X2dyb3VwLmV4cGxvZGUKbmV3X3Jvb2ZfZW50aXRpZXM9W10Kb2xkX3Jvb2Zf
ZW50aXRpZXMuZWFjaHt8ZXxuZXdfcm9vZl9lbnRpdGllcy5wdXNoKGUpaWYg
ZS52YWxpZD99CnJvb2ZfZ3JvdXA9ZW50aXRpZXMuYWRkX2dyb3VwKG5ld19y
b29mX2VudGl0aWVzKQpyb29mX2VudGl0aWVzPXJvb2ZfZ3JvdXAuZW50aXRp
ZXMKIyMjCiMjIyBOT1cgc29ydCBvdXQgZmFjZSBiaXRzIGZvciB0aGVpciBt
YXRlcmlhbHMtLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLQpzb2ZmaXRzPVtd
O3Nsb3Blcz1bXTtmYXNjaWFzPVtdCnJvb2ZfZW50aXRpZXMuZWFjaHt8ZXwK
ICBpZiBlLnR5cGVuYW1lPT0iRmFjZSIKICAgIHNvZmZpdHMucHVzaChlKSBp
ZiBlLm5vcm1hbC5ub3JtYWxpemUueiA8IDAKCSAjIyMgZG93bndhcmRzIHNv
ZmZpdHMKICAgIHNsb3Blcy5wdXNoKGUpIGlmIGUubm9ybWFsLm5vcm1hbGl6
ZS56ID4gMAoJICMjIyB1cHdhcmRzIGJ1dCBub3QgbGlkCiAgICBmYXNjaWFz
LnB1c2goZSkgaWYgZS5ub3JtYWwubm9ybWFsaXplLnogPCAxLjBlMDA2ICYm
IGUubm9ybWFsLm5vcm1hbGl6ZS56ID4gLTEuMGUwMDYKCSAjIyMgZ2FibGVz
ICogZmFzY2lhcyAtIGR1cGxpY2F0ZWQgaW4gb3RoZXJzIFtdIGJ1dCBwcm9j
ZXNzZWQgbGFzdC4uLgogIGVuZCNpZgp9CiMjIyBzb3J0IG91dCBsYXllciwg
bWF0ZXJpYWxzIGV0YyAjIyMtLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLQpkZWYgZGlhbG9nX21hdHMgKCkKIyMjIG1hdGVyaWFscyBkaWFs
b2cgIyMjLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tCiAgbW9kZWw9U2tldGNodXAuYWN0aXZlX21vZGVsCiAgIyMj
IGxheWVycy4uLgogIG1sYXllcnM9bW9kZWwubGF5ZXJzCiAgYWxheWVyPW1v
ZGVsLmFjdGl2ZV9sYXllcgogIG1vZGVsLmFjdGl2ZV9sYXllcj1uaWwKICBk
ZWZsYXllcj1tb2RlbC5hY3RpdmVfbGF5ZXIubmFtZQogIG1vZGVsLmFjdGl2
ZV9sYXllcj1hbGF5ZXIKICBybGF5ZXI9Ii1ST09GIiMjIyBlZGl0IHRoaXMg
dG8gc3VpdCB5b3VyIGRlc2lyZWQgZGVmYXVsdCByb29mIGxheWVyLgogIGxh
eWVycz1bXQogIG1sYXllcnMuZWFjaHt8bGF5ZXJ8bGF5ZXJzLnB1c2gobGF5
ZXIubmFtZSlpZiBsYXllci5uYW1lIT1kZWZsYXllcn0KICBsYXllcnM9W3Js
YXllcixkZWZsYXllcl0rbGF5ZXJzLnNvcnQhCiAgbGF5ZXJzPWxheWVycy51
bmlxLmpvaW4oJ3wnKQogICMjIyBtYXRlcmlhbHMuLi4KICBtYXRfcm9vZj0i
Um9vZiBTdXJmYWNlIgogIG1hdF9mYXNjaWE9IlJvb2YgRmFzY2lhIgogIG1h
dF9zb2ZmaXQ9IlJvb2YgU29mZml0IgogIG1hdGVyaWFscz1tb2RlbC5tYXRl
cmlhbHMKICBtYXRzPVtdCiAgbWF0ZXJpYWxzLmVhY2h7fG1hdHxtYXRzLnB1
c2gobWF0Lm5hbWUpfQogIG1hdHMuc29ydCEKICBsaXN0X21hdF9yb29mPSgo
WyI8RGVmYXVsdD4iXStbbWF0X3Jvb2ZdK21hdHMpLnVuaXEpLmpvaW4oInwi
KQogIGxpc3RfbWF0X2Zhc2NpYT0oKFsiPERlZmF1bHQ+Il0rW21hdF9mYXNj
aWFdK21hdHMpLnVuaXEpLmpvaW4oInwiKQogIGxpc3RfbWF0X3NvZmZpdD0o
KFsiPERlZmF1bHQ+Il0rW21hdF9zb2ZmaXRdK21hdHMpLnVuaXEpLmpvaW4o
InwiKQogICMjIyBzZXQgdXAgdmFyaWFibGVzLi4uCiAgQGxheWVyPXJsYXll
ciBpZiAhIEBsYXllcgogIEBtYXRfcm9vZj1tYXRfcm9vZiBpZiAhIEBtYXRf
cm9vZgogIEBtYXRfZmFzY2lhPW1hdF9mYXNjaWEgaWYgISBAbWF0X2Zhc2Np
YQogIEBtYXRfc29mZml0PW1hdF9zb2ZmaXQgaWYgISBAbWF0X3NvZmZpdAog
IGVudW1zPVtsYXllcnMsbGlzdF9tYXRfcm9vZixsaXN0X21hdF9mYXNjaWEs
bGlzdF9tYXRfc29mZml0XQogIHByb21wdHM9WyJSb29mIExheWVyOiAgIiwi
Um9vZiBTdXJmYWNlOiAgIiwiUm9vZiBGYXNjaWE6ICAiLCJSb29mIFNvZmZp
dDogIl0KICB2YWx1ZXM9W0BsYXllcixAbWF0X3Jvb2YsQG1hdF9mYXNjaWEs
QG1hdF9zb2ZmaXRdCiAgQG90aGVyX3Jlc3VsdHM9KGlucHV0Ym94IHByb21w
dHMsdmFsdWVzLGVudW1zLCJSb29mIExheWVyIGFuZCBNYXRlcmlhbHMiKQog
IEBsYXllcixAbWF0X3Jvb2YsQG1hdF9mYXNjaWEsQG1hdF9zb2ZmaXQ9QG90
aGVyX3Jlc3VsdHMgaWYgQG90aGVyX3Jlc3VsdHMKICBAb3RoZXI9Ik5vIiBp
ZiAhIEBvdGhlcl9yZXN1bHRzCiAgIyMjCmVuZCNkZWYKIyMjIHJ1biBtYXRl
cmlhbCBkaWFsb2cKICBkaWFsb2dfbWF0cygpIGlmIEBvdGhlcj09IlllcyIK
IyMjLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tCiAgI21hdF9yb29mPSJSb29m
IFN1cmZhY2UiCiAgI21hdF9mYXNjaWE9IlJvb2YgRmFzY2lhIgogICNtYXRf
c29mZml0PSJSb29mIFNvZmZpdCIKaWYgQG90aGVyPT0iWWVzIgogICMjIyBu
b3RlIHRoYXQgbGF5ZXIgaXMgc2V0IGFmdGVyIGdyb3VwcyBjb21iaW5lZC4u
LgogIGV4dGc9bmlsO0Btb2RlbC5sYXllcnMuZWFjaHt8bHlyfGV4dGc9bHly
IGlmIGx5ci5uYW1lPT1AbGF5ZXJ9CiAgaWYgQGxheWVyPT0iPERlZmF1bHQ+
IgogICAgbGF5cj1uaWwKICBlbHNlCiAgICBpZiBleHRnCiAgICAgIGxheXI9
ZXh0ZwogICAgZWxzZQogICAgICBsYXlyPUBtb2RlbC5sYXllcnMuYWRkKEBs
YXllcikKICAgIGVuZCNpZgogIGVuZCNpZgogICMjIyBtYXRlcmlhbHMuLi4K
ICAjIyMgZmFzY2lhCiAgZXh0Zz1uaWw7QG1vZGVsLm1hdGVyaWFscy5lYWNo
e3xtYXR8ZXh0Zz1tYXQgaWYgbWF0Lm5hbWU9PUBtYXRfZmFzY2lhfQogIGlm
IEBtYXRfZmFzY2lhPT0iPERlZmF1bHQ+IgogICAgbWF0X2Y9bmlsCiAgZWxz
ZQogICAgaWYgZXh0ZwogICAgICBtYXRfZj1leHRnCiAgICBlbHNlCiAgICAg
IG1hdF9mPUBtb2RlbC5tYXRlcmlhbHMuYWRkKEBtYXRfZmFzY2lhKQogICAg
ICBtYXRfZi5jb2xvcj1bNjYsNjYsNjZdIyMjIGFkanVzdCBkZWZhdWx0IGNv
bG91cnMgaGVyZS4KICAgIGVuZCNpZgogIGVuZCNpZgogIGZhc2NpYXMuZWFj
aHt8ZXxlLm1hdGVyaWFsPW1hdF9mfQogICMjIyBzb2ZmaXQKICBleHRnPW5p
bDtAbW9kZWwubWF0ZXJpYWxzLmVhY2h7fG1hdHxleHRnPW1hdCBpZiBtYXQu
bmFtZT09QG1hdF9zb2ZmaXR9CiAgaWYgQG1hdF9zb2ZmaXQ9PSI8RGVmYXVs
dD4iCiAgICBtYXRfcz1uaWwKICBlbHNlCiAgICBpZiBleHRnCiAgICAgIG1h
dF9zPWV4dGcKICAgIGVsc2UKICAgICAgbWF0X3M9QG1vZGVsLm1hdGVyaWFs
cy5hZGQoQG1hdF9zb2ZmaXQpCiAgICAgIG1hdF9zLmNvbG9yPVsyMjIsMjIy
LDIyMl0jIyMgYWRqdXN0IGRlZmF1bHQgY29sb3VycyBoZXJlLgogICAgZW5k
I2lmCiAgZW5kI2lmCiAgc29mZml0cy5lYWNoe3xlfGUubWF0ZXJpYWw9bWF0
X3N9CiAgIyMjIHJvb2YKICBleHRnPW5pbDtAbW9kZWwubWF0ZXJpYWxzLmVh
Y2h7fG1hdHxleHRnPW1hdCBpZiBtYXQubmFtZT09QG1hdF9yb29mfQogIGlm
IEBtYXRfcm9vZj09IjxEZWZhdWx0PiIKICAgIG1hdF9yPW5pbAogIGVsc2UK
ICAgIGlmIGV4dGcKICAgICAgbWF0X3I9ZXh0ZwogICAgZWxzZQogICAgICBt
YXRfcj1AbW9kZWwubWF0ZXJpYWxzLmFkZChAbWF0X3Jvb2YpCiAgICAgIG1h
dF9yLmNvbG9yPVsxMTEsMTExLDExMV0jIyMgYWRqdXN0IGRlZmF1bHQgY29s
b3VycyBoZXJlLgogICAgZW5kI2lmCiAgZW5kI2lmCiAgc2xvcGVzLmVhY2h7
fGV8ZS5tYXRlcmlhbD1tYXRfcn0KZW5kI2lmCiMjIyB0aWR5IHVwIGF0IGVu
ZCAjIyMtLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLQojIyMgcmVpbnN0YXRlIEBvZWRnZQpAb2VkZ2U9ZW50aXRp
ZXMuYWRkX2xpbmUob2VwcykKQG1vZGVsLnNlbGVjdGlvbi5jbGVhcgpAbW9k
ZWwuc2VsZWN0aW9uLmFkZChvZmFjZSxAb2VkZ2UpCiMjIyBlbmQgd2l0aCBv
cmlnaW5hbCBmYWNlL2VkZ2UgcmUtc2VsZWN0ZWQKQG1vZGVsLmFjdGl2ZV92
aWV3LmludmFsaWRhdGUKQG1vZGVsLmNvbW1pdF9vcGVyYXRpb24KU2tldGNo
dXAuc2VuZF9hY3Rpb24ic2VsZWN0U2VsZWN0aW9uVG9vbDoiCiMjIwplbmQj
ZGVmIHB5cmFtaWQKIyMjLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tCgoKCgoK
IyMjLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tCmRlZiBSb29mOjpnZXRfc2xv
cGUoKQogICMjIyBjaGVjayBmYWNlIC0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0KICBAbW9kZWw9U2tl
dGNodXAuYWN0aXZlX21vZGVsCiAgc3M9QG1vZGVsLnNlbGVjdGlvbgogIGZh
Y2VzPVtdOyBzcy5lYWNoe3xlfGZhY2VzLnB1c2goZSlpZiBlLnR5cGVuYW1l
PT0iRmFjZSJ9CiAgaWYgISBmYWNlcyB8fCBmYWNlc1sxXQogICAgVUkubWVz
c2FnZWJveCgiR2V0IFNsb3BlOlxuXG5Zb3UgbXVzdCBzZWxlY3QgT05FIEZB
Q0UgISIpCiAgICByZXR1cm4gbmlsCiAgZW5kI2lmCiAgZmFjZT1mYWNlc1sw
XQogIG5vcm1hbD1mYWNlLm5vcm1hbC5ub3JtYWxpemUKICB1cD1HZW9tOjpW
ZWN0b3IzZC5uZXcoMCwwLDEpCiAgYW5nbGU9bm9ybWFsLmFuZ2xlX2JldHdl
ZW4odXApIyMjcmFkaWFucwogIGFuZ2xlX2Q9YW5nbGUucmFkaWFucyMjI2Rl
Z3JlZXMKICBhbmdsZV9zPWFuZ2xlX2QudG9fcwogIGE9MTsgYj0xL01hdGg6
OnRhbihhbmdsZSkuYWJzCiAgcmF0aW89YS50b19zKyI6IitiLnRvX3MKICBV
SS5tZXNzYWdlYm94KCJBbmdsZSA9ICIrYW5nbGVfcysiIGRlZ3JlZXNcblNs
b3BlID0gIityYXRpbykKICAjIyMgIAplbmQjZGVmIHNsb3BlCgoKIyMjLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tCmRlZiBSb29mOjpoZWxwCiAgaGVscD1T
a2V0Y2h1cC5maW5kX3N1cHBvcnRfZmlsZSgiUm9vZkhlbHAubWh0IiwiUGx1
Z2lucy8iKSNiaWcgYnV0IHdvcmtzCiAgI2hlbHA9U2tldGNodXAuZmluZF9z
dXBwb3J0X2ZpbGUoIlJvb2ZIZWxwLnBkZiIsIlBsdWdpbnMvIikjbm90IHdv
cmtpbmc/Pz8KICBoZWxwPSJmaWxlOi8vLyIraGVscAogIFVJLm1lc3NhZ2Vi
b3goIioqKkVSUk9SKioqXG5Sb29mIEhlbHAgRmlsZSBOT1QgZm91bmQuIikg
aWYgbm90IFVJLm9wZW5VUkwoaGVscCkKZW5kI2RlZiBoZWxwCiMjIy0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLQoKCiMjIwplbmQjY2xhc3MgUm9vZiMjIyMj
IyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMj
IyMjIyMjIyMKIyMjLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tCgoKIyMjIE1l
bnVzIC0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tCmlzX3RoaXNfZmlsZT1GaWxlLmJhc2Vu
YW1lKF9fRklMRV9fKQppZiBub3QgZmlsZV9sb2FkZWQ/KGlzX3RoaXNfZmls
ZSkKICAjIyNtZW51PSRzdWJtZW51My5hZGRfc3VibWVudSgiUm9vZi4uLiIp
IyMjVElHIG9ubHkgdXNlLi4uCiAgbWVudT1VSS5tZW51KCJQbHVnaW5zIiku
YWRkX3N1Ym1lbnUoIlJvb2YuLi4iKQogIG1lbnUuYWRkX2l0ZW0oIkhpcHBl
ZCBSb29mIFtmcm9tIGEgRmFjZV0iKXtSb29mOjpoaXB9CiAgbWVudS5hZGRf
aXRlbSgiTWFuc2FyZCB8IFNwcm9ja2V0IFJvb2YgW2Zyb20gYSBGYWNlXSIp
e1Jvb2Y6Om1hbnNhcmR9CiAgbWVudS5hZGRfaXRlbSgiR2FibGUtRW5kZWQg
Um9vZiBbZnJvbSBhIFJlY3RhbmdsZStFbmRdIil7Um9vZjo6Z2FibGV9CiAg
bWVudS5hZGRfaXRlbSgiUHlyYW1pZCBSb29mIFtmcm9tIGEgUmVjdGFuZ2xl
K1NpZGVdIil7Um9vZjo6cHlyYW1pZH0KICBtZW51LmFkZF9pdGVtKCJHZXQg
U2xvcGUgW2Zyb20gYSBTZWxlY3RlZCBGYWNlXSIpe1Jvb2Y6OmdldF9zbG9w
ZX0KICBtZW51LmFkZF9pdGVtKCJIZWxwLi4uIil7Um9vZjo6aGVscH0KZW5k
I2lmCmZpbGVfbG9hZGVkKGlzX3RoaXNfZmlsZSkKIyMjLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t
LS0tLS0tLS0tLS0t}.unpack("m").to_s